class UcumUnit {
  UcumUnit(
    this.isBase_,
    this.name_,
    this.csCode_,
    this.ciCode_,
    this.property_,
    this.magnitude_,
    this.dim_dimVec_,
    this.printSymbol_,
    this.class_,
    this.isMetric_,
    this.variable_,
    this.cnv_,
    this.cnvPfx,
    this.isSpecial_,
    this.isArbitrary_,
    this.moleExp_,
    this.synonyms_,
    this.source_,
    this.loincProperty_,
    this.category_,
    this.guidance_,
    this.csUnitString_,
    this.ciUnitString_,
    this.baseFactorStr_,
    this.baseFactor_,
    this.defError_,
  );

  bool isBase_;
  String name_;
  String csCode_;
  String ciCode_;
  String property_;
  double magnitude_;
  List<int> dim_dimVec_;
  String? printSymbol_;
  String? class_;
  bool? isMetric_;
  String? variable_;
  String? cnv_;
  num cnvPfx;
  bool isSpecial_;
  bool isArbitrary_;
  int moleExp_;
  List<String>? synonyms_;
  String source_;
  String? loincProperty_;
  String? category_;
  String? guidance_;
  String? csUnitString_;
  String? ciUnitString_;
  String? baseFactorStr_;
  double? baseFactor_;
  bool defError_;
}

final unitsData = [
  UcumUnit(
    true,
    "meter",
    "m",
    "M",
    "length",
    1,
    [1, 0, 0, 0, 0, 0, 0],
    "m",
    null,
    false,
    "L",
    null,
    1,
    false,
    false,
    0,
    "meters; metres; distance".split('; '),
    "UCUM",
    "Len",
    "Clinical",
    "unit of length = 1.09361 yards",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "second - time",
    "s",
    "S",
    "time",
    1,
    [0, 1, 0, 0, 0, 0, 0],
    "s",
    null,
    false,
    "T",
    null,
    1,
    false,
    false,
    0,
    ["seconds"],
    "UCUM",
    "Time",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram",
    "g",
    "G",
    "mass",
    1,
    [0, 0, 1, 0, 0, 0, 0],
    "g",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "grams; gm".split('; '),
    "UCUM",
    "Mass",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "radian",
    "rad",
    "RAD",
    "plane angle",
    1,
    [0, 0, 0, 1, 0, 0, 0],
    "rad",
    null,
    false,
    "A",
    null,
    1,
    false,
    false,
    0,
    [
      "radians",
    ],
    "UCUM",
    "Angle",
    "Clinical",
    "unit of angular measure where 1 radian = 1/2π turn =  57.296 degrees. ",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "degree Kelvin",
    "K",
    "K",
    "temperature",
    1,
    [0, 0, 0, 0, 1, 0, 0],
    "K",
    null,
    false,
    "C",
    null,
    1,
    false,
    false,
    0,
    "Kelvin; degrees".split('; '),
    "UCUM",
    "Temp",
    "Clinical",
    "absolute, thermodynamic temperature scale ",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "coulomb",
    "C",
    "C",
    "electric charge",
    1,
    [0, 0, 0, 0, 0, 1, 0],
    "C",
    null,
    false,
    "Q",
    null,
    1,
    false,
    false,
    0,
    [
      "coulombs",
    ],
    "UCUM",
    "",
    "Clinical",
    "defined as amount of 1 electron charge = 6.2415093×10^18 e, and equivalent to 1 Ampere-second",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "candela",
    "cd",
    "CD",
    "luminous intensity",
    1,
    [0, 0, 0, 0, 0, 0, 1],
    "cd",
    null,
    false,
    "F",
    null,
    1,
    false,
    false,
    0,
    [
      "candelas",
    ],
    "UCUM",
    "",
    "Clinical",
    "SI base unit of luminous intensity",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "the number ten for arbitrary powers",
    "10*",
    "10*",
    "number",
    10,
    [0, 0, 0, 0, 0, 0, 0],
    "10",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "10^; 10 to the arbitrary powers".split('; '),
    "UCUM",
    "Num",
    "Clinical",
    "10* by itself is the same as 10, but users can add digits after the *. For example, 10*3 = 1000.",
    "1",
    "1",
    "10",
    10,
    false,
  ),
  UcumUnit(
    false,
    "the number ten for arbitrary powers",
    "10^",
    "10^",
    "number",
    10,
    [0, 0, 0, 0, 0, 0, 0],
    "10",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "10*; 10 to the arbitrary power".split('; '),
    "UCUM",
    "Num",
    "Clinical",
    "10* by itself is the same as 10, but users can add digits after the *. For example, 10*3 = 1000.",
    "1",
    "1",
    "10",
    10,
    false,
  ),
  UcumUnit(
    false,
    "the number pi",
    "[pi]",
    "[PI]",
    "number",
    3.141592653589793,
    [0, 0, 0, 0, 0, 0, 0],
    "π",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    ["π"],
    "UCUM",
    "",
    "Constant",
    "a mathematical constant; the ratio of a circle's circumference to its diameter ≈ 3.14159",
    "1",
    "1",
    "3.1415926535897932384626433832795028841971693993751058209749445923",
    3.141592653589793,
    false,
  ),
  UcumUnit(
    false,
    "",
    "%",
    "%",
    "fraction",
    0.01,
    [0, 0, 0, 0, 0, 0, 0],
    "%",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    ["percents"],
    "UCUM",
    "FR; NFR; MFR; CFR; SFR Rto; etc. ",
    "Clinical",
    "",
    "10*-2",
    "10*-2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "parts per thousand",
    "[ppth]",
    "[PPTH]",
    "fraction",
    0.001,
    [0, 0, 0, 0, 0, 0, 0],
    "ppth",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "ppth; 10^-3".split('; '),
    "UCUM",
    "MCnc; MCnt",
    "Clinical",
    "[ppth] is often used in solution concentrations as 1 g/L or 1 g/kg.\n\nCan be ambigous and would be better if the metric units was used directly. ",
    "10*-3",
    "10*-3",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "parts per million",
    "[ppm]",
    "[PPM]",
    "fraction",
    1e-6,
    [0, 0, 0, 0, 0, 0, 0],
    "ppm",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "ppm; 10^-6".split('; '),
    "UCUM",
    "MCnt; MCnc; SFr",
    "Clinical",
    "[ppm] is often used in solution concentrations as 1 mg/L  or 1 mg/kg. Also used to express mole fractions as 1 mmol/mol.\n\n[ppm] is also used in nuclear magnetic resonance (NMR) to represent chemical shift - the difference of a measured frequency in parts per million from the reference frequency.\n\nCan be ambigous and would be better if the metric units was used directly. ",
    "10*-6",
    "10*-6",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "parts per billion",
    "[ppb]",
    "[PPB]",
    "fraction",
    1e-9,
    [0, 0, 0, 0, 0, 0, 0],
    "ppb",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "ppb; 10^-9".split('; '),
    "UCUM",
    "MCnt; MCnc; SFr",
    "Clinical",
    "[ppb] is often used in solution concentrations as 1 ug/L  or 1 ug/kg. Also used to express mole fractions as 1 umol/mol.\n\nCan be ambigous and would be better if the metric units was used directly. ",
    "10*-9",
    "10*-9",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "parts per trillion",
    "[pptr]",
    "[PPTR]",
    "fraction",
    1e-12,
    [0, 0, 0, 0, 0, 0, 0],
    "pptr",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "pptr; 10^-12".split('; '),
    "UCUM",
    "MCnt; MCnc; SFr",
    "Clinical",
    "[pptr] is often used in solution concentrations as 1 ng/L or 1 ng/kg. Also used to express mole fractions as 1 nmol/mol.\n\nCan be ambigous and would be better if the metric units was used directly. ",
    "10*-12",
    "10*-12",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "mole",
    "mol",
    "MOL",
    "amount of substance",
    6.0221367e23,
    [0, 0, 0, 0, 0, 0, 0],
    "mol",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    ["moles"],
    "UCUM",
    "Sub",
    "Clinical",
    "Measure the number of molecules ",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "steradian - solid angle",
    "sr",
    "SR",
    "solid angle",
    1,
    [0, 0, 0, 2, 0, 0, 0],
    "sr",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "square radian; rad2; rad^2".split('; '),
    "UCUM",
    "Angle",
    "Clinical",
    "unit of solid angle in three-dimensional geometry analagous to radian; used in photometry which measures the perceived brightness of object by human eye (e.g. radiant intensity = watt/steradian)",
    "rad2",
    "RAD2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "hertz",
    "Hz",
    "HZ",
    "frequency",
    1,
    [0, -1, 0, 0, 0, 0, 0],
    "Hz",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "Herz; frequency; frequencies".split('; '),
    "UCUM",
    "Freq; Num",
    "Clinical",
    "equal to one cycle per second",
    "s-1",
    "S-1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "newton",
    "N",
    "N",
    "force",
    1e3,
    [1, -2, 1, 0, 0, 0, 0],
    "N",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "Newtons",
    ],
    "UCUM",
    "Force",
    "Clinical",
    "unit of force with base units kg.m/s2",
    "kg.m/s2",
    "KG.M/S2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "pascal",
    "Pa",
    "PAL",
    "pressure",
    1e3,
    [-1, -2, 1, 0, 0, 0, 0],
    "Pa",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    ["pascals"],
    "UCUM",
    "Pres",
    "Clinical",
    "standard unit of pressure equal to 1 newton per square meter (N/m2)",
    "N/m2",
    "N/M2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "joule",
    "J",
    "J",
    "energy",
    1e3,
    [2, -2, 1, 0, 0, 0, 0],
    "J",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "joules",
    ],
    "UCUM",
    "Enrg",
    "Clinical",
    "unit of energy defined as the work required to move an object 1 m with a force of 1 N (N.m) or an electric charge of 1 C through 1 V (C.V), or to produce 1 W for 1 s (W.s) ",
    "N.m",
    "N.M",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "watt",
    "W",
    "W",
    "power",
    1e3,
    [2, -3, 1, 0, 0, 0, 0],
    "W",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "watts",
    ],
    "UCUM",
    "EngRat",
    "Clinical",
    "unit of power equal to 1 Joule per second (J/s) =  kg⋅m2⋅s−3",
    "J/s",
    "J/S",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Ampere",
    "A",
    "A",
    "electric current",
    1,
    [0, -1, 0, 0, 0, 1, 0],
    "A",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "Amperes",
    ],
    "UCUM",
    "ElpotRat",
    "Clinical",
    "unit of electric current equal to flow rate of electrons equal to 16.2415×10^18 elementary charges moving past a boundary in one second or 1 Coulomb/second",
    "C/s",
    "C/S",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "volt",
    "V",
    "V",
    "electric potential",
    1e3,
    [2, -2, 1, 0, 0, -1, 0],
    "V",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    ["volts"],
    "UCUM",
    "Elpot",
    "Clinical",
    "unit of electric potential (voltage) = 1 Joule per Coulomb (J/C)",
    "J/C",
    "J/C",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "farad",
    "F",
    "F",
    "electric capacitance",
    0.001,
    [-2, 2, -1, 0, 0, 2, 0],
    "F",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "farads; electric capacitance".split('; '),
    "UCUM",
    "",
    "Clinical",
    "CGS unit of electric capacitance with base units C/V (Coulomb per Volt)",
    "C/V",
    "C/V",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "ohm",
    "Ohm",
    "OHM",
    "electric resistance",
    1e3,
    [2, -1, 1, 0, 0, -2, 0],
    "Ω",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "Ω; resistance; ohms".split('; '),
    "UCUM",
    "",
    "Clinical",
    "unit of electrical resistance with units of Volt per Ampere",
    "V/A",
    "V/A",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "siemens",
    "S",
    "SIE",
    "electric conductance",
    0.001,
    [-2, 1, -1, 0, 0, 2, 0],
    "S",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "Reciprocal ohm; mho; Ω−1; conductance".split('; '),
    "UCUM",
    "",
    "Clinical",
    "unit of electric conductance (the inverse of electrical resistance) equal to ohm^-1",
    "Ohm-1",
    "OHM-1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "weber",
    "Wb",
    "WB",
    "magnetic flux",
    1e3,
    [2, -1, 1, 0, 0, -1, 0],
    "Wb",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "magnetic flux; webers".split('; '),
    "UCUM",
    "",
    "Clinical",
    "unit of magnetic flux equal to Volt second",
    "V.s",
    "V.S",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "degree Celsius",
    "Cel",
    "CEL",
    "temperature",
    1,
    [0, 0, 0, 0, 1, 0, 0],
    "°C",
    "si",
    true,
    null,
    "Cel",
    1,
    true,
    false,
    0,
    "°C; degrees".split('; '),
    "UCUM",
    "Temp",
    "Clinical",
    "",
    "K",
    null,
    null,
    1,
    false,
  ),
  UcumUnit(
    false,
    "tesla",
    "T",
    "T",
    "magnetic flux density",
    1e3,
    [0, -1, 1, 0, 0, -1, 0],
    "T",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "Teslas; magnetic field".split('; '),
    "UCUM",
    "",
    "Clinical",
    "SI unit of magnetic field strength for magnetic field B equal to 1 Weber/square meter =  1 kg/(s2*A)",
    "Wb/m2",
    "WB/M2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "henry",
    "H",
    "H",
    "inductance",
    1e3,
    [2, 0, 1, 0, 0, -2, 0],
    "H",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "henries; inductance".split('; '),
    "UCUM",
    "",
    "Clinical",
    "unit of electrical inductance; usually expressed in millihenrys (mH) or microhenrys (uH).",
    "Wb/A",
    "WB/A",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "lumen",
    "lm",
    "LM",
    "luminous flux",
    1,
    [0, 0, 0, 2, 0, 0, 1],
    "lm",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "luminous flux; lumens".split('; '),
    "UCUM",
    "",
    "Clinical",
    "unit of luminous flux defined as 1 lm = 1 cd⋅sr (candela times sphere)",
    "cd.sr",
    "CD.SR",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "lux",
    "lx",
    "LX",
    "illuminance",
    1,
    [-2, 0, 0, 2, 0, 0, 1],
    "lx",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "illuminance; luxes".split('; '),
    "UCUM",
    "",
    "Clinical",
    "unit of illuminance equal to one lumen per square meter. ",
    "lm/m2",
    "LM/M2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "becquerel",
    "Bq",
    "BQ",
    "radioactivity",
    1,
    [0, -1, 0, 0, 0, 0, 0],
    "Bq",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "activity; radiation; becquerels".split('; '),
    "UCUM",
    "",
    "Clinical",
    "measure of the atomic radiation rate with units s^-1",
    "s-1",
    "S-1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "gray",
    "Gy",
    "GY",
    "energy dose",
    1,
    [2, -2, 0, 0, 0, 0, 0],
    "Gy",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "absorbed doses; ionizing radiation doses; kerma; grays".split('; '),
    "UCUM",
    "EngCnt",
    "Clinical",
    "unit of ionizing radiation dose with base units of 1 joule of radiation energy per kilogram of matter",
    "J/kg",
    "J/KG",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "sievert",
    "Sv",
    "SV",
    "dose equivalent",
    1,
    [2, -2, 0, 0, 0, 0, 0],
    "Sv",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "sieverts; radiation dose quantities; equivalent doses; effective dose; operational dose; committed dose"
        .split('; '),
    "UCUM",
    "",
    "Clinical",
    "SI unit for radiation dose equivalent equal to 1 Joule/kilogram.",
    "J/kg",
    "J/KG",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "degree - plane angle",
    "deg",
    "DEG",
    "plane angle",
    0.017453292519943295,
    [0, 0, 0, 1, 0, 0, 0],
    "°",
    "iso1000",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "°; degree of arc; arc degree; arcdegree; angle".split('; '),
    "UCUM",
    "Angle",
    "Clinical",
    "one degree is equivalent to π/180 radians.",
    "[pi].rad/360",
    "[PI].RAD/360",
    "2",
    2,
    false,
  ),
  UcumUnit(
    false,
    "gon",
    "gon",
    "GON",
    "plane angle",
    0.015707963267948967,
    [0, 0, 0, 1, 0, 0, 0],
    "□<sup>g</sup>",
    "iso1000",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "gon (grade); gons".split('; '),
    "UCUM",
    "Angle",
    "Nonclinical",
    "unit of plane angle measurement equal to 1/400 circle",
    "deg",
    "DEG",
    "0.9",
    0.9,
    false,
  ),
  UcumUnit(
    false,
    "arc minute",
    "'",
    "'",
    "plane angle",
    0.0002908882086657216,
    [0, 0, 0, 1, 0, 0, 0],
    "'",
    "iso1000",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "arcminutes; arcmin; arc minutes; arc mins".split('; '),
    "UCUM",
    "Angle",
    "Clinical",
    "equal to 1/60 degree; used in optometry and opthamology (e.g. visual acuity tests)",
    "deg/60",
    "DEG/60",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "arc second",
    "''",
    "''",
    "plane angle",
    484813681109536e-20,
    [0, 0, 0, 1, 0, 0, 0],
    "''",
    "iso1000",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "arcseconds; arcsecs".split('; '),
    "UCUM",
    "Angle",
    "Clinical",
    "equal to 1/60 arcminute = 1/3600 degree; used in optometry and opthamology (e.g. visual acuity tests)",
    "'/60",
    "'/60",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Liters",
    "l",
    "L",
    "volume",
    0.001,
    [3, 0, 0, 0, 0, 0, 0],
    "l",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "cubic decimeters; decimeters cubed; decimetres; dm3; dm^3; litres; liters, LT "
        .split('; '),
    "UCUM",
    "Vol",
    "Clinical",
    'Because lower case "l" can be read as the number "1", though this is a valid UCUM units. UCUM strongly reccomends using  "L"',
    "dm3",
    "DM3",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Liters",
    "L",
    "L",
    "volume",
    0.001,
    [3, 0, 0, 0, 0, 0, 0],
    "L",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "cubic decimeters; decimeters cubed; decimetres; dm3; dm^3; litres; liters, LT "
        .split('; '),
    "UCUM",
    "Vol",
    "Clinical",
    'Because lower case "l" can be read as the number "1", though this is a valid UCUM units. UCUM strongly reccomends using  "L"',
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "are",
    "ar",
    "AR",
    "area",
    100,
    [2, 0, 0, 0, 0, 0, 0],
    "a",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "100 m2; 100 m^2; 100 square meter; meters squared; metres".split('; '),
    "UCUM",
    "Area",
    "Clinical",
    "metric base unit for area defined as 100 m^2",
    "m2",
    "M2",
    "100",
    100,
    false,
  ),
  UcumUnit(
    false,
    "minute",
    "min",
    "MIN",
    "time",
    60,
    [0, 1, 0, 0, 0, 0, 0],
    "min",
    "iso1000",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "minutes",
    ],
    "UCUM",
    "Time",
    "Clinical",
    "",
    "s",
    "S",
    "60",
    60,
    false,
  ),
  UcumUnit(
    false,
    "hour",
    "h",
    "HR",
    "time",
    3600,
    [0, 1, 0, 0, 0, 0, 0],
    "h",
    "iso1000",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "hours; hrs; age".split('; '),
    "UCUM",
    "Time",
    "Clinical",
    "",
    "min",
    "MIN",
    "60",
    60,
    false,
  ),
  UcumUnit(
    false,
    "day",
    "d",
    "D",
    "time",
    86400,
    [0, 1, 0, 0, 0, 0, 0],
    "d",
    "iso1000",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "days; age; dy; 24 hours; 24 hrs".split('; '),
    "UCUM",
    "Time",
    "Clinical",
    "",
    "h",
    "HR",
    "24",
    24,
    false,
  ),
  UcumUnit(
    false,
    "tropical year",
    "a_t",
    "ANN_T",
    "time",
    31556925.216,
    [0, 1, 0, 0, 0, 0, 0],
    "a<sub>t</sub>",
    "iso1000",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "solar years; a tropical; years".split('; '),
    "UCUM",
    "Time",
    "Clinical",
    "has an average of 365.242181 days but is constantly changing.",
    "d",
    "D",
    "365.24219",
    365.24219,
    false,
  ),
  UcumUnit(
    false,
    "mean Julian year",
    "a_j",
    "ANN_J",
    "time",
    31557600,
    [0, 1, 0, 0, 0, 0, 0],
    "a<sub>j</sub>",
    "iso1000",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "mean Julian yr; a julian; years".split('; '),
    "UCUM",
    "Time",
    "Clinical",
    "has an average of 365.25 days, and in everyday use, has been replaced by the Gregorian year. However, this unit is used in astronomy to calculate light year. ",
    "d",
    "D",
    "365.25",
    365.25,
    false,
  ),
  UcumUnit(
    false,
    "mean Gregorian year",
    "a_g",
    "ANN_G",
    "time",
    31556952,
    [0, 1, 0, 0, 0, 0, 0],
    "a<sub>g</sub>",
    "iso1000",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "mean Gregorian yr; a gregorian; years".split('; '),
    "UCUM",
    "Time",
    "Clinical",
    "has an average of 365.2425 days and is the most internationally used civil calendar.",
    "d",
    "D",
    "365.2425",
    365.2425,
    false,
  ),
  UcumUnit(
    false,
    "year",
    "a",
    "ANN",
    "time",
    31557600,
    [0, 1, 0, 0, 0, 0, 0],
    "a",
    "iso1000",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "years; a; yr, yrs; annum".split('; '),
    "UCUM",
    "Time",
    "Clinical",
    "",
    "a_j",
    "ANN_J",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "week",
    "wk",
    "WK",
    "time",
    604800,
    [0, 1, 0, 0, 0, 0, 0],
    "wk",
    "iso1000",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "weeks; wks".split('; '),
    "UCUM",
    "Time",
    "Clinical",
    "",
    "d",
    "D",
    "7",
    7,
    false,
  ),
  UcumUnit(
    false,
    "synodal month",
    "mo_s",
    "MO_S",
    "time",
    2551442.976,
    [0, 1, 0, 0, 0, 0, 0],
    "mo<sub>s</sub>",
    "iso1000",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "Moon; synodic month; lunar month; mo-s; mo s; months; moons".split('; '),
    "UCUM",
    "Time",
    "Nonclinical",
    "has an average of 29.53 days per month, unit used in astronomy",
    "d",
    "D",
    "29.53059",
    29.53059,
    false,
  ),
  UcumUnit(
    false,
    "mean Julian month",
    "mo_j",
    "MO_J",
    "time",
    2629800,
    [0, 1, 0, 0, 0, 0, 0],
    "mo<sub>j</sub>",
    "iso1000",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "mo-julian; mo Julian; months".split('; '),
    "UCUM",
    "Time",
    "Clinical",
    "has an average of 30.435 days per month",
    "a_j/12",
    "ANN_J/12",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "mean Gregorian month",
    "mo_g",
    "MO_G",
    "time",
    2629746,
    [0, 1, 0, 0, 0, 0, 0],
    "mo<sub>g</sub>",
    "iso1000",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "months; month-gregorian; mo-gregorian".split('; '),
    "UCUM",
    "Time",
    "Clinical",
    "has an average 30.436875 days per month and is from the most internationally used civil calendar.",
    "a_g/12",
    "ANN_G/12",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "month",
    "mo",
    "MO",
    "time",
    2629800,
    [0, 1, 0, 0, 0, 0, 0],
    "mo",
    "iso1000",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "months; duration".split('; '),
    "UCUM",
    "Time",
    "Clinical",
    "based on Julian calendar which has an average of 30.435 days per month (this unit is used in astronomy but not in everyday life - see mo_g)",
    "mo_j",
    "MO_J",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "metric ton",
    "t",
    "TNE",
    "mass",
    1e6,
    [0, 0, 1, 0, 0, 0, 0],
    "t",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "tonnes; megagrams; tons".split('; '),
    "UCUM",
    "Mass",
    "Nonclinical",
    "equal to 1000 kg used in the US (recognized by NIST as metric ton), and internationally (recognized as tonne)",
    "kg",
    "KG",
    "1e3",
    1e3,
    false,
  ),
  UcumUnit(
    false,
    "bar",
    "bar",
    "BAR",
    "pressure",
    1e8,
    [-1, -2, 1, 0, 0, 0, 0],
    "bar",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "bars",
    ],
    "UCUM",
    "Pres",
    "Nonclinical",
    "unit of pressure equal to 10^5 Pascals, primarily used by meteorologists and in weather forecasting",
    "Pa",
    "PAL",
    "1e5",
    1e5,
    false,
  ),
  UcumUnit(
    false,
    "unified atomic mass unit",
    "u",
    "AMU",
    "mass",
    1.6605402e-24,
    [0, 0, 1, 0, 0, 0, 0],
    "u",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "unified atomic mass units; amu; Dalton; Da".split('; '),
    "UCUM",
    "Mass",
    "Clinical",
    "the mass of 1/12 of an unbound Carbon-12 atom nuclide equal to 1.6606x10^-27 kg ",
    "g",
    "G",
    "1.6605402e-24",
    1.6605402e-24,
    false,
  ),
  UcumUnit(
    false,
    "astronomic unit",
    "AU",
    "ASU",
    "length",
    149597870691,
    [1, 0, 0, 0, 0, 0, 0],
    "AU",
    "iso1000",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "AU; units".split('; '),
    "UCUM",
    "Len",
    "Clinical",
    "unit of length used in astronomy for measuring distance in Solar system",
    "Mm",
    "MAM",
    "149597.870691",
    149597.870691,
    false,
  ),
  UcumUnit(
    false,
    "parsec",
    "pc",
    "PRS",
    "length",
    3085678e10,
    [1, 0, 0, 0, 0, 0, 0],
    "pc",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "parsecs",
    ],
    "UCUM",
    "Len",
    "Clinical",
    "unit of length equal to 3.26 light years, nad used to measure large distances to objects outside our Solar System",
    "m",
    "M",
    "3.085678e16",
    3085678e10,
    false,
  ),
  UcumUnit(
    false,
    "velocity of light in a vacuum",
    "[c]",
    "[C]",
    "velocity",
    299792458,
    [1, -1, 0, 0, 0, 0, 0],
    "<i>c</i>",
    "const",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "speed of light",
    ],
    "UCUM",
    "Vel",
    "Constant",
    "equal to 299792458 m/s (approximately 3 x 10^8 m/s)",
    "m/s",
    "M/S",
    "299792458",
    299792458,
    false,
  ),
  UcumUnit(
    false,
    "Planck constant",
    "[h]",
    "[H]",
    "action",
    6.6260755e-31,
    [2, -1, 1, 0, 0, 0, 0],
    "<i>h</i>",
    "const",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "Planck's constant",
    ],
    "UCUM",
    "",
    "Constant",
    "constant = 6.62607004 × 10-34 m2.kg/s; defined as quantum of action",
    "J.s",
    "J.S",
    "6.6260755e-34",
    6.6260755e-34,
    false,
  ),
  UcumUnit(
    false,
    "Boltzmann constant",
    "[k]",
    "[K]",
    "(unclassified)",
    1.380658e-20,
    [2, -2, 1, 0, -1, 0, 0],
    "<i>k</i>",
    "const",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "k; kB".split('; '),
    "UCUM",
    "",
    "Constant",
    "physical constant relating energy at the individual particle level with temperature = 1.38064852 ×10^−23 J/K",
    "J/K",
    "J/K",
    "1.380658e-23",
    1.380658e-23,
    false,
  ),
  UcumUnit(
    false,
    "permittivity of vacuum - electric",
    "[eps_0]",
    "[EPS_0]",
    "electric permittivity",
    8.854187817000001e-15,
    [-3, 2, -1, 0, 0, 2, 0],
    "<i>ε<sub><r>0</r></sub></i>",
    "const",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "ε0; Electric Constant; vacuum permittivity; permittivity of free space "
        .split('; '),
    "UCUM",
    "",
    "Constant",
    "approximately equal to 8.854 × 10^−12 F/m (farads per meter)",
    "F/m",
    "F/M",
    "8.854187817e-12",
    8.854187817e-12,
    false,
  ),
  UcumUnit(
    false,
    "permeability of vacuum - magnetic",
    "[mu_0]",
    "[MU_0]",
    "magnetic permeability",
    0.0012566370614359172,
    [1, 0, 1, 0, 0, -2, 0],
    "<i>μ<sub><r>0</r></sub></i>",
    "const",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "μ0; vacuum permeability; permeability of free space; magnetic constant"
        .split('; '),
    "UCUM",
    "",
    "Constant",
    "equal to 4π×10^−7 N/A2 (Newtons per square ampere) ≈ 1.2566×10^−6 H/m (Henry per meter)",
    "N/A2",
    "4.[PI].10*-7.N/A2",
    "1",
    12566370614359173e-22,
    false,
  ),
  UcumUnit(
    false,
    "elementary charge",
    "[e]",
    "[E]",
    "electric charge",
    1.60217733e-19,
    [0, 0, 0, 0, 0, 1, 0],
    "<i>e</i>",
    "const",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "e; q; electric charges".split('; '),
    "UCUM",
    "",
    "Constant",
    "the magnitude of the electric charge carried by a single electron or proton ≈ 1.60217×10^-19 Coulombs",
    "C",
    "C",
    "1.60217733e-19",
    1.60217733e-19,
    false,
  ),
  UcumUnit(
    false,
    "electronvolt",
    "eV",
    "EV",
    "energy",
    1.60217733e-16,
    [2, -2, 1, 0, 0, 0, 0],
    "eV",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "Electron Volts; electronvolts".split('; '),
    "UCUM",
    "Eng",
    "Clinical",
    "unit of kinetic energy = 1 V * 1.602×10^−19 C = 1.6×10−19 Joules",
    "[e].V",
    "[E].V",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "electron mass",
    "[m_e]",
    "[M_E]",
    "mass",
    9.1093897e-28,
    [0, 0, 1, 0, 0, 0, 0],
    "<i>m<sub><r>e</r></sub></i>",
    "const",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "electron rest mass; me".split('; '),
    "UCUM",
    "Mass",
    "Constant",
    "approximately equal to 9.10938356 × 10-31 kg; defined as the mass of a stationary electron",
    "g",
    "g",
    "9.1093897e-28",
    9.1093897e-28,
    false,
  ),
  UcumUnit(
    false,
    "proton mass",
    "[m_p]",
    "[M_P]",
    "mass",
    1.6726231e-24,
    [0, 0, 1, 0, 0, 0, 0],
    "<i>m<sub><r>p</r></sub></i>",
    "const",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mp; masses".split('; '),
    "UCUM",
    "Mass",
    "Constant",
    "approximately equal to 1.672622×10−27 kg",
    "g",
    "g",
    "1.6726231e-24",
    1.6726231e-24,
    false,
  ),
  UcumUnit(
    false,
    "Newtonian constant of gravitation",
    "[G]",
    "[GC]",
    "(unclassified)",
    6.67259e-14,
    [3, -2, -1, 0, 0, 0, 0],
    "<i>G</i>",
    "const",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "G; gravitational constant; Newton's constant".split('; '),
    "UCUM",
    "",
    "Constant",
    "gravitational constant = 6.674×10−11 N⋅m2/kg2",
    "m3.kg-1.s-2",
    "M3.KG-1.S-2",
    "6.67259e-11",
    6.67259e-11,
    false,
  ),
  UcumUnit(
    false,
    "standard acceleration of free fall",
    "[g]",
    "[G]",
    "acceleration",
    9.80665,
    [1, -2, 0, 0, 0, 0, 0],
    "<i>g<sub>n</sub></i>",
    "const",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "standard gravity; g; ɡ0; ɡn".split('; '),
    "UCUM",
    "Accel",
    "Constant",
    "defined by standard = 9.80665 m/s2",
    "m/s2",
    "M/S2",
    "980665e-5",
    9.80665,
    false,
  ),
  UcumUnit(
    false,
    "Torr",
    "Torr",
    "Torr",
    "pressure",
    133322,
    [-1, -2, 1, 0, 0, 0, 0],
    "Torr",
    "const",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    ["torrs"],
    "UCUM",
    "Pres",
    "Clinical",
    "1 torr = 1 mmHg; unit used to measure blood pressure",
    "Pa",
    "PAL",
    "133.322",
    133.322,
    false,
  ),
  UcumUnit(
    false,
    "standard atmosphere",
    "atm",
    "ATM",
    "pressure",
    101325e3,
    [-1, -2, 1, 0, 0, 0, 0],
    "atm",
    "const",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "reference pressure; atmos; std atmosphere".split('; '),
    "UCUM",
    "Pres",
    "Clinical",
    "defined as being precisely equal to 101,325 Pa",
    "Pa",
    "PAL",
    "101325",
    101325,
    false,
  ),
  UcumUnit(
    false,
    "light-year",
    "[ly]",
    "[LY]",
    "length",
    9460730472580800,
    [1, 0, 0, 0, 0, 0, 0],
    "l.y.",
    "const",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "light years; ly".split('; '),
    "UCUM",
    "Len",
    "Constant",
    "unit of astronomal distance = 5.88×10^12 mi",
    "[c].a_j",
    "[C].ANN_J",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "gram-force",
    "gf",
    "GF",
    "force",
    9.80665,
    [1, -2, 1, 0, 0, 0, 0],
    "gf",
    "const",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "Newtons; gram forces".split('; '),
    "UCUM",
    "Force",
    "Clinical",
    "May be specific to unit related to cardiac output",
    "g.[g]",
    "G.[G]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Kayser",
    "Ky",
    "KY",
    "lineic number",
    100,
    [-1, 0, 0, 0, 0, 0, 0],
    "K",
    "cgs",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "wavenumbers; kaysers".split('; '),
    "UCUM",
    "InvLen",
    "Clinical",
    "unit of wavelength equal to cm^-1",
    "cm-1",
    "CM-1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Gal",
    "Gal",
    "GL",
    "acceleration",
    0.01,
    [1, -2, 0, 0, 0, 0, 0],
    "Gal",
    "cgs",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "galileos; Gals".split('; '),
    "UCUM",
    "Accel",
    "Clinical",
    "unit of acceleration used in gravimetry; equivalent to cm/s2 ",
    "cm/s2",
    "CM/S2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "dyne",
    "dyn",
    "DYN",
    "force",
    0.01,
    [1, -2, 1, 0, 0, 0, 0],
    "dyn",
    "cgs",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "dynes",
    ],
    "UCUM",
    "Force",
    "Clinical",
    "unit of force equal to 10^-5 Newtons",
    "g.cm/s2",
    "G.CM/S2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "erg",
    "erg",
    "ERG",
    "energy",
    1e-4,
    [2, -2, 1, 0, 0, 0, 0],
    "erg",
    "cgs",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "10^-7 Joules, 10-7 Joules; 100 nJ; 100 nanoJoules; 1 dyne cm; 1 g.cm2/s2"
        .split('; '),
    "UCUM",
    "Eng",
    "Clinical",
    "unit of energy = 1 dyne centimeter = 10^-7 Joules",
    "dyn.cm",
    "DYN.CM",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Poise",
    "P",
    "P",
    "dynamic viscosity",
    100,
    [-1, -1, 1, 0, 0, 0, 0],
    "P",
    "cgs",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "dynamic viscosity; poises".split('; '),
    "UCUM",
    "Visc",
    "Clinical",
    "unit of dynamic viscosity where 1 Poise = 1/10 Pascal second",
    "dyn.s/cm2",
    "DYN.S/CM2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Biot",
    "Bi",
    "BI",
    "electric current",
    10,
    [0, -1, 0, 0, 0, 1, 0],
    "Bi",
    "cgs",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "Bi; abamperes; abA".split('; '),
    "UCUM",
    "ElpotRat",
    "Clinical",
    "equal to 10 amperes",
    "A",
    "A",
    "10",
    10,
    false,
  ),
  UcumUnit(
    false,
    "Stokes",
    "St",
    "ST",
    "kinematic viscosity",
    1e-4,
    [2, -1, 0, 0, 0, 0, 0],
    "St",
    "cgs",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "kinematic viscosity",
    ],
    "UCUM",
    "Visc",
    "Clinical",
    "unit of kimematic viscosity with units cm2/s",
    "cm2/s",
    "CM2/S",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Maxwell",
    "Mx",
    "MX",
    "flux of magnetic induction",
    1e-5,
    [2, -1, 1, 0, 0, -1, 0],
    "Mx",
    "cgs",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "magnetix flux; Maxwells".split('; '),
    "UCUM",
    "",
    "Clinical",
    "unit of magnetic flux",
    "Wb",
    "WB",
    "1e-8",
    1e-8,
    false,
  ),
  UcumUnit(
    false,
    "Gauss",
    "G",
    "GS",
    "magnetic flux density",
    0.1,
    [0, -1, 1, 0, 0, -1, 0],
    "Gs",
    "cgs",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "magnetic fields; magnetic flux density; induction; B".split('; '),
    "UCUM",
    "magnetic",
    "Clinical",
    "CGS unit of magnetic flux density, known as magnetic field B; defined as one maxwell unit per square centimeter (see Oersted for CGS unit for H field)",
    "T",
    "T",
    "1e-4",
    1e-4,
    false,
  ),
  UcumUnit(
    false,
    "Oersted",
    "Oe",
    "OE",
    "magnetic field intensity",
    79.57747154594767,
    [-1, -1, 0, 0, 0, 1, 0],
    "Oe",
    "cgs",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "H magnetic B field; Oersteds".split('; '),
    "UCUM",
    "",
    "Clinical",
    "CGS unit of the auxiliary magnetic field H defined as 1 dyne per unit pole = 1000/4π amperes per meter (see Gauss for CGS unit for B field)",
    "A/m",
    "/[PI].A/M",
    "250",
    79.57747154594767,
    false,
  ),
  UcumUnit(
    false,
    "Gilbert",
    "Gb",
    "GB",
    "magnetic tension",
    0.7957747154594768,
    [0, -1, 0, 0, 0, 1, 0],
    "Gb",
    "cgs",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "Gi; magnetomotive force; Gilberts".split('; '),
    "UCUM",
    "",
    "Clinical",
    "unit of magnetomotive force (magnetic potential)",
    "Oe.cm",
    "OE.CM",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "stilb",
    "sb",
    "SB",
    "lum. intensity density",
    1e4,
    [-2, 0, 0, 0, 0, 0, 1],
    "sb",
    "cgs",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    ["stilbs"],
    "UCUM",
    "",
    "Obsolete",
    "unit of luminance; equal to and replaced by unit candela per square centimeter (cd/cm2)",
    "cd/cm2",
    "CD/CM2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Lambert",
    "Lmb",
    "LMB",
    "brightness",
    3183.098861837907,
    [-2, 0, 0, 0, 0, 0, 1],
    "L",
    "cgs",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "luminance; lamberts".split('; '),
    "UCUM",
    "",
    "Clinical",
    "unit of luminance defined as 1 lambert = 1/ π candela per square meter",
    "cd/cm2/[pi]",
    "CD/CM2/[PI]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "phot",
    "ph",
    "PHT",
    "illuminance",
    1e-4,
    [-2, 0, 0, 2, 0, 0, 1],
    "ph",
    "cgs",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "phots",
    ],
    "UCUM",
    "",
    "Clinical",
    "CGS photometric unit of illuminance, or luminous flux through an area equal to 10000 lumens per square meter = 10000 lux",
    "lx",
    "LX",
    "1e-4",
    1e-4,
    false,
  ),
  UcumUnit(
    false,
    "Curie",
    "Ci",
    "CI",
    "radioactivity",
    37e9,
    [0, -1, 0, 0, 0, 0, 0],
    "Ci",
    "cgs",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "curies",
    ],
    "UCUM",
    "",
    "Obsolete",
    "unit for measuring atomic disintegration rate; replaced by the Bequerel (Bq) unit",
    "Bq",
    "BQ",
    "37e9",
    37e9,
    false,
  ),
  UcumUnit(
    false,
    "Roentgen",
    "R",
    "ROE",
    "ion dose",
    2.58e-7,
    [0, 0, -1, 0, 0, 1, 0],
    "R",
    "cgs",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "röntgen; Roentgens".split('; '),
    "UCUM",
    "",
    "Clinical",
    "unit of exposure of X-rays and gamma rays in air; unit used primarily in the US but strongly discouraged by NIST",
    "C/kg",
    "C/KG",
    "2.58e-4",
    258e-6,
    false,
  ),
  UcumUnit(
    false,
    "radiation absorbed dose",
    "RAD",
    "[RAD]",
    "energy dose",
    0.01,
    [2, -2, 0, 0, 0, 0, 0],
    "RAD",
    "cgs",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "doses",
    ],
    "UCUM",
    "",
    "Clinical",
    "unit of radiation absorbed dose used primarily in the US with base units 100 ergs per gram of material. Also see the SI unit Gray (Gy).",
    "erg/g",
    "ERG/G",
    "100",
    100,
    false,
  ),
  UcumUnit(
    false,
    "radiation equivalent man",
    "REM",
    "[REM]",
    "dose equivalent",
    0.01,
    [2, -2, 0, 0, 0, 0, 0],
    "REM",
    "cgs",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "Roentgen Equivalent in Man; rems; dose equivalents".split('; '),
    "UCUM",
    "",
    "Clinical",
    "unit of equivalent dose which measures the effect of radiation on humans equal to 0.01 sievert. Used primarily in the US. Also see SI unit Sievert (Sv)",
    "RAD",
    "[RAD]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "inch",
    "[in_i]",
    "[IN_I]",
    "length",
    0.025400000000000002,
    [1, 0, 0, 0, 0, 0, 0],
    "in",
    "intcust",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "inches; in; international inch; body height".split('; '),
    "UCUM",
    "Len",
    "Clinical",
    "standard unit for inch in the US and internationally",
    "cm",
    "CM",
    "254e-2",
    2.54,
    false,
  ),
  UcumUnit(
    false,
    "foot",
    "[ft_i]",
    "[FT_I]",
    "length",
    0.3048,
    [1, 0, 0, 0, 0, 0, 0],
    "ft",
    "intcust",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "ft; fts; foot; international foot; feet; international feet; height"
        .split('; '),
    "UCUM",
    "Len",
    "Clinical",
    "unit used in the US and internationally",
    "[in_i]",
    "[IN_I]",
    "12",
    12,
    false,
  ),
  UcumUnit(
    false,
    "yard",
    "[yd_i]",
    "[YD_I]",
    "length",
    0.9144000000000001,
    [1, 0, 0, 0, 0, 0, 0],
    "yd",
    "intcust",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "international yards; yds; distance".split('; '),
    "UCUM",
    "Len",
    "Clinical",
    "standard unit used in the US and internationally",
    "[ft_i]",
    "[FT_I]",
    "3",
    3,
    false,
  ),
  UcumUnit(
    false,
    "mile",
    "[mi_i]",
    "[MI_I]",
    "length",
    1609.344,
    [1, 0, 0, 0, 0, 0, 0],
    "mi",
    "intcust",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "international miles; mi I; statute mile".split('; '),
    "UCUM",
    "Len",
    "Clinical",
    "standard unit used in the US and internationally",
    "[ft_i]",
    "[FT_I]",
    "5280",
    5280,
    false,
  ),
  UcumUnit(
    false,
    "fathom",
    "[fth_i]",
    "[FTH_I]",
    "depth of water",
    1.8288000000000002,
    [1, 0, 0, 0, 0, 0, 0],
    "fth",
    "intcust",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "international fathoms",
    ],
    "UCUM",
    "Len",
    "Nonclinical",
    "unit used in the US and internationally to measure depth of water; same length as the US fathom",
    "[ft_i]",
    "[FT_I]",
    "6",
    6,
    false,
  ),
  UcumUnit(
    false,
    "nautical mile",
    "[nmi_i]",
    "[NMI_I]",
    "length",
    1852,
    [1, 0, 0, 0, 0, 0, 0],
    "n.mi",
    "intcust",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "nautical mile; nautical miles; international nautical mile; international nautical miles; nm; n.m.; nmi"
        .split('; '),
    "UCUM",
    "Len",
    "Nonclinical",
    "standard unit used in the US and internationally",
    "m",
    "M",
    "1852",
    1852,
    false,
  ),
  UcumUnit(
    false,
    "knot",
    "[kn_i]",
    "[KN_I]",
    "velocity",
    0.5144444444444445,
    [1, -1, 0, 0, 0, 0, 0],
    "knot",
    "intcust",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "kn; kt; international knots".split('; '),
    "UCUM",
    "Vel",
    "Nonclinical",
    "defined as equal to one nautical mile (1.852 km) per hour",
    "[nmi_i]/h",
    "[NMI_I]/H",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "square inch",
    "[sin_i]",
    "[SIN_I]",
    "area",
    0.0006451600000000001,
    [2, 0, 0, 0, 0, 0, 0],
    null,
    "intcust",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "in2; in^2; inches squared; sq inch; inches squared; international"
        .split('; '),
    "UCUM",
    "Area",
    "Clinical",
    "standard unit used in the US and internationally",
    "[in_i]2",
    "[IN_I]2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "square foot",
    "[sft_i]",
    "[SFT_I]",
    "area",
    0.09290304,
    [2, 0, 0, 0, 0, 0, 0],
    null,
    "intcust",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "ft2; ft^2; ft squared; sq ft; feet; international".split('; '),
    "UCUM",
    "Area",
    "Clinical",
    "standard unit used in the US and internationally",
    "[ft_i]2",
    "[FT_I]2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "square yard",
    "[syd_i]",
    "[SYD_I]",
    "area",
    0.8361273600000002,
    [2, 0, 0, 0, 0, 0, 0],
    null,
    "intcust",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "yd2; yd^2; sq. yds; yards squared; international".split('; '),
    "UCUM",
    "Area",
    "Clinical",
    "standard unit used in the US and internationally",
    "[yd_i]2",
    "[YD_I]2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "cubic inch",
    "[cin_i]",
    "[CIN_I]",
    "volume",
    16387064000000003e-21,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "intcust",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "in3; in^3; in*3; inches^3; inches*3; cu. in; cu in; cubic inches; inches cubed; cin"
        .split('; '),
    "UCUM",
    "Vol",
    "Clinical",
    "standard unit used in the US and internationally",
    "[in_i]3",
    "[IN_I]3",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "cubic foot",
    "[cft_i]",
    "[CFT_I]",
    "volume",
    0.028316846592000004,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "intcust",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "ft3; ft^3; ft*3; cu. ft; cubic feet; cubed; [ft_i]3; international"
        .split('; '),
    "UCUM",
    "Vol",
    "Clinical",
    "",
    "[ft_i]3",
    "[FT_I]3",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "cubic yard",
    "[cyd_i]",
    "[CYD_I]",
    "volume",
    0.7645548579840002,
    [3, 0, 0, 0, 0, 0, 0],
    "cu.yd",
    "intcust",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "cubic yards; cubic yds; cu yards; CYs; yards^3; yd^3; yds^3; yd3; yds3"
        .split('; '),
    "UCUM",
    "Vol",
    "Nonclinical",
    "standard unit used in the US and internationally",
    "[yd_i]3",
    "[YD_I]3",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "board foot",
    "[bf_i]",
    "[BF_I]",
    "volume",
    0.002359737216,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "intcust",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "BDFT; FBM; BF; board feet; international".split('; '),
    "UCUM",
    "Vol",
    "Nonclinical",
    "unit of volume used to measure lumber",
    "[in_i]3",
    "[IN_I]3",
    "144",
    144,
    false,
  ),
  UcumUnit(
    false,
    "cord",
    "[cr_i]",
    "[CR_I]",
    "volume",
    3.6245563637760005,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "intcust",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "crd I; international cords".split('; '),
    "UCUM",
    "Vol",
    "Nonclinical",
    "unit of measure of dry volume used to measure firewood equal 128 ft3",
    "[ft_i]3",
    "[FT_I]3",
    "128",
    128,
    false,
  ),
  UcumUnit(
    false,
    "mil",
    "[mil_i]",
    "[MIL_I]",
    "length",
    25400000000000004e-21,
    [1, 0, 0, 0, 0, 0, 0],
    "mil",
    "intcust",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "thou, thousandth; mils; international".split('; '),
    "UCUM",
    "Len",
    "Clinical",
    "equal to 0.001 international inch",
    "[in_i]",
    "[IN_I]",
    "1e-3",
    0.001,
    false,
  ),
  UcumUnit(
    false,
    "circular mil",
    "[cml_i]",
    "[CML_I]",
    "area",
    5.067074790974979e-10,
    [2, 0, 0, 0, 0, 0, 0],
    "circ.mil",
    "intcust",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "circular mils; cml I; international".split('; '),
    "UCUM",
    "Area",
    "Clinical",
    "",
    "[pi]/4.[mil_i]2",
    "[PI]/4.[MIL_I]2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "hand",
    "[hd_i]",
    "[HD_I]",
    "height of horses",
    0.10160000000000001,
    [1, 0, 0, 0, 0, 0, 0],
    "hd",
    "intcust",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "hands; international".split('; '),
    "UCUM",
    "Len",
    "Nonclinical",
    "used to measure horse height",
    "[in_i]",
    "[IN_I]",
    "4",
    4,
    false,
  ),
  UcumUnit(
    false,
    "foot - US",
    "[ft_us]",
    "[FT_US]",
    "length",
    0.3048006096012192,
    [1, 0, 0, 0, 0, 0, 0],
    "ft<sub>us</sub>",
    "us-lengths",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "US foot; foot US; us ft; ft us; height; visual distance; feet".split('; '),
    "UCUM",
    "Len",
    "Obsolete",
    "Better to use [ft_i] which refers to the length used worldwide, including in the US;  [ft_us] may be confused with land survey units. ",
    "m/3937",
    "M/3937",
    "1200",
    1200,
    false,
  ),
  UcumUnit(
    false,
    "yard - US",
    "[yd_us]",
    "[YD_US]",
    "length",
    0.9144018288036575,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "us-lengths",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "US yards; us yds; distance".split('; '),
    "UCUM",
    "Len; Nrat",
    "Obsolete",
    "Better to use [yd_i] which refers to the length used worldwide, including in the US; [yd_us] refers to unit used in land surveys in the US",
    "[ft_us]",
    "[FT_US]",
    "3",
    3,
    false,
  ),
  UcumUnit(
    false,
    "inch - US",
    "[in_us]",
    "[IN_US]",
    "length",
    0.0254000508001016,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "us-lengths",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "US inches; in us; us in; inch US".split('; '),
    "UCUM",
    "Len",
    "Obsolete",
    "Better to use [in_i] which refers to the length used worldwide, including in the US",
    "[ft_us]/12",
    "[FT_US]/12",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "rod - US",
    "[rd_us]",
    "[RD_US]",
    "length",
    5.029210058420117,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "us-lengths",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "US rod; US rods; rd US; US rd".split('; '),
    "UCUM",
    "Len",
    "Obsolete",
    "",
    "[ft_us]",
    "[FT_US]",
    "16.5",
    16.5,
    false,
  ),
  UcumUnit(
    false,
    "Gunter's chain - US",
    "[ch_us]",
    "[CH_US]",
    "length",
    20.116840233680467,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "us-lengths",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "surveyor's chain; Surveyor's chain USA; Gunter’s measurement; surveyor’s measurement; Gunter's Chain USA"
        .split('; '),
    "UCUM",
    "Len",
    "Obsolete",
    "historical unit used for land survey used only in the US",
    "[rd_us]",
    "[RD_US]",
    "4",
    4,
    false,
  ),
  UcumUnit(
    false,
    "link for Gunter's chain - US",
    "[lk_us]",
    "[LK_US]",
    "length",
    0.20116840233680466,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "us-lengths",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "Links for Gunter's Chain USA",
    ],
    "UCUM",
    "Len",
    "Obsolete",
    "",
    "[ch_us]/100",
    "[CH_US]/100",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Ramden's chain - US",
    "[rch_us]",
    "[RCH_US]",
    "length",
    30.480060960121918,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "us-lengths",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "Ramsden's chain; engineer's chains".split('; '),
    "UCUM",
    "Len",
    "Obsolete",
    "distance measuring device used for land survey",
    "[ft_us]",
    "[FT_US]",
    "100",
    100,
    false,
  ),
  UcumUnit(
    false,
    "link for Ramden's chain - US",
    "[rlk_us]",
    "[RLK_US]",
    "length",
    0.3048006096012192,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "us-lengths",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "links for Ramsden's chain",
    ],
    "UCUM",
    "Len",
    "Obsolete",
    "",
    "[rch_us]/100",
    "[RCH_US]/100",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "fathom - US",
    "[fth_us]",
    "[FTH_US]",
    "length",
    1.828803657607315,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "us-lengths",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "US fathoms; fathom USA; fth us".split('; '),
    "UCUM",
    "Len",
    "Obsolete",
    "same length as the international fathom - better to use international fathom ([fth_i])",
    "[ft_us]",
    "[FT_US]",
    "6",
    6,
    false,
  ),
  UcumUnit(
    false,
    "furlong - US",
    "[fur_us]",
    "[FUR_US]",
    "length",
    201.16840233680466,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "us-lengths",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "US furlongs; fur us".split('; '),
    "UCUM",
    "Len",
    "Nonclinical",
    "distance unit in horse racing",
    "[rd_us]",
    "[RD_US]",
    "40",
    40,
    false,
  ),
  UcumUnit(
    false,
    "mile - US",
    "[mi_us]",
    "[MI_US]",
    "length",
    1609.3472186944373,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "us-lengths",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "U.S. Survey Miles; US statute miles; survey mi; US mi; distance"
        .split('; '),
    "UCUM",
    "Len",
    "Nonclinical",
    "Better to use [mi_i] which refers to the length used worldwide, including in the US",
    "[fur_us]",
    "[FUR_US]",
    "8",
    8,
    false,
  ),
  UcumUnit(
    false,
    "acre - US",
    "[acr_us]",
    "[ACR_US]",
    "area",
    4046.872609874252,
    [2, 0, 0, 0, 0, 0, 0],
    null,
    "us-lengths",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "Acre USA Survey; Acre USA; survey acres".split('; '),
    "UCUM",
    "Area",
    "Nonclinical",
    "an older unit based on pre 1959 US statute lengths that is still sometimes used in the US only for land survey purposes. ",
    "[rd_us]2",
    "[RD_US]2",
    "160",
    160,
    false,
  ),
  UcumUnit(
    false,
    "square rod - US",
    "[srd_us]",
    "[SRD_US]",
    "area",
    25.292953811714074,
    [2, 0, 0, 0, 0, 0, 0],
    null,
    "us-lengths",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "rod2; rod^2; sq. rod; rods squared".split('; '),
    "UCUM",
    "Area",
    "Nonclinical",
    "Used only in the US to measure land area, based on US statute land survey length units",
    "[rd_us]2",
    "[RD_US]2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "square mile - US",
    "[smi_us]",
    "[SMI_US]",
    "area",
    2589998.470319521,
    [2, 0, 0, 0, 0, 0, 0],
    null,
    "us-lengths",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "mi2; mi^2; sq mi; miles squared".split('; '),
    "UCUM",
    "Area",
    "Nonclinical",
    "historical unit used only in the US for land survey purposes (based on the US survey mile), not the internationally recognized [mi_i]",
    "[mi_us]2",
    "[MI_US]2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "section",
    "[sct]",
    "[SCT]",
    "area",
    2589998.470319521,
    [2, 0, 0, 0, 0, 0, 0],
    null,
    "us-lengths",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "sct; sections".split('; '),
    "UCUM",
    "Area",
    "Nonclinical",
    "tract of land approximately equal to 1 mile square containing 640 acres",
    "[mi_us]2",
    "[MI_US]2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "township",
    "[twp]",
    "[TWP]",
    "area",
    93239944.93150276,
    [2, 0, 0, 0, 0, 0, 0],
    null,
    "us-lengths",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "twp; townships".split('; '),
    "UCUM",
    "Area",
    "Nonclinical",
    "land measurement equal to 6 mile square",
    "[sct]",
    "[SCT]",
    "36",
    36,
    false,
  ),
  UcumUnit(
    false,
    "mil - US",
    "[mil_us]",
    "[MIL_US]",
    "length",
    254000508001016e-19,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "us-lengths",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "thou, thousandth; mils".split('; '),
    "UCUM",
    "Len",
    "Obsolete",
    "better to use [mil_i] which is based on the internationally recognized inch",
    "[in_us]",
    "[IN_US]",
    "1e-3",
    0.001,
    false,
  ),
  UcumUnit(
    false,
    "inch - British",
    "[in_br]",
    "[IN_BR]",
    "length",
    0.025399980000000003,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "brit-length",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "imperial inches; imp in; br in; british inches".split('; '),
    "UCUM",
    "Len",
    "Obsolete",
    "",
    "cm",
    "CM",
    "2.539998",
    2.539998,
    false,
  ),
  UcumUnit(
    false,
    "foot - British",
    "[ft_br]",
    "[FT_BR]",
    "length",
    0.30479976000000003,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "brit-length",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "British Foot; Imperial Foot; feet; imp fts; br fts".split('; '),
    "UCUM",
    "Len",
    "Obsolete",
    "",
    "[in_br]",
    "[IN_BR]",
    "12",
    12,
    false,
  ),
  UcumUnit(
    false,
    "rod - British",
    "[rd_br]",
    "[RD_BR]",
    "length",
    5.02919604,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "brit-length",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "British rods; br rd".split('; '),
    "UCUM",
    "Len",
    "Obsolete",
    "",
    "[ft_br]",
    "[FT_BR]",
    "16.5",
    16.5,
    false,
  ),
  UcumUnit(
    false,
    "Gunter's chain - British",
    "[ch_br]",
    "[CH_BR]",
    "length",
    20.11678416,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "brit-length",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "Gunter's Chain British; Gunters Chain British; Surveyor's Chain British"
        .split('; '),
    "UCUM",
    "Len",
    "Obsolete",
    "historical unit used for land survey used only in Great Britain",
    "[rd_br]",
    "[RD_BR]",
    "4",
    4,
    false,
  ),
  UcumUnit(
    false,
    "link for Gunter's chain - British",
    "[lk_br]",
    "[LK_BR]",
    "length",
    0.2011678416,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "brit-length",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "Links for Gunter's Chain British",
    ],
    "UCUM",
    "Len",
    "Obsolete",
    "",
    "[ch_br]/100",
    "[CH_BR]/100",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "fathom - British",
    "[fth_br]",
    "[FTH_BR]",
    "length",
    1.82879856,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "brit-length",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "British fathoms; imperial fathoms; br fth; imp fth".split('; '),
    "UCUM",
    "Len",
    "Obsolete",
    "",
    "[ft_br]",
    "[FT_BR]",
    "6",
    6,
    false,
  ),
  UcumUnit(
    false,
    "pace - British",
    "[pc_br]",
    "[PC_BR]",
    "length",
    0.7619994000000001,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "brit-length",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "British paces; br pc".split('; '),
    "UCUM",
    "Len",
    "Nonclinical",
    "traditional unit of length equal to 152.4 centimeters, or 1.52 meter. ",
    "[ft_br]",
    "[FT_BR]",
    "2.5",
    2.5,
    false,
  ),
  UcumUnit(
    false,
    "yard - British",
    "[yd_br]",
    "[YD_BR]",
    "length",
    0.91439928,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "brit-length",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "British yards; Br yds; distance".split('; '),
    "UCUM",
    "Len",
    "Obsolete",
    "",
    "[ft_br]",
    "[FT_BR]",
    "3",
    3,
    false,
  ),
  UcumUnit(
    false,
    "mile - British",
    "[mi_br]",
    "[MI_BR]",
    "length",
    1609.3427328000002,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "brit-length",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "imperial miles; British miles; English statute miles; imp mi, br mi"
        .split('; '),
    "UCUM",
    "Len",
    "Obsolete",
    "",
    "[ft_br]",
    "[FT_BR]",
    "5280",
    5280,
    false,
  ),
  UcumUnit(
    false,
    "nautical mile - British",
    "[nmi_br]",
    "[NMI_BR]",
    "length",
    1853.1825408000002,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "brit-length",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "British nautical miles; Imperial nautical miles; Admiralty miles; n.m. br; imp nm"
        .split('; '),
    "UCUM",
    "Len",
    "Obsolete",
    "",
    "[ft_br]",
    "[FT_BR]",
    "6080",
    6080,
    false,
  ),
  UcumUnit(
    false,
    "knot - British",
    "[kn_br]",
    "[KN_BR]",
    "velocity",
    0.5147729280000001,
    [1, -1, 0, 0, 0, 0, 0],
    null,
    "brit-length",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "British knots; kn br; kt".split('; '),
    "UCUM",
    "Vel",
    "Obsolete",
    "based on obsolete British nautical mile ",
    "[nmi_br]/h",
    "[NMI_BR]/H",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "acre",
    "[acr_br]",
    "[ACR_BR]",
    "area",
    4046.850049400269,
    [2, 0, 0, 0, 0, 0, 0],
    null,
    "brit-length",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "Imperial acres; British; a; ac; ar; acr".split('; '),
    "UCUM",
    "Area",
    "Nonclinical",
    "the standard unit for acre used in the US and internationally",
    "[yd_br]2",
    "[YD_BR]2",
    "4840",
    4840,
    false,
  ),
  UcumUnit(
    false,
    "gallon - US",
    "[gal_us]",
    "[GAL_US]",
    "fluid volume",
    0.0037854117840000006,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "us-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "US gallons; US liquid gallon; gal us; Queen Anne's wine gallon"
        .split('; '),
    "UCUM",
    "Vol",
    "Nonclinical",
    "only gallon unit used in the US; [gal_us] is only used in some other countries in South American and Africa to measure gasoline volume",
    "[in_i]3",
    "[IN_I]3",
    "231",
    231,
    false,
  ),
  UcumUnit(
    false,
    "barrel - US",
    "[bbl_us]",
    "[BBL_US]",
    "fluid volume",
    0.158987294928,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "us-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "bbl",
    ],
    "UCUM",
    "Vol",
    "Nonclinical",
    "[bbl_us] is the standard unit for oil barrel, which is a unit only used in the US to measure the volume oil. ",
    "[gal_us]",
    "[GAL_US]",
    "42",
    42,
    false,
  ),
  UcumUnit(
    false,
    "quart - US",
    "[qt_us]",
    "[QT_US]",
    "fluid volume",
    0.0009463529460000001,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "us-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "US quarts; us qts".split('; '),
    "UCUM",
    "Vol",
    "Clinical",
    "Used only in the US",
    "[gal_us]/4",
    "[GAL_US]/4",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "pint - US",
    "[pt_us]",
    "[PT_US]",
    "fluid volume",
    0.00047317647300000007,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "us-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "US pints; pint US; liquid pint; pt us; us pt".split('; '),
    "UCUM",
    "Vol",
    "Clinical",
    "Used only in the US",
    "[qt_us]/2",
    "[QT_US]/2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "gill - US",
    "[gil_us]",
    "[GIL_US]",
    "fluid volume",
    0.00011829411825000002,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "us-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "US gills; gil us".split('; '),
    "UCUM",
    "Vol",
    "Nonclinical",
    "only used in the context of alcohol volume in the US",
    "[pt_us]/4",
    "[PT_US]/4",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "fluid ounce - US",
    "[foz_us]",
    "[FOZ_US]",
    "fluid volume",
    29573529562500005e-21,
    [3, 0, 0, 0, 0, 0, 0],
    "oz fl",
    "us-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "US fluid ounces; fl ozs; FO; fl. oz.; foz us".split('; '),
    "UCUM",
    "Vol",
    "Clinical",
    "unit used only in the US",
    "[gil_us]/4",
    "[GIL_US]/4",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "fluid dram - US",
    "[fdr_us]",
    "[FDR_US]",
    "fluid volume",
    36966911953125006e-22,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "us-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "US fluid drams; fdr us".split('; '),
    "UCUM",
    "Vol",
    "Nonclinical",
    "equal to 1/8 US fluid ounce = 3.69 mL; used informally to mean small amount of liquor, especially Scotch whiskey",
    "[foz_us]/8",
    "[FOZ_US]/8",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "minim - US",
    "[min_us]",
    "[MIN_US]",
    "fluid volume",
    6.1611519921875e-8,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "us-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "min US; US min; ♏ US".split('; '),
    "UCUM",
    "Vol",
    "Obsolete",
    "",
    "[fdr_us]/60",
    "[FDR_US]/60",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "cord - US",
    "[crd_us]",
    "[CRD_US]",
    "fluid volume",
    3.6245563637760005,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "us-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "US cord; US cords; crd us; us crd".split('; '),
    "UCUM",
    "Vol",
    "Nonclinical",
    "unit of measure of dry volume used to measure firewood equal 128 ft3 (the same as international cord [cr_i])",
    "[ft_i]3",
    "[FT_I]3",
    "128",
    128,
    false,
  ),
  UcumUnit(
    false,
    "bushel - US",
    "[bu_us]",
    "[BU_US]",
    "dry volume",
    0.03523907016688001,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "us-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "US bushels; US bsh; US bu".split('; '),
    "UCUM",
    "Vol",
    "Obsolete",
    "Historical unit of dry volume that is rarely used today",
    "[in_i]3",
    "[IN_I]3",
    "2150.42",
    2150.42,
    false,
  ),
  UcumUnit(
    false,
    "gallon - historical",
    "[gal_wi]",
    "[GAL_WI]",
    "dry volume",
    0.004404883770860001,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "us-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "Corn Gallon British; Dry Gallon US; Gallons Historical; Grain Gallon British; Winchester Corn Gallon; historical winchester gallons; wi gal"
        .split('; '),
    "UCUM",
    "Vol",
    "Obsolete",
    "historical unit of dry volume no longer used",
    "[bu_us]/8",
    "[BU_US]/8",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "peck - US",
    "[pk_us]",
    "[PK_US]",
    "dry volume",
    0.008809767541720002,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "us-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "US pecks; US pk".split('; '),
    "UCUM",
    "Vol",
    "Nonclinical",
    "unit of dry volume rarely used today (can be used to measure volume of apples)",
    "[bu_us]/4",
    "[BU_US]/4",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "dry quart - US",
    "[dqt_us]",
    "[DQT_US]",
    "dry volume",
    0.0011012209427150002,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "us-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "dry quarts; dry quart US; US dry quart; dry qt; us dry qt; dqt; dqt us"
        .split('; '),
    "UCUM",
    "Vol",
    "Nonclinical",
    "historical unit of dry volume only in the US, but is rarely used today",
    "[pk_us]/8",
    "[PK_US]/8",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "dry pint - US",
    "[dpt_us]",
    "[DPT_US]",
    "dry volume",
    0.0005506104713575001,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "us-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "dry pints; dry pint US; US dry pint; dry pt; dpt; dpt us".split('; '),
    "UCUM",
    "Vol",
    "Nonclinical",
    "historical unit of dry volume only in the US, but is rarely used today",
    "[dqt_us]/2",
    "[DQT_US]/2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "tablespoon - US",
    "[tbs_us]",
    "[TBS_US]",
    "volume",
    14786764781250002e-21,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "us-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "Tbs; tbsp; tbs us; US tablespoons".split('; '),
    "UCUM",
    "Vol",
    "Clinical",
    "unit defined as 0.5 US fluid ounces or 3 teaspoons - used only in the US. See [tbs_m] for the unit used internationally and in the US for nutrional labelling. ",
    "[foz_us]/2",
    "[FOZ_US]/2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "teaspoon - US",
    "[tsp_us]",
    "[TSP_US]",
    "volume",
    49289215937500005e-22,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "us-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "tsp; t; US teaspoons".split('; '),
    "UCUM",
    "Vol",
    "Nonclinical",
    "unit defined as 1/6 US fluid ounces - used only in the US. See [tsp_m] for the unit used internationally and in the US for nutrional labelling. ",
    "[tbs_us]/3",
    "[TBS_US]/3",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "cup - US customary",
    "[cup_us]",
    "[CUP_US]",
    "volume",
    0.00023658823650000004,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "us-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "cup us; us cups".split('; '),
    "UCUM",
    "Vol",
    "Nonclinical",
    "Unit defined as 1/2 US pint or 16 US tablespoons ≈ 236.59 mL, which is not the standard unit defined by the FDA of 240 mL - see [cup_m] (metric cup)",
    "[tbs_us]",
    "[TBS_US]",
    "16",
    16,
    false,
  ),
  UcumUnit(
    false,
    "fluid ounce - metric",
    "[foz_m]",
    "[FOZ_M]",
    "fluid volume",
    29999999999999997e-21,
    [3, 0, 0, 0, 0, 0, 0],
    "oz fl",
    "us-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "metric fluid ounces; fozs m; fl ozs m".split('; '),
    "UCUM",
    "Vol",
    "Clinical",
    "unit used only in the US for nutritional labelling, as set by the FDA",
    "mL",
    "ML",
    "30",
    30,
    false,
  ),
  UcumUnit(
    false,
    "cup - US legal",
    "[cup_m]",
    "[CUP_M]",
    "volume",
    0.00023999999999999998,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "us-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "cup m; metric cups".split('; '),
    "UCUM",
    "Vol",
    "Clinical",
    "standard unit equal to 240 mL used in the US for nutritional labelling, as defined by the FDA. Note that this is different from the US customary cup (236.59 mL) and the metric cup used in Commonwealth nations (250 mL).",
    "mL",
    "ML",
    "240",
    240,
    false,
  ),
  UcumUnit(
    false,
    "teaspoon - metric",
    "[tsp_m]",
    "[TSP_M]",
    "volume",
    49999999999999996e-22,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "us-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "tsp; t; metric teaspoons".split('; '),
    "UCUM",
    "Vol",
    "Clinical",
    "standard unit used in the US and internationally",
    "mL",
    "mL",
    "5",
    5,
    false,
  ),
  UcumUnit(
    false,
    "tablespoon - metric",
    "[tbs_m]",
    "[TBS_M]",
    "volume",
    14999999999999999e-21,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "us-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "metric tablespoons; Tbs; tbsp; T; tbs m".split('; '),
    "UCUM",
    "Vol",
    "Clinical",
    "standard unit used in the US and internationally",
    "mL",
    "mL",
    "15",
    15,
    false,
  ),
  UcumUnit(
    false,
    "gallon- British",
    "[gal_br]",
    "[GAL_BR]",
    "volume",
    0.004546090000000001,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "brit-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "imperial gallons, UK gallons; British gallons; br gal; imp gal"
        .split('; '),
    "UCUM",
    "Vol",
    "Nonclinical",
    "Used only in Great Britain and other Commonwealth countries",
    "l",
    "L",
    "4.54609",
    4.54609,
    false,
  ),
  UcumUnit(
    false,
    "peck - British",
    "[pk_br]",
    "[PK_BR]",
    "volume",
    0.009092180000000002,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "brit-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "imperial pecks; British pecks; br pk; imp pk".split('; '),
    "UCUM",
    "Vol",
    "Nonclinical",
    "unit of dry volume rarely used today (can be used to measure volume of apples)",
    "[gal_br]",
    "[GAL_BR]",
    "2",
    2,
    false,
  ),
  UcumUnit(
    false,
    "bushel - British",
    "[bu_br]",
    "[BU_BR]",
    "volume",
    0.03636872000000001,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "brit-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "British bushels; imperial; br bsh; br bu; imp".split('; '),
    "UCUM",
    "Vol",
    "Obsolete",
    "Historical unit of dry volume that is rarely used today",
    "[pk_br]",
    "[PK_BR]",
    "4",
    4,
    false,
  ),
  UcumUnit(
    false,
    "quart - British",
    "[qt_br]",
    "[QT_BR]",
    "volume",
    0.0011365225000000002,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "brit-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "British quarts; imperial quarts; br qts".split('; '),
    "UCUM",
    "Vol",
    "Clinical",
    "Used only in Great Britain and other Commonwealth countries",
    "[gal_br]/4",
    "[GAL_BR]/4",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "pint - British",
    "[pt_br]",
    "[PT_BR]",
    "volume",
    0.0005682612500000001,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "brit-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "British pints; imperial pints; pt br; br pt; imp pt; pt imp".split('; '),
    "UCUM",
    "Vol",
    "Clinical",
    "Used only in Great Britain and other Commonwealth countries",
    "[qt_br]/2",
    "[QT_BR]/2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "gill - British",
    "[gil_br]",
    "[GIL_BR]",
    "volume",
    0.00014206531250000003,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "brit-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "imperial gills; British gills; imp gill, br gill".split('; '),
    "UCUM",
    "Vol",
    "Nonclinical",
    "only used in the context of alcohol volume in Great Britain",
    "[pt_br]/4",
    "[PT_BR]/4",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "fluid ounce - British",
    "[foz_br]",
    "[FOZ_BR]",
    "volume",
    28413062500000005e-21,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "brit-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "British fluid ounces; Imperial fluid ounces; br fozs; imp fozs; br fl ozs"
        .split('; '),
    "UCUM",
    "Vol",
    "Clinical",
    "Used only in Great Britain and other Commonwealth countries",
    "[gil_br]/5",
    "[GIL_BR]/5",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "fluid dram - British",
    "[fdr_br]",
    "[FDR_BR]",
    "volume",
    35516328125000006e-22,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "brit-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "British fluid drams; fdr br".split('; '),
    "UCUM",
    "Vol",
    "Nonclinical",
    "equal to 1/8 Imperial fluid ounce = 3.55 mL; used informally to mean small amount of liquor, especially Scotch whiskey",
    "[foz_br]/8",
    "[FOZ_BR]/8",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "minim - British",
    "[min_br]",
    "[MIN_BR]",
    "volume",
    5.919388020833334e-8,
    [3, 0, 0, 0, 0, 0, 0],
    null,
    "brit-volumes",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "min br; br min; ♏ br".split('; '),
    "UCUM",
    "Vol",
    "Obsolete",
    "",
    "[fdr_br]/60",
    "[FDR_BR]/60",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "grain",
    "[gr]",
    "[GR]",
    "mass",
    0.06479891,
    [0, 0, 1, 0, 0, 0, 0],
    null,
    "avoirdupois",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "gr; grains".split('; '),
    "UCUM",
    "Mass",
    "Nonclinical",
    "an apothecary measure of mass rarely used today",
    "mg",
    "MG",
    "64.79891",
    64.79891,
    false,
  ),
  UcumUnit(
    false,
    "pound",
    "[lb_av]",
    "[LB_AV]",
    "mass",
    453.59237,
    [0, 0, 1, 0, 0, 0, 0],
    "lb",
    "avoirdupois",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "avoirdupois pounds, international pounds; av lbs; pounds".split('; '),
    "UCUM",
    "Mass",
    "Clinical",
    "standard unit used in the US and internationally",
    "[gr]",
    "[GR]",
    "7000",
    7e3,
    false,
  ),
  UcumUnit(
    false,
    "pound force - US",
    "[lbf_av]",
    "[LBF_AV]",
    "force",
    4448.2216152605,
    [1, -2, 1, 0, 0, 0, 0],
    "lbf",
    "const",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "lbfs; US lbf; US pound forces".split('; '),
    "UCUM",
    "Force",
    "Clinical",
    "only rarely needed in health care - see [lb_av] which is the more common unit to express weight",
    "[lb_av].[g]",
    "[LB_AV].[G]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "ounce",
    "[oz_av]",
    "[OZ_AV]",
    "mass",
    28.349523125,
    [0, 0, 1, 0, 0, 0, 0],
    "oz",
    "avoirdupois",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "ounces; international ounces; avoirdupois ounces; av ozs".split('; '),
    "UCUM",
    "Mass",
    "Clinical",
    "standard unit used in the US and internationally",
    "[lb_av]/16",
    "[LB_AV]/16",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Dram mass unit",
    "[dr_av]",
    "[DR_AV]",
    "mass",
    1.7718451953125,
    [0, 0, 1, 0, 0, 0, 0],
    null,
    "avoirdupois",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "Dram; drams avoirdupois; avoidupois dram; international dram".split('; '),
    "UCUM",
    "Mass",
    "Clinical",
    "unit from the avoirdupois system, which is used in the US and internationally",
    "[oz_av]/16",
    "[OZ_AV]/16",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "short hundredweight",
    "[scwt_av]",
    "[SCWT_AV]",
    "mass",
    45359.237,
    [0, 0, 1, 0, 0, 0, 0],
    null,
    "avoirdupois",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "hundredweights; s cwt; scwt; avoirdupois".split('; '),
    "UCUM",
    "Mass",
    "Nonclinical",
    "Used only in the US to equal 100 pounds",
    "[lb_av]",
    "[LB_AV]",
    "100",
    100,
    false,
  ),
  UcumUnit(
    false,
    "long hundredweight",
    "[lcwt_av]",
    "[LCWT_AV]",
    "mass",
    50802.345440000005,
    [0, 0, 1, 0, 0, 0, 0],
    null,
    "avoirdupois",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "imperial hundredweights; imp cwt; lcwt; avoirdupois".split('; '),
    "UCUM",
    "Mass",
    "Obsolete",
    "",
    "[lb_av]",
    "[LB_AV]",
    "112",
    112,
    false,
  ),
  UcumUnit(
    false,
    "short ton - US",
    "[ston_av]",
    "[STON_AV]",
    "mass",
    907184.74,
    [0, 0, 1, 0, 0, 0, 0],
    null,
    "avoirdupois",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "ton; US tons; avoirdupois tons".split('; '),
    "UCUM",
    "Mass",
    "Clinical",
    "Used only in the US",
    "[scwt_av]",
    "[SCWT_AV]",
    "20",
    20,
    false,
  ),
  UcumUnit(
    false,
    "long ton - British",
    "[lton_av]",
    "[LTON_AV]",
    "mass",
    1016046.9088000001,
    [0, 0, 1, 0, 0, 0, 0],
    null,
    "avoirdupois",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "imperial tons; weight tons; British long tons; long ton avoirdupois"
        .split('; '),
    "UCUM",
    "Mass",
    "Nonclinical",
    "Used only in Great Britain and other Commonwealth countries",
    "[lcwt_av]",
    "[LCWT_AV]",
    "20",
    20,
    false,
  ),
  UcumUnit(
    false,
    "stone - British",
    "[stone_av]",
    "[STONE_AV]",
    "mass",
    6350.293180000001,
    [0, 0, 1, 0, 0, 0, 0],
    null,
    "avoirdupois",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "British stones; avoirdupois".split('; '),
    "UCUM",
    "Mass",
    "Nonclinical",
    "Used primarily in the UK and Ireland to measure body weight",
    "[lb_av]",
    "[LB_AV]",
    "14",
    14,
    false,
  ),
  UcumUnit(
    false,
    "pennyweight - troy",
    "[pwt_tr]",
    "[PWT_TR]",
    "mass",
    1.5551738400000001,
    [0, 0, 1, 0, 0, 0, 0],
    null,
    "troy",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "dwt; denarius weights".split('; '),
    "UCUM",
    "Mass",
    "Obsolete",
    "historical unit used to measure mass and cost of precious metals",
    "[gr]",
    "[GR]",
    "24",
    24,
    false,
  ),
  UcumUnit(
    false,
    "ounce - troy",
    "[oz_tr]",
    "[OZ_TR]",
    "mass",
    31.103476800000003,
    [0, 0, 1, 0, 0, 0, 0],
    null,
    "troy",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "troy ounces; tr ozs".split('; '),
    "UCUM",
    "Mass",
    "Nonclinical",
    "unit of mass for precious metals and gemstones only",
    "[pwt_tr]",
    "[PWT_TR]",
    "20",
    20,
    false,
  ),
  UcumUnit(
    false,
    "pound - troy",
    "[lb_tr]",
    "[LB_TR]",
    "mass",
    373.2417216,
    [0, 0, 1, 0, 0, 0, 0],
    null,
    "troy",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "troy pounds; tr lbs".split('; '),
    "UCUM",
    "Mass",
    "Nonclinical",
    "only used for weighing precious metals",
    "[oz_tr]",
    "[OZ_TR]",
    "12",
    12,
    false,
  ),
  UcumUnit(
    false,
    "scruple",
    "[sc_ap]",
    "[SC_AP]",
    "mass",
    1.2959782,
    [0, 0, 1, 0, 0, 0, 0],
    null,
    "apoth",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "scruples; sc ap".split('; '),
    "UCUM",
    "Mass",
    "Obsolete",
    "",
    "[gr]",
    "[GR]",
    "20",
    20,
    false,
  ),
  UcumUnit(
    false,
    "dram - apothecary",
    "[dr_ap]",
    "[DR_AP]",
    "mass",
    3.8879346,
    [0, 0, 1, 0, 0, 0, 0],
    null,
    "apoth",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "ʒ; drachm; apothecaries drams; dr ap; dram ap".split('; '),
    "UCUM",
    "Mass",
    "Nonclinical",
    "unit still used in the US occasionally to measure amount of drugs in pharmacies",
    "[sc_ap]",
    "[SC_AP]",
    "3",
    3,
    false,
  ),
  UcumUnit(
    false,
    "ounce - apothecary",
    "[oz_ap]",
    "[OZ_AP]",
    "mass",
    31.1034768,
    [0, 0, 1, 0, 0, 0, 0],
    null,
    "apoth",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "apothecary ounces; oz ap; ap ozs; ozs ap".split('; '),
    "UCUM",
    "Mass",
    "Obsolete",
    "",
    "[dr_ap]",
    "[DR_AP]",
    "8",
    8,
    false,
  ),
  UcumUnit(
    false,
    "pound - apothecary",
    "[lb_ap]",
    "[LB_AP]",
    "mass",
    373.2417216,
    [0, 0, 1, 0, 0, 0, 0],
    null,
    "apoth",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "apothecary pounds; apothecaries pounds; ap lb; lb ap; ap lbs; lbs ap"
        .split('; '),
    "UCUM",
    "Mass",
    "Obsolete",
    "",
    "[oz_ap]",
    "[OZ_AP]",
    "12",
    12,
    false,
  ),
  UcumUnit(
    false,
    "ounce - metric",
    "[oz_m]",
    "[OZ_M]",
    "mass",
    28,
    [0, 0, 1, 0, 0, 0, 0],
    null,
    "apoth",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "metric ounces; m ozs".split('; '),
    "UCUM",
    "Mass",
    "Clinical",
    "see [oz_av] (the avoirdupois ounce) for the standard ounce used internationally; [oz_m] is equal to 28 grams and is based on the apothecaries' system of mass units which is used in some US pharmacies. ",
    "g",
    "g",
    "28",
    28,
    false,
  ),
  UcumUnit(
    false,
    "line",
    "[lne]",
    "[LNE]",
    "length",
    0.002116666666666667,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "typeset",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "British lines; br L; L; l".split('; '),
    "UCUM",
    "Len",
    "Obsolete",
    "",
    "[in_i]/12",
    "[IN_I]/12",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "point (typography)",
    "[pnt]",
    "[PNT]",
    "length",
    0.0003527777777777778,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "typeset",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "DTP points; desktop publishing point; pt; pnt".split('; '),
    "UCUM",
    "Len",
    "Nonclinical",
    "typography unit for typesetter's length",
    "[lne]/6",
    "[LNE]/6",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "pica (typography)",
    "[pca]",
    "[PCA]",
    "length",
    0.004233333333333334,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "typeset",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "picas",
    ],
    "UCUM",
    "Len",
    "Nonclinical",
    "typography unit for typesetter's length",
    "[pnt]",
    "[PNT]",
    "12",
    12,
    false,
  ),
  UcumUnit(
    false,
    "Printer's point (typography)",
    "[pnt_pr]",
    "[PNT_PR]",
    "length",
    0.00035145980000000004,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "typeset",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "pnt pr",
    ],
    "UCUM",
    "Len",
    "Nonclinical",
    "typography unit for typesetter's length",
    "[in_i]",
    "[IN_I]",
    "0.013837",
    0.013837,
    false,
  ),
  UcumUnit(
    false,
    "Printer's pica  (typography)",
    "[pca_pr]",
    "[PCA_PR]",
    "length",
    0.004217517600000001,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "typeset",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "pca pr; Printer's picas".split('; '),
    "UCUM",
    "Len",
    "Nonclinical",
    "typography unit for typesetter's length",
    "[pnt_pr]",
    "[PNT_PR]",
    "12",
    12,
    false,
  ),
  UcumUnit(
    false,
    "pied",
    "[pied]",
    "[PIED]",
    "length",
    0.3248,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "typeset",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "pieds du roi; Paris foot; royal; French; feet".split('; '),
    "UCUM",
    "Len",
    "Obsolete",
    "",
    "cm",
    "CM",
    "32.48",
    32.48,
    false,
  ),
  UcumUnit(
    false,
    "pouce",
    "[pouce]",
    "[POUCE]",
    "length",
    0.027066666666666666,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "typeset",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "historical French inches; French royal inches".split('; '),
    "UCUM",
    "Len",
    "Obsolete",
    "",
    "[pied]/12",
    "[PIED]/12",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "ligne",
    "[ligne]",
    "[LIGNE]",
    "length",
    0.0022555555555555554,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "typeset",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "Paris lines; lignes".split('; '),
    "UCUM",
    "Len",
    "Obsolete",
    "",
    "[pouce]/12",
    "[POUCE]/12",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "didot",
    "[didot]",
    "[DIDOT]",
    "length",
    0.0003759259259259259,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "typeset",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "Didot point; dd; Didots Point; didots; points".split('; '),
    "UCUM",
    "Len",
    "Obsolete",
    "typography unit for typesetter's length",
    "[ligne]/6",
    "[LIGNE]/6",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "cicero",
    "[cicero]",
    "[CICERO]",
    "length",
    0.004511111111111111,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "typeset",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "Didot's pica; ciceros; picas".split('; '),
    "UCUM",
    "Len",
    "Obsolete",
    "typography unit for typesetter's length",
    "[didot]",
    "[DIDOT]",
    "12",
    12,
    false,
  ),
  UcumUnit(
    false,
    "degrees Fahrenheit",
    "[degF]",
    "[DEGF]",
    "temperature",
    0.5555555555555556,
    [0, 0, 0, 0, 1, 0, 0],
    "°F",
    "heat",
    false,
    null,
    "degF",
    1,
    true,
    false,
    0,
    "°F; deg F".split('; '),
    "UCUM",
    "Temp",
    "Clinical",
    "",
    "K",
    null,
    null,
    0.5555555555555556,
    false,
  ),
  UcumUnit(
    false,
    "degrees Rankine",
    "[degR]",
    "[degR]",
    "temperature",
    0.5555555555555556,
    [0, 0, 0, 0, 1, 0, 0],
    "°R",
    "heat",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "°R; °Ra; Rankine".split('; '),
    "UCUM",
    "Temp",
    "Obsolete",
    "Replaced by Kelvin",
    "K/9",
    "K/9",
    "5",
    5,
    false,
  ),
  UcumUnit(
    false,
    "degrees Réaumur",
    "[degRe]",
    "[degRe]",
    "temperature",
    1.25,
    [0, 0, 0, 0, 1, 0, 0],
    "°Ré",
    "heat",
    false,
    null,
    "degRe",
    1,
    true,
    false,
    0,
    "°Ré, °Re, °r; Réaumur; degree Reaumur; Reaumur".split('; '),
    "UCUM",
    "Temp",
    "Obsolete",
    "replaced by Celsius",
    "K",
    null,
    null,
    1.25,
    false,
  ),
  UcumUnit(
    false,
    "calorie at 15°C",
    "cal_[15]",
    "CAL_[15]",
    "energy",
    4185.8,
    [2, -2, 1, 0, 0, 0, 0],
    "cal<sub>15°C</sub>",
    "heat",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "calorie 15 C; cals 15 C; calories at 15 C".split('; '),
    "UCUM",
    "Enrg",
    "Nonclinical",
    "equal to 4.1855 joules; calorie most often used in engineering",
    "J",
    "J",
    "4.18580",
    4.1858,
    false,
  ),
  UcumUnit(
    false,
    "calorie at 20°C",
    "cal_[20]",
    "CAL_[20]",
    "energy",
    4181.9,
    [2, -2, 1, 0, 0, 0, 0],
    "cal<sub>20°C</sub>",
    "heat",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "calorie 20 C; cal 20 C; calories at 20 C".split('; '),
    "UCUM",
    "Enrg",
    "Clinical",
    "equal to 4.18190  joules. ",
    "J",
    "J",
    "4.18190",
    4.1819,
    false,
  ),
  UcumUnit(
    false,
    "mean calorie",
    "cal_m",
    "CAL_M",
    "energy",
    4190.0199999999995,
    [2, -2, 1, 0, 0, 0, 0],
    "cal<sub>m</sub>",
    "heat",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mean cals; mean calories".split('; '),
    "UCUM",
    "Enrg",
    "Clinical",
    "equal to 4.19002 joules. ",
    "J",
    "J",
    "4.19002",
    4.19002,
    false,
  ),
  UcumUnit(
    false,
    "international table calorie",
    "cal_IT",
    "CAL_IT",
    "energy",
    4186.8,
    [2, -2, 1, 0, 0, 0, 0],
    "cal<sub>IT</sub>",
    "heat",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "calories IT; IT cals; international steam table calories".split('; '),
    "UCUM",
    "Enrg",
    "Nonclinical",
    "used in engineering steam tables and defined as 1/860 international watt-hour; equal to 4.1868 joules",
    "J",
    "J",
    "4.1868",
    4.1868,
    false,
  ),
  UcumUnit(
    false,
    "thermochemical calorie",
    "cal_th",
    "CAL_TH",
    "energy",
    4184,
    [2, -2, 1, 0, 0, 0, 0],
    "cal<sub>th</sub>",
    "heat",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "thermochemical calories; th cals".split('; '),
    "UCUM",
    "Enrg",
    "Clinical",
    "equal to 4.184 joules; used as the unit in medicine and biochemistry (equal to cal)",
    "J",
    "J",
    "4.184",
    4.184,
    false,
  ),
  UcumUnit(
    false,
    "calorie",
    "cal",
    "CAL",
    "energy",
    4184,
    [2, -2, 1, 0, 0, 0, 0],
    "cal",
    "heat",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "gram calories; small calories".split('; '),
    "UCUM",
    "Enrg",
    "Clinical",
    "equal to 4.184 joules (the same value as the thermochemical calorie, which is the most common calorie used in medicine and biochemistry)",
    "cal_th",
    "CAL_TH",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "nutrition label Calories",
    "[Cal]",
    "[CAL]",
    "energy",
    4184e3,
    [2, -2, 1, 0, 0, 0, 0],
    "Cal",
    "heat",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "food calories; Cal; kcal".split('; '),
    "UCUM",
    "Eng",
    "Clinical",
    "",
    "kcal_th",
    "KCAL_TH",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "British thermal unit at 39°F",
    "[Btu_39]",
    "[BTU_39]",
    "energy",
    1059670,
    [2, -2, 1, 0, 0, 0, 0],
    "Btu<sub>39°F</sub>",
    "heat",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "BTU 39F; BTU 39 F; B.T.U. 39 F; B.Th.U. 39 F; BThU 39 F; British thermal units"
        .split('; '),
    "UCUM",
    "Eng",
    "Nonclinical",
    "equal to 1.05967 kJ; used as a measure of power in the electric power, steam generation, heating, and air conditioning industries",
    "kJ",
    "kJ",
    "1.05967",
    1.05967,
    false,
  ),
  UcumUnit(
    false,
    "British thermal unit at 59°F",
    "[Btu_59]",
    "[BTU_59]",
    "energy",
    1054800,
    [2, -2, 1, 0, 0, 0, 0],
    "Btu<sub>59°F</sub>",
    "heat",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "BTU 59 F; BTU 59F; B.T.U. 59 F; B.Th.U. 59 F; BThU 59F; British thermal units"
        .split('; '),
    "UCUM",
    "Eng",
    "Nonclinical",
    "equal to  1.05480 kJ; used as a measure of power in the electric power, steam generation, heating, and air conditioning industries",
    "kJ",
    "kJ",
    "1.05480",
    1.0548,
    false,
  ),
  UcumUnit(
    false,
    "British thermal unit at 60°F",
    "[Btu_60]",
    "[BTU_60]",
    "energy",
    1054680,
    [2, -2, 1, 0, 0, 0, 0],
    "Btu<sub>60°F</sub>",
    "heat",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "BTU 60 F; BTU 60F; B.T.U. 60 F; B.Th.U. 60 F; BThU 60 F; British thermal units 60 F"
        .split('; '),
    "UCUM",
    "Eng",
    "Nonclinical",
    "equal to 1.05468 kJ; used as a measure of power in the electric power, steam generation, heating, and air conditioning industries",
    "kJ",
    "kJ",
    "1.05468",
    1.05468,
    false,
  ),
  UcumUnit(
    false,
    "mean British thermal unit",
    "[Btu_m]",
    "[BTU_M]",
    "energy",
    1055870,
    [2, -2, 1, 0, 0, 0, 0],
    "Btu<sub>m</sub>",
    "heat",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "BTU mean; B.T.U. mean; B.Th.U. mean; BThU mean; British thermal units mean; "
        .split('; '),
    "UCUM",
    "Eng",
    "Nonclinical",
    "equal to 1.05587 kJ; used as a measure of power in the electric power, steam generation, heating, and air conditioning industries",
    "kJ",
    "kJ",
    "1.05587",
    1.05587,
    false,
  ),
  UcumUnit(
    false,
    "international table British thermal unit",
    "[Btu_IT]",
    "[BTU_IT]",
    "energy",
    1055055.85262,
    [2, -2, 1, 0, 0, 0, 0],
    "Btu<sub>IT</sub>",
    "heat",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "BTU IT; B.T.U. IT; B.Th.U. IT; BThU IT; British thermal units IT"
        .split('; '),
    "UCUM",
    "Eng",
    "Nonclinical",
    "equal to 1.055 kJ; used as a measure of power in the electric power, steam generation, heating, and air conditioning industries",
    "kJ",
    "kJ",
    "1.05505585262",
    1.05505585262,
    false,
  ),
  UcumUnit(
    false,
    "thermochemical British thermal unit",
    "[Btu_th]",
    "[BTU_TH]",
    "energy",
    1054350,
    [2, -2, 1, 0, 0, 0, 0],
    "Btu<sub>th</sub>",
    "heat",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "BTU Th; B.T.U. Th; B.Th.U. Th; BThU Th; thermochemical British thermal units"
        .split('; '),
    "UCUM",
    "Eng",
    "Nonclinical",
    "equal to 1.054350 kJ; used as a measure of power in the electric power, steam generation, heating, and air conditioning industries",
    "kJ",
    "kJ",
    "1.054350",
    1.05435,
    false,
  ),
  UcumUnit(
    false,
    "British thermal unit",
    "[Btu]",
    "[BTU]",
    "energy",
    1054350,
    [2, -2, 1, 0, 0, 0, 0],
    "btu",
    "heat",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "BTU; B.T.U. ; B.Th.U.; BThU; British thermal units".split('; '),
    "UCUM",
    "Eng",
    "Nonclinical",
    "equal to the thermochemical British thermal unit equal to 1.054350 kJ; used as a measure of power in the electric power, steam generation, heating, and air conditioning industries",
    "[Btu_th]",
    "[BTU_TH]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "horsepower - mechanical",
    "[HP]",
    "[HP]",
    "power",
    745699.8715822703,
    [2, -3, 1, 0, 0, 0, 0],
    null,
    "heat",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "imperial horsepowers",
    ],
    "UCUM",
    "EngRat",
    "Nonclinical",
    "refers to mechanical horsepower, which is unit used to measure engine power primarily in the US. ",
    "[ft_i].[lbf_av]/s",
    "[FT_I].[LBF_AV]/S",
    "550",
    550,
    false,
  ),
  UcumUnit(
    false,
    "tex",
    "tex",
    "TEX",
    "linear mass density (of textile thread)",
    0.001,
    [-1, 0, 1, 0, 0, 0, 0],
    "tex",
    "heat",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "linear mass density; texes".split('; '),
    "UCUM",
    "",
    "Clinical",
    "unit of linear mass density for fibers equal to gram per 1000 meters",
    "g/km",
    "G/KM",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Denier (linear mass density)",
    "[den]",
    "[DEN]",
    "linear mass density (of textile thread)",
    0.0001111111111111111,
    [-1, 0, 1, 0, 0, 0, 0],
    "den",
    "heat",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "den; deniers".split('; '),
    "UCUM",
    "",
    "Nonclinical",
    "equal to the mass in grams per 9000 meters of the fiber (1 denier = 1 strand of silk)",
    "g/9/km",
    "G/9/KM",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "meter of water column",
    "m[H2O]",
    "M[H2O]",
    "pressure",
    9806650,
    [-1, -2, 1, 0, 0, 0, 0],
    "m HO<sub><r>2</r></sub>",
    "clinical",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mH2O; m H2O; meters of water column; metres; pressure".split('; '),
    "UCUM",
    "Pres",
    "Clinical",
    "",
    "kPa",
    "KPAL",
    "980665e-5",
    9.80665,
    false,
  ),
  UcumUnit(
    false,
    "meter of mercury column",
    "m[Hg]",
    "M[HG]",
    "pressure",
    133322e3,
    [-1, -2, 1, 0, 0, 0, 0],
    "m Hg",
    "clinical",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mHg; m Hg; meters of mercury column; metres; pressure".split('; '),
    "UCUM",
    "Pres",
    "Clinical",
    "",
    "kPa",
    "KPAL",
    "133.3220",
    133.322,
    false,
  ),
  UcumUnit(
    false,
    "inch of water column",
    "[in_i'H2O]",
    "[IN_I'H2O]",
    "pressure",
    249088.91000000003,
    [-1, -2, 1, 0, 0, 0, 0],
    "in HO<sub><r>2</r></sub>",
    "clinical",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "inches WC; inAq; in H2O; inch of water gauge; iwg; pressure".split('; '),
    "UCUM",
    "Pres",
    "Clinical",
    "unit of pressure, especially in respiratory and ventilation care",
    "m[H2O].[in_i]/m",
    "M[H2O].[IN_I]/M",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "inch of mercury column",
    "[in_i'Hg]",
    "[IN_I'HG]",
    "pressure",
    3386378.8000000003,
    [-1, -2, 1, 0, 0, 0, 0],
    "in Hg",
    "clinical",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "inHg; in Hg; pressure; inches".split('; '),
    "UCUM",
    "Pres",
    "Clinical",
    "unit of pressure used in US to measure barometric pressure and occasionally blood pressure (see mm[Hg] for unit used internationally)",
    "m[Hg].[in_i]/m",
    "M[HG].[IN_I]/M",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "peripheral vascular resistance unit",
    "[PRU]",
    "[PRU]",
    "fluid resistance",
    133322e6,
    [-4, -1, 1, 0, 0, 0, 0],
    "P.R.U.",
    "clinical",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "peripheral vascular resistance units; peripheral resistance unit; peripheral resistance units; PRU"
        .split('; '),
    "UCUM",
    "FldResist",
    "Clinical",
    "used to assess blood flow in the capillaries; equal to 1 mmH.min/mL = 133.3 Pa·min/mL",
    "mm[Hg].s/ml",
    "MM[HG].S/ML",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Wood unit",
    "[wood'U]",
    "[WOOD'U]",
    "fluid resistance",
    799932e4,
    [-4, -1, 1, 0, 0, 0, 0],
    "Wood U.",
    "clinical",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "hybrid reference units; HRU; mmHg.min/L; vascular resistance".split('; '),
    "UCUM",
    "Pres",
    "Clinical",
    "simplified unit of measurement for for measuring pulmonary vascular resistance that uses pressure; equal to mmHg.min/L",
    "mm[Hg].min/L",
    "MM[HG].MIN/L",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "diopter (lens)",
    "[diop]",
    "[DIOP]",
    "refraction of a lens",
    1,
    [1, 0, 0, 0, 0, 0, 0],
    "dpt",
    "clinical",
    false,
    null,
    "inv",
    1,
    false,
    false,
    0,
    "diopters; diop; dioptre; dpt; refractive power".split('; '),
    "UCUM",
    "InvLen",
    "Clinical",
    "unit of optical power of lens represented by inverse meters (m^-1)",
    "m",
    "/M",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "prism diopter (magnifying power)",
    "[p'diop]",
    "[P'DIOP]",
    "refraction of a prism",
    1,
    [0, 0, 0, 1, 0, 0, 0],
    "PD",
    "clinical",
    false,
    null,
    "tanTimes100",
    1,
    true,
    false,
    0,
    "diopters; dioptres; p diops; pdiop; dpt; pdptr; Δ; cm/m; centimeter per meter; centimetre; metre"
        .split('; '),
    "UCUM",
    "Angle",
    "Clinical",
    "unit for prism correction in eyeglass prescriptions",
    "rad",
    null,
    null,
    1,
    false,
  ),
  UcumUnit(
    false,
    "percent of slope",
    "%[slope]",
    "%[SLOPE]",
    "slope",
    0.017453292519943295,
    [0, 0, 0, 1, 0, 0, 0],
    "%",
    "clinical",
    false,
    null,
    "100tan",
    1,
    true,
    false,
    0,
    "% slope; %slope; percents slopes".split('; '),
    "UCUM",
    "VelFr; ElpotRatFr; VelRtoFr; AccelFr",
    "Clinical",
    "",
    "deg",
    null,
    null,
    1,
    false,
  ),
  UcumUnit(
    false,
    "mesh",
    "[mesh_i]",
    "[MESH_I]",
    "lineic number",
    0.025400000000000002,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "clinical",
    false,
    null,
    "inv",
    1,
    false,
    false,
    0,
    [
      "meshes",
    ],
    "UCUM",
    "NLen (lineic number)",
    "Clinical",
    "traditional unit of length defined as the number of strands or particles per inch",
    "[in_i]",
    "/[IN_I]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "French (catheter gauge) ",
    "[Ch]",
    "[CH]",
    "gauge of catheters",
    0.0003333333333333333,
    [1, 0, 0, 0, 0, 0, 0],
    "Ch",
    "clinical",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "Charrières, French scales; French gauges; Fr, Fg, Ga, FR, Ch".split('; '),
    "UCUM",
    "Len; Circ; Diam",
    "Clinical",
    "",
    "mm/3",
    "MM/3",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "drop - metric (1/20 mL)",
    "[drp]",
    "[DRP]",
    "volume",
    5e-8,
    [3, 0, 0, 0, 0, 0, 0],
    "drp",
    "clinical",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "drop dosing units; metric drops; gtt".split('; '),
    "UCUM",
    "Vol",
    "Clinical",
    "standard unit used in the US and internationally for clinical medicine but note that although [drp] is defined as 1/20 milliliter, in practice, drop sizes will vary due to external factors",
    "ml/20",
    "ML/20",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Hounsfield unit",
    "[hnsf'U]",
    "[HNSF'U]",
    "x-ray attenuation",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "HF",
    "clinical",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "HU; units".split('; '),
    "UCUM",
    "",
    "Clinical",
    "used to measure X-ray attenuation, especially in CT scans.",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Metabolic Equivalent of Task ",
    "[MET]",
    "[MET]",
    "metabolic cost of physical activity",
    5.833333333333334e-11,
    [3, -1, -1, 0, 0, 0, 0],
    "MET",
    "clinical",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "metabolic equivalents",
    ],
    "UCUM",
    "RelEngRat",
    "Clinical",
    "unit used to measure rate of energy expenditure per power in treadmill and other functional tests",
    "mL/min/kg",
    "ML/MIN/KG",
    "3.5",
    3.5,
    false,
  ),
  UcumUnit(
    false,
    "homeopathic potency of decimal series (retired)",
    "[hp'_X]",
    "[HP'_X]",
    "homeopathic potency (retired)",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "X",
    "clinical",
    false,
    null,
    "hpX",
    1,
    true,
    false,
    0,
    null,
    "UCUM",
    null,
    null,
    null,
    "1",
    null,
    null,
    1,
    false,
  ),
  UcumUnit(
    false,
    "homeopathic potency of centesimal series (retired)",
    "[hp'_C]",
    "[HP'_C]",
    "homeopathic potency (retired)",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "C",
    "clinical",
    false,
    null,
    "hpC",
    1,
    true,
    false,
    0,
    null,
    "UCUM",
    null,
    null,
    null,
    "1",
    null,
    null,
    1,
    false,
  ),
  UcumUnit(
    false,
    "homeopathic potency of millesimal series (retired)",
    "[hp'_M]",
    "[HP'_M]",
    "homeopathic potency (retired)",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "M",
    "clinical",
    false,
    null,
    "hpM",
    1,
    true,
    false,
    0,
    null,
    "UCUM",
    null,
    null,
    null,
    "1",
    null,
    null,
    1,
    false,
  ),
  UcumUnit(
    false,
    "homeopathic potency of quintamillesimal series (retired)",
    "[hp'_Q]",
    "[HP'_Q]",
    "homeopathic potency (retired)",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "Q",
    "clinical",
    false,
    null,
    "hpQ",
    1,
    true,
    false,
    0,
    null,
    "UCUM",
    null,
    null,
    null,
    "1",
    null,
    null,
    1,
    false,
  ),
  UcumUnit(
    false,
    "homeopathic potency of decimal hahnemannian series",
    "[hp_X]",
    "[HP_X]",
    "homeopathic potency (Hahnemann)",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "X",
    "clinical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    null,
    "UCUM",
    null,
    null,
    null,
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "homeopathic potency of centesimal hahnemannian series",
    "[hp_C]",
    "[HP_C]",
    "homeopathic potency (Hahnemann)",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "C",
    "clinical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    null,
    "UCUM",
    null,
    null,
    null,
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "homeopathic potency of millesimal hahnemannian series",
    "[hp_M]",
    "[HP_M]",
    "homeopathic potency (Hahnemann)",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "M",
    "clinical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    null,
    "UCUM",
    null,
    null,
    null,
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "homeopathic potency of quintamillesimal hahnemannian series",
    "[hp_Q]",
    "[HP_Q]",
    "homeopathic potency (Hahnemann)",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "Q",
    "clinical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    null,
    "UCUM",
    null,
    null,
    null,
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "homeopathic potency of decimal korsakovian series",
    "[kp_X]",
    "[KP_X]",
    "homeopathic potency (Korsakov)",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "X",
    "clinical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    null,
    "UCUM",
    null,
    null,
    null,
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "homeopathic potency of centesimal korsakovian series",
    "[kp_C]",
    "[KP_C]",
    "homeopathic potency (Korsakov)",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "C",
    "clinical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    null,
    "UCUM",
    null,
    null,
    null,
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "homeopathic potency of millesimal korsakovian series",
    "[kp_M]",
    "[KP_M]",
    "homeopathic potency (Korsakov)",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "M",
    "clinical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    null,
    "UCUM",
    null,
    null,
    null,
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "homeopathic potency of quintamillesimal korsakovian series",
    "[kp_Q]",
    "[KP_Q]",
    "homeopathic potency (Korsakov)",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "Q",
    "clinical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    null,
    "UCUM",
    null,
    null,
    null,
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "equivalent",
    "eq",
    "EQ",
    "amount of substance",
    6.0221367e23,
    [0, 0, 0, 0, 0, 0, 0],
    "eq",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    [
      "equivalents",
    ],
    "UCUM",
    "Sub",
    "Clinical",
    "equivalence equals moles per valence",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "osmole",
    "osm",
    "OSM",
    "amount of substance (dissolved particles)",
    6.0221367e23,
    [0, 0, 0, 0, 0, 0, 0],
    "osm",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "osmoles; osmols".split('; '),
    "UCUM",
    "Osmol",
    "Clinical",
    "the number of moles of solute that contribute to the osmotic pressure of a solution",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "pH",
    "[pH]",
    "[PH]",
    "acidity",
    6.0221366999999994e26,
    [-3, 0, 0, 0, 0, 0, 0],
    "pH",
    "chemical",
    false,
    null,
    "pH",
    1,
    true,
    false,
    0,
    [
      "pH scale",
    ],
    "UCUM",
    "LogCnc",
    "Clinical",
    "Log concentration of H+",
    "mol/l",
    null,
    null,
    1,
    false,
  ),
  UcumUnit(
    false,
    "gram percent",
    "g%",
    "G%",
    "mass concentration",
    1e4,
    [-3, 0, 1, 0, 0, 0, 0],
    "g%",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "gram %; gram%; grams per deciliter; g/dL; gm per dL; gram percents"
        .split('; '),
    "UCUM",
    "MCnc",
    "Clinical",
    "equivalent to unit gram per deciliter (g/dL), a unit often used in medical tests to represent solution concentrations",
    "g/dl",
    "G/DL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Svedberg unit",
    "[S]",
    "[S]",
    "sedimentation coefficient",
    1e-13,
    [0, 1, 0, 0, 0, 0, 0],
    "S",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "Sv; 10^-13 seconds; 100 fs; 100 femtoseconds".split('; '),
    "UCUM",
    "Time",
    "Clinical",
    "unit of time used in measuring particle's sedimentation rate, usually after centrifugation. ",
    "s",
    "10*-13.S",
    "1",
    1e-13,
    false,
  ),
  UcumUnit(
    false,
    "high power field (microscope)",
    "[HPF]",
    "[HPF]",
    "view area in microscope",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "HPF",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "HPF",
    ],
    "UCUM",
    "Area",
    "Clinical",
    "area visible under the maximum magnification power of the objective in microscopy (usually 400x)\n",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "low power field (microscope)",
    "[LPF]",
    "[LPF]",
    "view area in microscope",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "LPF",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "LPF; fields".split('; '),
    "UCUM",
    "Area",
    "Clinical",
    "area visible under the low magnification of the objective in microscopy (usually 100 x)\n",
    "1",
    "1",
    "100",
    100,
    false,
  ),
  UcumUnit(
    false,
    "katal",
    "kat",
    "KAT",
    "catalytic activity",
    6.0221367e23,
    [0, -1, 0, 0, 0, 0, 0],
    "kat",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mol/secs; moles per second; mol*sec-1; mol*s-1; mol.s-1; katals; catalytic activity; enzymatic; enzyme units; activities"
        .split('; '),
    "UCUM",
    "CAct",
    "Clinical",
    "kat is a unit of catalytic activity with base units = mol/s. Rarely used because its units are too large to practically express catalytic activity. See enzyme unit [U] which is the standard unit for catalytic activity.",
    "mol/s",
    "MOL/S",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "enzyme unit",
    "U",
    "U",
    "catalytic activity",
    100368945e8,
    [0, -1, 0, 0, 0, 0, 0],
    "U",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "micromoles per minute; umol/min; umol per minute; umol min-1; enzymatic activity; enzyme activity"
        .split('; '),
    "UCUM",
    "CAct",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min)",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "international unit - arbitrary",
    "[iU]",
    "[IU]",
    "arbitrary",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "IU",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    true,
    0,
    "international units; IE; F2".split('; '),
    "UCUM",
    "Arb",
    "Clinical",
    "International units (IU) are analyte and reference specimen  specific arbitrary units (held at WHO)",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "international unit - arbitrary",
    "[IU]",
    "[IU]",
    "arbitrary",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "i.U.",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    true,
    0,
    "international units; IE; F2".split('; '),
    "UCUM",
    "Arb",
    "Clinical",
    "International units (IU) are analyte and reference specimen  specific arbitrary units (held at WHO)",
    "[iU]",
    "[IU]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "arbitary unit",
    "[arb'U]",
    "[ARB'U]",
    "arbitrary",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "arb. U",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "arbitary units; arb units; arbU".split('; '),
    "UCUM",
    "Arb",
    "Clinical",
    "relative unit of measurement to show the ratio of test measurement to reference measurement",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "United States Pharmacopeia unit",
    "[USP'U]",
    "[USP'U]",
    "arbitrary",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "U.S.P.",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "USP U; USP'U".split('; '),
    "UCUM",
    "Arb",
    "Clinical",
    "a dose unit to express potency of drugs and vitamins defined by the United States Pharmacopoeia; usually 1 USP = 1 IU",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "GPL unit",
    "[GPL'U]",
    "[GPL'U]",
    "biologic activity of anticardiolipin IgG",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "GPL Units; GPL U; IgG anticardiolipin units; IgG Phospholipid".split('; '),
    "UCUM",
    "ACnc; AMass",
    "Clinical",
    "Units for an antiphospholipid test",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "MPL unit",
    "[MPL'U]",
    "[MPL'U]",
    "biologic activity of anticardiolipin IgM",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "MPL units; MPL U; MPL'U; IgM anticardiolipin units; IgM Phospholipid Units "
        .split('; '),
    "UCUM",
    "ACnc",
    "Clinical",
    "units for antiphospholipid test",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "APL unit",
    "[APL'U]",
    "[APL'U]",
    "biologic activity of anticardiolipin IgA",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "APL units; APL U; IgA anticardiolipin; IgA Phospholipid; biologic activity of"
        .split('; '),
    "UCUM",
    "AMass; ACnc",
    "Clinical",
    "Units for an anti phospholipid syndrome test",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Bethesda unit",
    "[beth'U]",
    "[BETH'U]",
    "biologic activity of factor VIII inhibitor",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    [
      "BU",
    ],
    "UCUM",
    "ACnc",
    "Clinical",
    "measures of blood coagulation inhibitior for many blood factors",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "anti factor Xa unit",
    "[anti'Xa'U]",
    "[ANTI'XA'U]",
    "biologic activity of factor Xa inhibitor (heparin)",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    [
      "units",
    ],
    "UCUM",
    "ACnc",
    "Clinical",
    "[anti'Xa'U] unit is equivalent to and can be converted to IU/mL. ",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Todd unit",
    "[todd'U]",
    "[TODD'U]",
    "biologic activity antistreptolysin O",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    [
      "units",
    ],
    "UCUM",
    "InvThres; RtoThres",
    "Clinical",
    "the unit for the results of the testing for antistreptolysin O (ASO)",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Dye unit",
    "[dye'U]",
    "[DYE'U]",
    "biologic activity of amylase",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    [
      "units",
    ],
    "UCUM",
    "CCnc",
    "Obsolete",
    "equivalent to the Somogyi unit, which is an enzyme unit for amylase but better to use U, the standard enzyme unit for measuring catalytic activity",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Somogyi unit",
    "[smgy'U]",
    "[SMGY'U]",
    "biologic activity of amylase",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "Somogyi units; smgy U".split('; '),
    "UCUM",
    "CAct",
    "Clinical",
    "measures the enzymatic activity of amylase in blood serum - better to use base units mg/mL ",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Bodansky unit",
    "[bdsk'U]",
    "[BDSK'U]",
    "biologic activity of phosphatase",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    [
      "",
    ],
    "UCUM",
    "ACnc",
    "Obsolete",
    "Enzyme unit specific to alkaline phosphatase - better to use standard enzyme unit of U",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "King-Armstrong unit",
    "[ka'U]",
    "[KA'U]",
    "biologic activity of phosphatase",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "King-Armstrong Units; King units".split('; '),
    "UCUM",
    "AMass",
    "Obsolete",
    "enzyme units for acid phosphatase - better to use enzyme unit [U]",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Kunkel unit",
    "[knk'U]",
    "[KNK'U]",
    "arbitrary biologic activity",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    null,
    "UCUM",
    null,
    null,
    null,
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Mac Lagan unit",
    "[mclg'U]",
    "[MCLG'U]",
    "arbitrary biologic activity",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "galactose index; galactose tolerance test; thymol turbidity test unit; mclg U; units; indexes"
        .split('; '),
    "UCUM",
    "ACnc",
    "Obsolete",
    "unit for liver tests - previously used in thymol turbidity tests for liver disease diagnoses, and now is sometimes referred to in the oral galactose tolerance test",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "tuberculin unit",
    "[tb'U]",
    "[TB'U]",
    "biologic activity of tuberculin",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "TU; units".split('; '),
    "UCUM",
    "Arb",
    "Clinical",
    "amount of tuberculin antigen -usually in reference to a TB skin test ",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "50% cell culture infectious dose",
    "[CCID_50]",
    "[CCID_50]",
    "biologic activity (infectivity) of an infectious agent preparation",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "CCID<sub>50</sub>",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "CCID50; 50% cell culture infective doses".split('; '),
    "UCUM",
    "NumThres",
    "Clinical",
    "",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "50% tissue culture infectious dose",
    "[TCID_50]",
    "[TCID_50]",
    "biologic activity (infectivity) of an infectious agent preparation",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "TCID<sub>50</sub>",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "TCID50; 50% tissue culture infective dose".split('; '),
    "UCUM",
    "NumThres",
    "Clinical",
    "",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "50% embryo infectious dose",
    "[EID_50]",
    "[EID_50]",
    "biologic activity (infectivity) of an infectious agent preparation",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "EID<sub>50</sub>",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "EID50; 50% embryo infective doses; EID50 Egg Infective Dosage".split('; '),
    "UCUM",
    "thresNum",
    "Clinical",
    "",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "plaque forming units",
    "[PFU]",
    "[PFU]",
    "amount of an infectious agent",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "PFU",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    [
      "PFU",
    ],
    "UCUM",
    "ACnc",
    "Clinical",
    "tests usually report unit as number of PFU per unit volume",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "focus forming units (cells)",
    "[FFU]",
    "[FFU]",
    "amount of an infectious agent",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "FFU",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    [
      "FFU",
    ],
    "UCUM",
    "EntNum",
    "Clinical",
    "",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "colony forming units",
    "[CFU]",
    "[CFU]",
    "amount of a proliferating organism",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "CFU",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    [
      "CFU",
    ],
    "UCUM",
    "Num",
    "Clinical",
    "",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "index of reactivity (allergen)",
    "[IR]",
    "[IR]",
    "amount of an allergen callibrated through in-vivo testing using the Stallergenes® method.",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "IR",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "IR; indexes".split('; '),
    "UCUM",
    "Acnc",
    "Clinical",
    "amount of an allergen callibrated through in-vivo testing using the Stallergenes method. Usually reported in tests as IR/mL",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "bioequivalent allergen unit",
    "[BAU]",
    "[BAU]",
    "amount of an allergen callibrated through in-vivo testing based on the ID50EAL method of (intradermal dilution for 50mm sum of erythema diameters",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "BAU",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "BAU; Bioequivalent Allergy Units; bioequivalent allergen units"
        .split('; '),
    "UCUM",
    "Arb",
    "Clinical",
    "",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "allergy unit",
    "[AU]",
    "[AU]",
    "procedure defined amount of an allergen using some reference standard",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "AU",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "allergy units; allergen units; AU".split('; '),
    "UCUM",
    "Arb",
    "Clinical",
    "Most standard test allergy units are reported as [IU] or as %. ",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "allergen unit for Ambrosia artemisiifolia",
    "[Amb'a'1'U]",
    "[AMB'A'1'U]",
    "procedure defined amount of the major allergen of ragweed.",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "Amb a 1 U",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "Amb a 1 unit; Antigen E; AgE U; allergen units".split('; '),
    "UCUM",
    "Arb",
    "Clinical",
    "Amb a 1 is the major allergen in short ragweed, and can be converted Bioequivalent allergen units (BAU) where 350 Amb a 1 U/mL = 100,000 BAU/mL",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "protein nitrogen unit (allergen testing)",
    "[PNU]",
    "[PNU]",
    "procedure defined amount of a protein substance",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "PNU",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "protein nitrogen units; PNU".split('; '),
    "UCUM",
    "Mass",
    "Clinical",
    "defined as 0.01 ug of phosphotungstic acid-precipitable protein nitrogen. Being replaced by bioequivalent allergy units (BAU).",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Limit of flocculation",
    "[Lf]",
    "[LF]",
    "procedure defined amount of an antigen substance",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "Lf",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    [
      "Lf doses",
    ],
    "UCUM",
    "Arb",
    "Clinical",
    "the antigen content  forming 1:1 ratio against 1 unit of antitoxin",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "D-antigen unit (polio)",
    "[D'ag'U]",
    "[D'AG'U]",
    "procedure defined amount of a poliomyelitis d-antigen substance",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "DAgU; units".split('; '),
    "UCUM",
    "Acnc",
    "Clinical",
    "unit of potency of poliovirus vaccine used for poliomyelitis prevention reported as D antigen units/mL. The unit is poliovirus type-specific.",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "fibrinogen equivalent units",
    "[FEU]",
    "[FEU]",
    "amount of fibrinogen broken down into the measured d-dimers",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    [
      "FEU",
    ],
    "UCUM",
    "MCnc",
    "Clinical",
    "Note both the FEU and DDU units are used to report D-dimer measurements. 1 DDU = 1/2 FFU",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "ELISA unit",
    "[ELU]",
    "[ELU]",
    "arbitrary ELISA unit",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "Enzyme-Linked Immunosorbent Assay Units; ELU; EL. U".split('; '),
    "UCUM",
    "ACnc",
    "Clinical",
    "",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Ehrlich units (urobilinogen)",
    "[EU]",
    "[EU]",
    "Ehrlich unit",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "EU/dL; mg{urobilinogen}/dL".split('; '),
    "UCUM",
    "ACnc",
    "Clinical",
    "",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "neper",
    "Np",
    "NEP",
    "level",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "Np",
    "levels",
    true,
    null,
    "ln",
    1,
    true,
    false,
    0,
    [
      "nepers",
    ],
    "UCUM",
    "LogRto",
    "Clinical",
    "logarithmic unit for ratios of measurements of physical field and power quantities, such as gain and loss of electronic signals",
    "1",
    null,
    null,
    1,
    false,
  ),
  UcumUnit(
    false,
    "bel",
    "B",
    "B",
    "level",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "B",
    "levels",
    true,
    null,
    "lg",
    1,
    true,
    false,
    0,
    [
      "bels",
    ],
    "UCUM",
    "LogRto",
    "Clinical",
    "Logarithm of the ratio of power- or field-type quantities; usually expressed in decibels ",
    "1",
    null,
    null,
    1,
    false,
  ),
  UcumUnit(
    false,
    "bel sound pressure",
    "B[SPL]",
    "B[SPL]",
    "pressure level",
    0.02,
    [-1, -2, 1, 0, 0, 0, 0],
    "B(SPL)",
    "levels",
    true,
    null,
    "lgTimes2",
    1,
    true,
    false,
    0,
    "bel SPL; B SPL; sound pressure bels".split('; '),
    "UCUM",
    "LogRto",
    "Clinical",
    "used to measure sound level in acoustics",
    "Pa",
    null,
    null,
    2e-5,
    false,
  ),
  UcumUnit(
    false,
    "bel volt",
    "B[V]",
    "B[V]",
    "electric potential level",
    1e3,
    [2, -2, 1, 0, 0, -1, 0],
    "B(V)",
    "levels",
    true,
    null,
    "lgTimes2",
    1,
    true,
    false,
    0,
    "bel V; B V; volts bels".split('; '),
    "UCUM",
    "LogRtoElp",
    "Clinical",
    "used to express power gain in electrical circuits",
    "V",
    null,
    null,
    1,
    false,
  ),
  UcumUnit(
    false,
    "bel millivolt",
    "B[mV]",
    "B[MV]",
    "electric potential level",
    1,
    [2, -2, 1, 0, 0, -1, 0],
    "B(mV)",
    "levels",
    true,
    null,
    "lgTimes2",
    1,
    true,
    false,
    0,
    "bel mV; B mV; millivolt bels; 10^-3V bels; 10*-3V ".split('; '),
    "UCUM",
    "LogRtoElp",
    "Clinical",
    "used to express power gain in electrical circuits",
    "mV",
    null,
    null,
    1,
    false,
  ),
  UcumUnit(
    false,
    "bel microvolt",
    "B[uV]",
    "B[UV]",
    "electric potential level",
    0.001,
    [2, -2, 1, 0, 0, -1, 0],
    "B(μV)",
    "levels",
    true,
    null,
    "lgTimes2",
    1,
    true,
    false,
    0,
    "bel uV; B uV; microvolts bels; 10^-6V bel; 10*-6V bel".split('; '),
    "UCUM",
    "LogRto",
    "Clinical",
    "used to express power gain in electrical circuits",
    "uV",
    null,
    null,
    1,
    false,
  ),
  UcumUnit(
    false,
    "bel 10 nanovolt",
    "B[10.nV]",
    "B[10.NV]",
    "electric potential level",
    10000000000000003e-21,
    [2, -2, 1, 0, 0, -1, 0],
    "B(10 nV)",
    "levels",
    true,
    null,
    "lgTimes2",
    1,
    true,
    false,
    0,
    "bel 10 nV; B 10 nV; 10 nanovolts bels".split('; '),
    "UCUM",
    "LogRtoElp",
    "Clinical",
    "used to express power gain in electrical circuits",
    "nV",
    null,
    null,
    10,
    false,
  ),
  UcumUnit(
    false,
    "bel watt",
    "B[W]",
    "B[W]",
    "power level",
    1e3,
    [2, -3, 1, 0, 0, 0, 0],
    "B(W)",
    "levels",
    true,
    null,
    "lg",
    1,
    true,
    false,
    0,
    "bel W; b W; b Watt; Watts bels".split('; '),
    "UCUM",
    "LogRto",
    "Clinical",
    "used to express power",
    "W",
    null,
    null,
    1,
    false,
  ),
  UcumUnit(
    false,
    "bel kilowatt",
    "B[kW]",
    "B[KW]",
    "power level",
    1e6,
    [2, -3, 1, 0, 0, 0, 0],
    "B(kW)",
    "levels",
    true,
    null,
    "lg",
    1,
    true,
    false,
    0,
    "bel kW; B kW; kilowatt bel; kW bel; kW B".split('; '),
    "UCUM",
    "LogRto",
    "Clinical",
    "used to express power",
    "kW",
    null,
    null,
    1,
    false,
  ),
  UcumUnit(
    false,
    "stere",
    "st",
    "STR",
    "volume",
    1,
    [3, 0, 0, 0, 0, 0, 0],
    "st",
    "misc",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "stère; m3; cubic meter; m^3; meters cubed; metre".split('; '),
    "UCUM",
    "Vol",
    "Nonclinical",
    "equal to one cubic meter, usually used for measuring firewoord",
    "m3",
    "M3",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Ångström",
    "Ao",
    "AO",
    "length",
    1.0000000000000002e-10,
    [1, 0, 0, 0, 0, 0, 0],
    "Å",
    "misc",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "Å; Angstroms; Ao; Ångströms".split('; '),
    "UCUM",
    "Len",
    "Clinical",
    "equal to 10^-10 meters; used to express wave lengths and atom scaled differences ",
    "nm",
    "NM",
    "0.1",
    0.1,
    false,
  ),
  UcumUnit(
    false,
    "barn",
    "b",
    "BRN",
    "action area",
    9.999999999999999e-29,
    [2, 0, 0, 0, 0, 0, 0],
    "b",
    "misc",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "barns",
    ],
    "UCUM",
    "Area",
    "Clinical",
    "used in high-energy physics to express cross-sectional areas",
    "fm2",
    "FM2",
    "100",
    100,
    false,
  ),
  UcumUnit(
    false,
    "technical atmosphere",
    "att",
    "ATT",
    "pressure",
    98066499.99999999,
    [-1, -2, 1, 0, 0, 0, 0],
    "at",
    "misc",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "at; tech atm; tech atmosphere; kgf/cm2; atms; atmospheres".split('; '),
    "UCUM",
    "Pres",
    "Obsolete",
    "non-SI unit of pressure equal to one kilogram-force per square centimeter",
    "kgf/cm2",
    "KGF/CM2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "mho",
    "mho",
    "MHO",
    "electric conductance",
    0.001,
    [-2, 1, -1, 0, 0, 2, 0],
    "mho",
    "misc",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "siemens; ohm reciprocals; Ω^−1; Ω-1 ".split('; '),
    "UCUM",
    "",
    "Obsolete",
    "unit of electric conductance (the inverse of electrical resistance) equal to ohm^-1",
    "S",
    "S",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "pound per square inch",
    "[psi]",
    "[PSI]",
    "pressure",
    6894757.293168359,
    [-1, -2, 1, 0, 0, 0, 0],
    "psi",
    "misc",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "psi; lb/in2; lb per in2".split('; '),
    "UCUM",
    "Pres",
    "Clinical",
    "",
    "[lbf_av]/[in_i]2",
    "[LBF_AV]/[IN_I]2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "circle - plane angle",
    "circ",
    "CIRC",
    "plane angle",
    6.283185307179586,
    [0, 0, 0, 1, 0, 0, 0],
    "circ",
    "misc",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "angles; circles".split('; '),
    "UCUM",
    "Angle",
    "Clinical",
    "",
    "[pi].rad",
    "[PI].RAD",
    "2",
    2,
    false,
  ),
  UcumUnit(
    false,
    "spere - solid angle",
    "sph",
    "SPH",
    "solid angle",
    12.566370614359172,
    [0, 0, 0, 2, 0, 0, 0],
    "sph",
    "misc",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "speres",
    ],
    "UCUM",
    "Angle",
    "Clinical",
    "equal to the solid angle of an entire sphere = 4πsr (sr = steradian) ",
    "[pi].sr",
    "[PI].SR",
    "4",
    4,
    false,
  ),
  UcumUnit(
    false,
    "metric carat",
    "[car_m]",
    "[CAR_M]",
    "mass",
    0.2,
    [0, 0, 1, 0, 0, 0, 0],
    "ct<sub>m</sub>",
    "misc",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "carats; ct; car m".split('; '),
    "UCUM",
    "Mass",
    "Nonclinical",
    "unit of mass for gemstones",
    "g",
    "G",
    "2e-1",
    0.2,
    false,
  ),
  UcumUnit(
    false,
    "carat of gold alloys",
    "[car_Au]",
    "[CAR_AU]",
    "mass fraction",
    0.041666666666666664,
    [0, 0, 0, 0, 0, 0, 0],
    "ct<sub><r>Au</r></sub>",
    "misc",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "karats; k; kt; car au; carats".split('; '),
    "UCUM",
    "MFr",
    "Nonclinical",
    "unit of purity for gold alloys",
    "/24",
    "/24",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Smoot",
    "[smoot]",
    "[SMOOT]",
    "length",
    1.7018000000000002,
    [1, 0, 0, 0, 0, 0, 0],
    null,
    "misc",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "",
    ],
    "UCUM",
    "Len",
    "Nonclinical",
    "prank unit of length from MIT",
    "[in_i]",
    "[IN_I]",
    "67",
    67,
    false,
  ),
  UcumUnit(
    false,
    "meter per square seconds per square root of hertz",
    "[m/s2/Hz^(1/2)]",
    "[M/S2/HZ^(1/2)]",
    "amplitude spectral density",
    1,
    [2, -3, 0, 0, 0, 0, 0],
    null,
    "misc",
    false,
    null,
    "sqrt",
    1,
    true,
    false,
    0,
    "m/s2/(Hz^.5); m/s2/(Hz^(1/2)); m per s2 per Hz^1/2".split('; '),
    "UCUM",
    "",
    "Constant",
    "measures amplitude spectral density, and is equal to the square root of power spectral density\n ",
    "m2/s4/Hz",
    null,
    null,
    1,
    false,
  ),
  UcumUnit(
    false,
    "bit - logarithmic",
    "bit_s",
    "BIT_S",
    "amount of information",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "bit<sub>s</sub>",
    "infotech",
    false,
    null,
    "ld",
    1,
    true,
    false,
    0,
    "bit-s; bit s; bit logarithmic".split('; '),
    "UCUM",
    "LogA",
    "Nonclinical",
    "defined as the log base 2 of the number of distinct signals; cannot practically be used to express more than 1000 bits\n\nIn information theory, the definition of the amount of self-information and information entropy is often expressed with the binary logarithm (log base 2)",
    "1",
    null,
    null,
    1,
    false,
  ),
  UcumUnit(
    false,
    "bit",
    "bit",
    "BIT",
    "amount of information",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "bit",
    "infotech",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "bits",
    ],
    "UCUM",
    "",
    "Nonclinical",
    "dimensionless information unit of 1 used in computing and digital communications",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "byte",
    "By",
    "BY",
    "amount of information",
    8,
    [0, 0, 0, 0, 0, 0, 0],
    "B",
    "infotech",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "bytes",
    ],
    "UCUM",
    "",
    "Nonclinical",
    "equal to 8 bits",
    "bit",
    "bit",
    "8",
    8,
    false,
  ),
  UcumUnit(
    false,
    "baud",
    "Bd",
    "BD",
    "signal transmission rate",
    1,
    [0, 1, 0, 0, 0, 0, 0],
    "Bd",
    "infotech",
    true,
    null,
    "inv",
    1,
    false,
    false,
    0,
    "Bd; bauds".split('; '),
    "UCUM",
    "Freq",
    "Nonclinical",
    "unit to express rate in symbols per second or pulses per second. ",
    "s",
    "/s",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "per twelve hour",
    "/(12.h)",
    "/HR",
    "",
    23148148148148147e-21,
    [0, -1, 0, 0, 0, 0, 0],
    "/h",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "per 12 hours; 12hrs; 12 hrs; /12hrs".split('; '),
    "LOINC",
    "Rat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per arbitrary unit",
    "/[arb'U]",
    "/[ARB'U]",
    "",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "/arb/ U",
    null,
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    [
      "/arbU",
    ],
    "LOINC",
    "InvA ",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per high power field",
    "/[HPF]",
    "/[HPF]",
    "",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "/HPF",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/HPF; per HPF".split('; '),
    "LOINC",
    "Naric",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per international unit",
    "/[IU]",
    "/[IU]",
    "",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "/i/U.",
    null,
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "international units; /IU; per IU".split('; '),
    "LOINC",
    "InvA",
    "Clinical",
    "International units (IU) are analyte and reference specimen  specific arbitrary units (held at WHO)",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per low power field",
    "/[LPF]",
    "/[LPF]",
    "",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "/LPF",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/LPF; per LPF".split('; '),
    "LOINC",
    "Naric",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per 10 billion  ",
    "/10*10",
    "/10*10",
    "",
    1e-10,
    [0, 0, 0, 0, 0, 0, 0],
    "/10<sup>10<.sup>",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/10^10; per 10*10".split('; '),
    "LOINC",
    "NFr",
    "Clinical",
    "used for counting entities, e.g. blood cells; usually these kinds of terms have numerators such as moles or milligrams, and counting that amount per the number in the denominator",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per trillion ",
    "/10*12",
    "/10*12",
    "",
    1e-12,
    [0, 0, 0, 0, 0, 0, 0],
    "/10<sup>12<.sup>",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/10^12; per 10*12".split('; '),
    "LOINC",
    "NFr",
    "Clinical",
    "used for counting entities, e.g. blood cells; usually these kinds of terms have numerators such as moles or milligrams, and counting that amount per the number in the denominator",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per thousand",
    "/10*3",
    "/10*3",
    "",
    0.001,
    [0, 0, 0, 0, 0, 0, 0],
    "/10<sup>3<.sup>",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/10^3; per 10*3".split('; '),
    "LOINC",
    "NFr",
    "Clinical",
    "used for counting entities, e.g. blood cells; usually these kinds of terms have numerators such as moles or milligrams, and counting that amount per the number in the denominator",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per million",
    "/10*6",
    "/10*6",
    "",
    1e-6,
    [0, 0, 0, 0, 0, 0, 0],
    "/10<sup>6<.sup>",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/10^6; per 10*6;".split('; '),
    "LOINC",
    "NFr",
    "Clinical",
    "used for counting entities, e.g. blood cells; usually these kinds of terms have numerators such as moles or milligrams, and counting that amount per the number in the denominator",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per billion",
    "/10*9",
    "/10*9",
    "",
    1e-9,
    [0, 0, 0, 0, 0, 0, 0],
    "/10<sup>9<.sup>",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/10^9; per 10*9".split('; '),
    "LOINC",
    "NFr",
    "Clinical",
    "used for counting entities, e.g. blood cells; usually these kinds of terms have numerators such as moles or milligrams, and counting that amount per the number in the denominator",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per 100",
    "/100",
    "",
    "",
    0.01,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "per hundred; 10^2; 10*2".split('; '),
    "LOINC",
    "NFr",
    "Clinical",
    "used for counting entities, e.g. blood cells; usually these kinds of terms have numerators such as moles or milligrams, and counting that amount per the number in the denominator",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per 100 cells",
    "/100{cells}",
    "",
    "",
    0.01,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/100 cells; /100cells; per hundred".split('; '),
    "LOINC",
    "EntMass; EntNum; NFr",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per 100 neutrophils",
    "/100{neutrophils}",
    "",
    "",
    0.01,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/100 neutrophils; /100neutrophils; per hundred".split('; '),
    "LOINC",
    "EntMass; EntNum; NFr",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per 100 spermatozoa",
    "/100{spermatozoa}",
    "",
    "",
    0.01,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/100 spermatozoa; /100spermatozoa; per hundred".split('; '),
    "LOINC",
    "NFr",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per 100 white blood cells",
    "/100{WBCs}",
    "",
    "",
    0.01,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/100 WBCs; /100WBCs; per hundred".split('; '),
    "LOINC",
    "Ratio; NFr",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per year",
    "/a",
    "/ANN",
    "",
    3.168808781402895e-8,
    [0, -1, 0, 0, 0, 0, 0],
    "/a",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/Years; /yrs; yearly".split('; '),
    "LOINC",
    "NRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per centimeter of water",
    "/cm[H2O]",
    "/CM[H2O]",
    "",
    10197162129779282e-21,
    [1, 2, -1, 0, 0, 0, 0],
    "/cm HO<sub><r>2<.r></sub>",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/cmH2O; /cm H2O; centimeters; centimetres".split('; '),
    "LOINC",
    "InvPress",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per day",
    "/d",
    "/D",
    "",
    11574074074074073e-21,
    [0, -1, 0, 0, 0, 0, 0],
    "/d",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/dy; per day".split('; '),
    "LOINC",
    "NRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per deciliter",
    "/dL",
    "/DL",
    "",
    1e4,
    [-3, 0, 0, 0, 0, 0, 0],
    "/dL",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "per dL; /deciliter; decilitre".split('; '),
    "LOINC",
    "NCnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per gram",
    "/g",
    "/G",
    "",
    1,
    [0, 0, -1, 0, 0, 0, 0],
    "/g",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/gm; /gram; per g".split('; '),
    "LOINC",
    "NCnt",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per hour",
    "/h",
    "/HR",
    "",
    0.0002777777777777778,
    [0, -1, 0, 0, 0, 0, 0],
    "/h",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/hr; /hour; per hr".split('; '),
    "LOINC",
    "NRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per kilogram",
    "/kg",
    "/KG",
    "",
    0.001,
    [0, 0, -1, 0, 0, 0, 0],
    "/kg",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "per kg; per kilogram".split('; '),
    "LOINC",
    "NCnt",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per liter",
    "/L",
    "/L",
    "",
    1e3,
    [-3, 0, 0, 0, 0, 0, 0],
    "/L",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/liter; litre".split('; '),
    "LOINC",
    "NCnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per square meter",
    "/m2",
    "/M2",
    "",
    1,
    [-2, 0, 0, 0, 0, 0, 0],
    "/m<sup>2<.sup>",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/m^2; /m*2; /sq. m; per square meter; meter squared; metre".split('; '),
    "LOINC",
    "Naric",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per cubic meter",
    "/m3",
    "/M3",
    "",
    1,
    [-3, 0, 0, 0, 0, 0, 0],
    "/m<sup>3<.sup>",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/m^3; /m*3; /cu. m; per cubic meter; meter cubed; per m3; metre"
        .split('; '),
    "LOINC",
    "NCncn",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per milligram",
    "/mg",
    "/MG",
    "",
    1e3,
    [0, 0, -1, 0, 0, 0, 0],
    "/mg",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/milligram; per mg".split('; '),
    "LOINC",
    "NCnt",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per minute",
    "/min",
    "/MIN",
    "",
    0.016666666666666666,
    [0, -1, 0, 0, 0, 0, 0],
    "/min",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/minute; per mins; breaths beats per minute".split('; '),
    "LOINC",
    "NRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per milliliter",
    "/mL",
    "/ML",
    "",
    1e6,
    [-3, 0, 0, 0, 0, 0, 0],
    "/mL",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/milliliter; per mL; millilitre".split('; '),
    "LOINC",
    "NCncn",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per millimeter",
    "/mm",
    "/MM",
    "",
    1e3,
    [-1, 0, 0, 0, 0, 0, 0],
    "/mm",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/millimeter; per mm; millimetre".split('; '),
    "LOINC",
    "InvLen",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per month",
    "/mo",
    "/MO",
    "",
    3.802570537683474e-7,
    [0, -1, 0, 0, 0, 0, 0],
    "/mo",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/month; per mo; monthly; month".split('; '),
    "LOINC",
    "NRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per second",
    "/s",
    "/S",
    "",
    1,
    [0, -1, 0, 0, 0, 0, 0],
    "/s",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/second; /sec; per sec; frequency; Hertz; Herz; Hz; becquerels; Bq; s-1; s^-1"
        .split('; '),
    "LOINC",
    "NRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per enzyme unit",
    "/U",
    "/U",
    "",
    9.963241120049633e-17,
    [0, 1, 0, 0, 0, 0, 0],
    "/U",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    -1,
    "/enzyme units; per U".split('; '),
    "LOINC",
    "InvC; NCat",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min)",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per microliter",
    "/uL",
    "/UL",
    "",
    999999999.9999999,
    [-3, 0, 0, 0, 0, 0, 0],
    "/μL",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/microliter; microlitre; /mcl; per uL".split('; '),
    "LOINC",
    "ACnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "per week",
    "/wk",
    "/WK",
    "",
    16534391534391535e-22,
    [0, -1, 0, 0, 0, 0, 0],
    "/wk",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "/week; per wk; weekly, weeks".split('; '),
    "LOINC",
    "NRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "APL unit per milliliter",
    "[APL'U]/mL",
    "[APL'U]/ML",
    "biologic activity of anticardiolipin IgA",
    1e6,
    [-3, 0, 0, 0, 0, 0, 0],
    "/mL",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "APL/mL; APL'U/mL; APL U/mL; APL/milliliter; IgA anticardiolipin units per milliliter; IgA Phospholipid Units; millilitre; biologic activity of"
        .split('; '),
    "LOINC",
    "ACnc",
    "Clinical",
    "Units for an anti phospholipid syndrome test",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "arbitrary unit per milliliter",
    "[arb'U]/mL",
    "[ARB'U]/ML",
    "arbitrary",
    1e6,
    [-3, 0, 0, 0, 0, 0, 0],
    "(arb. U)/mL",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "arb'U/mL; arbU/mL; arb U/mL; arbitrary units per milliliter; millilitre"
        .split('; '),
    "LOINC",
    "ACnc",
    "Clinical",
    "relative unit of measurement to show the ratio of test measurement to reference measurement",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "colony forming units per liter",
    "[CFU]/L",
    "[CFU]/L",
    "amount of a proliferating organism",
    1e3,
    [-3, 0, 0, 0, 0, 0, 0],
    "CFU/L",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "CFU per Liter; CFU/L".split('; '),
    "LOINC",
    "NCnc",
    "Clinical",
    "",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "colony forming units per milliliter",
    "[CFU]/mL",
    "[CFU]/ML",
    "amount of a proliferating organism",
    1e6,
    [-3, 0, 0, 0, 0, 0, 0],
    "CFU/mL",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "CFU per mL; CFU/mL".split('; '),
    "LOINC",
    "NCnc",
    "Clinical",
    "",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "foot per foot - US",
    "[ft_us]/[ft_us]",
    "[FT_US]/[FT_US]",
    "length",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "(ft<sub>us</sub>)/(ft<sub>us</sub>)",
    "us-lengths",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "ft/ft; ft per ft; feet per feet; visual acuity".split('; '),
    "",
    "LenRto",
    "Clinical",
    "distance ratio to measure 20:20 vision",
    "m/3937",
    "M/3937",
    "1200",
    1200,
    false,
  ),
  UcumUnit(
    false,
    "GPL unit per milliliter",
    "[GPL'U]/mL",
    "[GPL'U]/ML",
    "biologic activity of anticardiolipin IgG",
    1e6,
    [-3, 0, 0, 0, 0, 0, 0],
    "/mL",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "GPL U/mL; GPL'U/mL; GPL/mL; GPL U per mL; IgG Phospholipid Units per milliliters; IgG anticardiolipin units; millilitres "
        .split('; '),
    "LOINC",
    "ACnc; AMass",
    "Clinical",
    "Units for an antiphospholipid test",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "international unit per 2 hour",
    "[IU]/(2.h)",
    "[IU]/HR",
    "arbitrary",
    0.0001388888888888889,
    [0, -1, 0, 0, 0, 0, 0],
    "(i.U.)/h",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    true,
    0,
    "IU/2hrs; IU/2 hours; IU per 2 hrs; international units per 2 hours"
        .split('; '),
    "LOINC",
    "ARat",
    "Clinical",
    "International units (IU) are analyte and reference specimen  specific arbitrary units (held at WHO)",
    "[iU]",
    "[IU]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "international unit per 24 hour",
    "[IU]/(24.h)",
    "[IU]/HR",
    "arbitrary",
    11574074074074073e-21,
    [0, -1, 0, 0, 0, 0, 0],
    "(i.U.)/h",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    true,
    0,
    "IU/24hr; IU/24 hours; IU per 24 hrs; international units per 24 hours"
        .split('; '),
    "LOINC",
    "ARat",
    "Clinical",
    "International units (IU) are analyte and reference specimen  specific arbitrary units (held at WHO)",
    "[iU]",
    "[IU]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "international unit per day",
    "[IU]/d",
    "[IU]/D",
    "arbitrary",
    11574074074074073e-21,
    [0, -1, 0, 0, 0, 0, 0],
    "(i.U.)/d",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    true,
    0,
    "IU/dy; IU/days; IU per dys; international units per day".split('; '),
    "LOINC",
    "ARat",
    "Clinical",
    "International units (IU) are analyte and reference specimen  specific arbitrary units (held at WHO)",
    "[iU]",
    "[IU]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "international unit per deciliter",
    "[IU]/dL",
    "[IU]/DL",
    "arbitrary",
    1e4,
    [-3, 0, 0, 0, 0, 0, 0],
    "(i.U.)/dL",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    true,
    0,
    "IU/dL; IU per dL; international units per deciliters; decilitres"
        .split('; '),
    "LOINC",
    "ACnc",
    "Clinical",
    "International units (IU) are analyte and reference specimen  specific arbitrary units (held at WHO)",
    "[iU]",
    "[IU]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "international unit per gram",
    "[IU]/g",
    "[IU]/G",
    "arbitrary",
    1,
    [0, 0, -1, 0, 0, 0, 0],
    "(i.U.)/g",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    true,
    0,
    "IU/gm; IU/gram; IU per gm; IU per g; international units per gram"
        .split('; '),
    "LOINC",
    "ACnt",
    "Clinical",
    "International units (IU) are analyte and reference specimen  specific arbitrary units (held at WHO)",
    "[iU]",
    "[IU]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "international unit per hour",
    "[IU]/h",
    "[IU]/HR",
    "arbitrary",
    0.0002777777777777778,
    [0, -1, 0, 0, 0, 0, 0],
    "(i.U.)/h",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    true,
    0,
    "IU/hrs; IU per hours; international units per hour".split('; '),
    "LOINC",
    "ARat",
    "Clinical",
    "International units (IU) are analyte and reference specimen  specific arbitrary units (held at WHO)",
    "[iU]",
    "[IU]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "international unit per kilogram",
    "[IU]/kg",
    "[IU]/KG",
    "arbitrary",
    0.001,
    [0, 0, -1, 0, 0, 0, 0],
    "(i.U.)/kg",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    true,
    0,
    "IU/kg; IU/kilogram; IU per kg; units".split('; '),
    "LOINC",
    "ACnt",
    "Clinical",
    "International units (IU) are analyte and reference specimen  specific arbitrary units (held at WHO)",
    "[iU]",
    "[IU]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "international unit per kilogram per day",
    "[IU]/kg/d",
    "[IU]/KG/D",
    "arbitrary",
    1.1574074074074074e-8,
    [0, -1, -1, 0, 0, 0, 0],
    "(i.U.)/kg/d",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    true,
    0,
    "IU/kg/dy; IU/kg/day; IU/kilogram/day; IU per kg per day; units"
        .split('; '),
    "LOINC",
    "ACntRat",
    "Clinical",
    "International units (IU) are analyte and reference specimen  specific arbitrary units (held at WHO)",
    "[iU]",
    "[IU]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "international unit per liter",
    "[IU]/L",
    "[IU]/L",
    "arbitrary",
    1e3,
    [-3, 0, 0, 0, 0, 0, 0],
    "(i.U.)/L",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    true,
    0,
    "IU/L; IU/liter; IU per liter; units; litre".split('; '),
    "LOINC",
    "ACnc",
    "Clinical",
    "International units (IU) are analyte and reference specimen  specific arbitrary units (held at WHO)",
    "[iU]",
    "[IU]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "international unit per minute",
    "[IU]/min",
    "[IU]/MIN",
    "arbitrary",
    0.016666666666666666,
    [0, -1, 0, 0, 0, 0, 0],
    "(i.U.)/min",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    true,
    0,
    "IU/min; IU/minute; IU per minute; international units".split('; '),
    "LOINC",
    "ARat",
    "Clinical",
    "International units (IU) are analyte and reference specimen  specific arbitrary units (held at WHO)",
    "[iU]",
    "[IU]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "international unit per milliliter",
    "[IU]/mL",
    "[IU]/ML",
    "arbitrary",
    1e6,
    [-3, 0, 0, 0, 0, 0, 0],
    "(i.U.)/mL",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    true,
    0,
    "IU/mL; IU per mL; international units per milliliter; millilitre"
        .split('; '),
    "LOINC",
    "ACnc",
    "Clinical",
    "International units (IU) are analyte and reference specimen  specific arbitrary units (held at WHO)",
    "[iU]",
    "[IU]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "MPL unit per milliliter",
    "[MPL'U]/mL",
    "[MPL'U]/ML",
    "biologic activity of anticardiolipin IgM",
    1e6,
    [-3, 0, 0, 0, 0, 0, 0],
    "/mL",
    "chemical",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "MPL/mL; MPL U/mL; MPL'U/mL; IgM anticardiolipin units; IgM Phospholipid Units; millilitre "
        .split('; '),
    "LOINC",
    "ACnc",
    "Clinical",
    "units for antiphospholipid test\n",
    "1",
    "1",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "number per high power field",
    "{#}/[HPF]",
    "/[HPF]",
    "",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "/HPF",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "#/HPF; # per HPF; number/HPF; numbers per high power field".split('; '),
    "LOINC",
    "Naric",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "number per low power field",
    "{#}/[LPF]",
    "/[LPF]",
    "",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "/LPF",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "#/LPF; # per LPF; number/LPF; numbers per low power field".split('; '),
    "LOINC",
    "Naric",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "IgA antiphosphatidylserine unit ",
    "{APS'U}",
    "",
    "",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "APS Unit; Phosphatidylserine Antibody IgA Units".split('; '),
    "LOINC",
    "ACnc",
    "Clinical",
    "unit for antiphospholipid test",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "EIA index",
    "{EIA_index}",
    "",
    "",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "enzyme immunoassay index",
    ],
    "LOINC",
    "ACnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "kaolin clotting time",
    "{KCT'U}",
    "",
    "",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "KCT",
    ],
    "LOINC",
    "Time",
    "Clinical",
    "sensitive test to detect lupus anticoagulants; measured in seconds",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "IgM antiphosphatidylserine unit",
    "{MPS'U}",
    "",
    "",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    null,
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "Phosphatidylserine Antibody IgM Measurement ",
    ],
    "LOINC",
    "ACnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "trillion per liter",
    "10*12/L",
    "(10*12)/L",
    "number",
    1e15,
    [-3, 0, 0, 0, 0, 0, 0],
    "(10<sup>12</sup>)/L",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "10^12/L; 10*12 per Liter; trillion per liter; litre".split('; '),
    "LOINC",
    "NCncn",
    "Clinical",
    "",
    "1",
    "1",
    "10",
    10,
    false,
  ),
  UcumUnit(
    false,
    "10^3 (used for cell count)",
    "10*3",
    "10*3",
    "number",
    1e3,
    [0, 0, 0, 0, 0, 0, 0],
    "10<sup>3</sup>",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "10^3; thousand".split('; '),
    "LOINC",
    "Num",
    "Clinical",
    "usually used for counting entities (e.g. blood cells) per volume",
    "1",
    "1",
    "10",
    10,
    false,
  ),
  UcumUnit(
    false,
    "thousand per liter",
    "10*3/L",
    "(10*3)/L",
    "number",
    1e6,
    [-3, 0, 0, 0, 0, 0, 0],
    "(10<sup>3</sup>)/L",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "10^3/L; 10*3 per liter; litre".split('; '),
    "LOINC",
    "NCncn",
    "Clinical",
    "",
    "1",
    "1",
    "10",
    10,
    false,
  ),
  UcumUnit(
    false,
    "thousand per milliliter",
    "10*3/mL",
    "(10*3)/ML",
    "number",
    1e9,
    [-3, 0, 0, 0, 0, 0, 0],
    "(10<sup>3</sup>)/mL",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "10^3/mL; 10*3 per mL; thousand per milliliter; millilitre".split('; '),
    "LOINC",
    "NCncn",
    "Clinical",
    "",
    "1",
    "1",
    "10",
    10,
    false,
  ),
  UcumUnit(
    false,
    "thousand per microliter",
    "10*3/uL",
    "(10*3)/UL",
    "number",
    999999999999.9999,
    [-3, 0, 0, 0, 0, 0, 0],
    "(10<sup>3</sup>)/μL",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "10^3/uL; 10*3 per uL; thousand per microliter; microlitre".split('; '),
    "LOINC",
    "NCncn",
    "Clinical",
    "",
    "1",
    "1",
    "10",
    10,
    false,
  ),
  UcumUnit(
    false,
    "10 thousand per microliter",
    "10*4/uL",
    "(10*4)/UL",
    "number",
    1e13,
    [-3, 0, 0, 0, 0, 0, 0],
    "(10<sup>4</sup>)/μL",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "10^4/uL; 10*4 per uL; microlitre".split('; '),
    "LOINC",
    "NCncn",
    "Clinical",
    "",
    "1",
    "1",
    "10",
    10,
    false,
  ),
  UcumUnit(
    false,
    "10^5 ",
    "10*5",
    "10*5",
    "number",
    1e5,
    [0, 0, 0, 0, 0, 0, 0],
    "10<sup>5</sup>",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "one hundred thousand",
    ],
    "LOINC",
    "Num",
    "Clinical",
    "",
    "1",
    "1",
    "10",
    10,
    false,
  ),
  UcumUnit(
    false,
    "10^6",
    "10*6",
    "10*6",
    "number",
    1e6,
    [0, 0, 0, 0, 0, 0, 0],
    "10<sup>6</sup>",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "",
    ],
    "LOINC",
    "Num",
    "Clinical",
    "",
    "1",
    "1",
    "10",
    10,
    false,
  ),
  UcumUnit(
    false,
    "million colony forming unit per liter",
    "10*6.[CFU]/L",
    "(10*6).[CFU]/L",
    "number",
    1e9,
    [-3, 0, 0, 0, 0, 0, 0],
    "(10<sup>6</sup>).CFU/L",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "10*6 CFU/L; 10^6 CFU/L; 10^6CFU; 10^6 CFU per liter; million colony forming units; litre"
        .split('; '),
    "LOINC",
    "ACnc",
    "Clinical",
    "",
    "1",
    "1",
    "10",
    10,
    false,
  ),
  UcumUnit(
    false,
    "million international unit",
    "10*6.[IU]",
    "(10*6).[IU]",
    "number",
    1e6,
    [0, 0, 0, 0, 0, 0, 0],
    "(10<sup>6</sup>).(i.U.)",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    true,
    0,
    "10*6 IU; 10^6 IU; international units".split('; '),
    "LOINC",
    "arb",
    "Clinical",
    "International units (IU) are analyte and reference specimen  specific arbitrary units (held at WHO)",
    "1",
    "1",
    "10",
    10,
    false,
  ),
  UcumUnit(
    false,
    "million per 24 hour",
    "10*6/(24.h)",
    "(10*6)/HR",
    "number",
    11.574074074074074,
    [0, -1, 0, 0, 0, 0, 0],
    "(10<sup>6</sup>)/h",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "10*6/24hrs; 10^6/24 hrs; 10*6 per 24 hrs; 10^6 per 24 hours".split('; '),
    "LOINC",
    "NRat",
    "Clinical",
    "",
    "1",
    "1",
    "10",
    10,
    false,
  ),
  UcumUnit(
    false,
    "million per kilogram",
    "10*6/kg",
    "(10*6)/KG",
    "number",
    1e3,
    [0, 0, -1, 0, 0, 0, 0],
    "(10<sup>6</sup>)/kg",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "10^6/kg; 10*6 per kg; 10*6 per kilogram; millions".split('; '),
    "LOINC",
    "NCnt",
    "Clinical",
    "",
    "1",
    "1",
    "10",
    10,
    false,
  ),
  UcumUnit(
    false,
    "million per liter",
    "10*6/L",
    "(10*6)/L",
    "number",
    1e9,
    [-3, 0, 0, 0, 0, 0, 0],
    "(10<sup>6</sup>)/L",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "10^6/L; 10*6 per Liter; 10^6 per Liter; litre".split('; '),
    "LOINC",
    "NCncn",
    "Clinical",
    "",
    "1",
    "1",
    "10",
    10,
    false,
  ),
  UcumUnit(
    false,
    "million per milliliter",
    "10*6/mL",
    "(10*6)/ML",
    "number",
    1e12,
    [-3, 0, 0, 0, 0, 0, 0],
    "(10<sup>6</sup>)/mL",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "10^6/mL; 10*6 per mL; 10*6 per milliliter; millilitre".split('; '),
    "LOINC",
    "NCncn",
    "Clinical",
    "",
    "1",
    "1",
    "10",
    10,
    false,
  ),
  UcumUnit(
    false,
    "million per microliter",
    "10*6/uL",
    "(10*6)/UL",
    "number",
    1e15,
    [-3, 0, 0, 0, 0, 0, 0],
    "(10<sup>6</sup>)/μL",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "10^6/uL; 10^6 per uL; 10^6/mcl; 10^6 per mcl; 10^6 per microliter; microlitre"
        .split('; '),
    "LOINC",
    "NCncn",
    "Clinical",
    "",
    "1",
    "1",
    "10",
    10,
    false,
  ),
  UcumUnit(
    false,
    "10^8",
    "10*8",
    "10*8",
    "number",
    1e8,
    [0, 0, 0, 0, 0, 0, 0],
    "10<sup>8</sup>",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "100 million; one hundred million; 10^8".split('; '),
    "LOINC",
    "Num",
    "Clinical",
    "",
    "1",
    "1",
    "10",
    10,
    false,
  ),
  UcumUnit(
    false,
    "billion per liter",
    "10*9/L",
    "(10*9)/L",
    "number",
    1e12,
    [-3, 0, 0, 0, 0, 0, 0],
    "(10<sup>9</sup>)/L",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "10^9/L; 10*9 per Liter; litre".split('; '),
    "LOINC",
    "NCncn",
    "Clinical",
    "",
    "1",
    "1",
    "10",
    10,
    false,
  ),
  UcumUnit(
    false,
    "billion per milliliter",
    "10*9/mL",
    "(10*9)/ML",
    "number",
    1e15,
    [-3, 0, 0, 0, 0, 0, 0],
    "(10<sup>9</sup>)/mL",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "10^9/mL; 10*9 per mL; 10^9 per mL; 10*9 per milliliter; millilitre"
        .split('; '),
    "LOINC",
    "NCncn",
    "Clinical",
    "",
    "1",
    "1",
    "10",
    10,
    false,
  ),
  UcumUnit(
    false,
    "billion per microliter",
    "10*9/uL",
    "(10*9)/UL",
    "number",
    1e18,
    [-3, 0, 0, 0, 0, 0, 0],
    "(10<sup>9</sup>)/μL",
    "dimless",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "10^9/uL; 10^9 per uL; 10^9/mcl; 10^9 per mcl; 10*9 per uL; 10*9 per mcl; 10*9/mcl; 10^9 per microliter; microlitre"
        .split('; '),
    "LOINC",
    "NCncn",
    "Clinical",
    "",
    "1",
    "1",
    "10",
    10,
    false,
  ),
  UcumUnit(
    false,
    "10 liter per minute per square meter",
    "10.L/(min.m2)",
    "L/(MIN.M2)",
    "",
    0.00016666666666666666,
    [1, -1, 0, 0, 0, 0, 0],
    "L/(min.(m<sup>2</sup>))",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "10 liters per minutes per square meter; 10 L per min per m2; m^2; 10 L/(min*m2); 10L/(min*m^2); litres; sq. meter; metre; meters squared"
        .split('; '),
    "LOINC",
    "ArVRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "10 liter per minute",
    "10.L/min",
    "L/MIN",
    "",
    0.00016666666666666666,
    [3, -1, 0, 0, 0, 0, 0],
    "L/min",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "10 liters per minute; 10 L per min; 10L; 10 L/min; litre".split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "10 micronewton second per centimeter to the fifth power per square meter",
    "10.uN.s/(cm5.m2)",
    "(UN.S)/(CM5.M2)",
    "",
    1e8,
    [-6, -1, 1, 0, 0, 0, 0],
    "(μN.s)/(cm<sup>5</sup>).(m<sup>2</sup>)",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "dyne seconds per centimeter5 and square meter; dyn.s/(cm5.m2); dyn.s/cm5/m2; cm^5; m^2"
        .split('; '),
    "LOINC",
    "",
    "Clinical",
    "unit to measure systemic vascular resistance per body surface area",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "24 hour",
    "24.h",
    "HR",
    "",
    86400,
    [0, 1, 0, 0, 0, 0, 0],
    "h",
    null,
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "24hrs; 24 hrs; 24 hours; days; dy".split('; '),
    "LOINC",
    "Time",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "ampere per meter",
    "A/m",
    "A/M",
    "electric current",
    1,
    [-1, -1, 0, 0, 0, 1, 0],
    "A/m",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "A/m; amp/meter; magnetic field strength; H; B; amperes per meter; metre"
        .split('; '),
    "LOINC",
    "",
    "Clinical",
    "unit of magnetic field strength",
    "C/s",
    "C/S",
    "1",
    1,
    false,
  ),
  UcumUnit(
    true,
    "centigram",
    "cg",
    "CG",
    "mass",
    0.01,
    [0, 0, 1, 0, 0, 0, 0],
    "cg",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "centigrams; cg; cgm".split('; '),
    "LOINC",
    "Mass",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "centiliter",
    "cL",
    "CL",
    "volume",
    1e-5,
    [3, 0, 0, 0, 0, 0, 0],
    "cL",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "centiliters; centilitres".split('; '),
    "LOINC",
    "Vol",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    true,
    "centimeter",
    "cm",
    "CM",
    "length",
    0.01,
    [1, 0, 0, 0, 0, 0, 0],
    "cm",
    null,
    false,
    "L",
    null,
    1,
    false,
    false,
    0,
    "centimeters; centimetres".split('; '),
    "LOINC",
    "Len",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "centimeter of water",
    "cm[H2O]",
    "CM[H2O]",
    "pressure",
    98066.5,
    [-1, -2, 1, 0, 0, 0, 0],
    "cm HO<sub><r>2</r></sub>",
    "clinical",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "cm H2O; cmH2O; centimetres; pressure".split('; '),
    "LOINC",
    "Pres",
    "Clinical",
    "unit of pressure mostly applies to blood pressure",
    "kPa",
    "KPAL",
    "980665e-5",
    9.80665,
    false,
  ),
  UcumUnit(
    false,
    "centimeter of water per liter per second",
    "cm[H2O]/L/s",
    "(CM[H2O]/L)/S",
    "pressure",
    98066500,
    [-4, -3, 1, 0, 0, 0, 0],
    "(cm HO<sub><r>2</r></sub>)/L/s",
    "clinical",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "cm[H2O]/(L/s); cm[H2O].s/L; cm H2O/L/sec; cmH2O/L/sec; cmH2O/Liter; cmH2O per L per secs; centimeters of water per liters per second; centimetres; litres; cm[H2O]/(L/s)"
        .split('; '),
    "LOINC",
    "PresRat",
    "Clinical",
    "unit used to measure mean pulmonary resistance",
    "kPa",
    "KPAL",
    "980665e-5",
    9.80665,
    false,
  ),
  UcumUnit(
    false,
    "centimeter of water per second per meter",
    "cm[H2O]/s/m",
    "(CM[H2O]/S)/M",
    "pressure",
    98066.5,
    [-2, -3, 1, 0, 0, 0, 0],
    "(cm HO<sub><r>2</r></sub>)/s/m",
    "clinical",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "cm[H2O]/(s.m); cm H2O/s/m; cmH2O; cmH2O/sec/m; cmH2O per secs per meters; centimeters of water per seconds per meter; centimetres; metre"
        .split('; '),
    "LOINC",
    "PresRat",
    "Clinical",
    "unit used to measure pulmonary pressure time product",
    "kPa",
    "KPAL",
    "980665e-5",
    9.80665,
    false,
  ),
  UcumUnit(
    false,
    "centimeter of mercury",
    "cm[Hg]",
    "CM[HG]",
    "pressure",
    1333220,
    [-1, -2, 1, 0, 0, 0, 0],
    "cm Hg",
    "clinical",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "centimeters of mercury; centimetres; cmHg; cm Hg".split('; '),
    "LOINC",
    "Pres",
    "Clinical",
    "unit of pressure where 1 cmHg = 10 torr",
    "kPa",
    "KPAL",
    "133.3220",
    133.322,
    false,
  ),
  UcumUnit(
    true,
    "square centimeter",
    "cm2",
    "CM2",
    "length",
    1e-4,
    [2, 0, 0, 0, 0, 0, 0],
    "cm<sup>2</sup>",
    null,
    false,
    "L",
    null,
    1,
    false,
    false,
    0,
    "cm^2; sq cm; centimeters squared; square centimeters; centimetre; area"
        .split('; '),
    "LOINC",
    "Area",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "square centimeter per second",
    "cm2/s",
    "CM2/S",
    "length",
    1e-4,
    [2, -1, 0, 0, 0, 0, 0],
    "(cm<sup>2</sup>)/s",
    null,
    false,
    "L",
    null,
    1,
    false,
    false,
    0,
    "cm^2/sec; square centimeters per second; sq cm per sec; cm2; centimeters squared; centimetres"
        .split('; '),
    "LOINC",
    "AreaRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "centipoise",
    "cP",
    "CP",
    "dynamic viscosity",
    1,
    [-1, -1, 1, 0, 0, 0, 0],
    "cP",
    "cgs",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "cps; centiposes".split('; '),
    "LOINC",
    "Visc",
    "Clinical",
    "unit of dynamic viscosity in the CGS system with base units: 10^−3 Pa.s = 1 mPa·.s (1 millipascal second)",
    "dyn.s/cm2",
    "DYN.S/CM2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "centistoke",
    "cSt",
    "CST",
    "kinematic viscosity",
    10000000000000002e-22,
    [2, -1, 0, 0, 0, 0, 0],
    "cSt",
    "cgs",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "centistokes",
    ],
    "LOINC",
    "Visc",
    "Clinical",
    "unit for kinematic viscosity with base units of mm^2/s (square millimeter per second)",
    "cm2/s",
    "CM2/S",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "dekaliter per minute",
    "daL/min",
    "DAL/MIN",
    "volume",
    0.00016666666666666666,
    [3, -1, 0, 0, 0, 0, 0],
    "daL/min",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "dekalitres; dekaliters per minute; per min".split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "dekaliter per minute per square meter",
    "daL/min/m2",
    "(DAL/MIN)/M2",
    "volume",
    0.00016666666666666666,
    [1, -1, 0, 0, 0, 0, 0],
    "(daL/min)/(m<sup>2</sup>)",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "daL/min/m^2; daL/minute/m2; sq. meter; dekaliters per minutes per square meter; meter squared; dekalitres; metre"
        .split('; '),
    "LOINC",
    "ArVRat",
    "Clinical",
    "The area usually is the body surface area used to normalize cardiovascular measures for patient's size",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "decibel",
    "dB",
    "DB",
    "level",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "dB",
    "levels",
    true,
    null,
    "lg",
    0.1,
    true,
    false,
    0,
    [
      "decibels",
    ],
    "LOINC",
    "LogRto",
    "Clinical",
    "unit most commonly used in acoustics as unit of sound pressure level. (also see B[SPL] or bel sound pressure level). ",
    "1",
    null,
    null,
    1,
    false,
  ),
  UcumUnit(
    false,
    "degree per second",
    "deg/s",
    "DEG/S",
    "plane angle",
    0.017453292519943295,
    [0, -1, 0, 1, 0, 0, 0],
    "°/s",
    "iso1000",
    false,
    null,
    null,
    1,
    false,
    false,
    0,
    "deg/sec; deg per sec; °/sec; twist rate; angular speed; rotational speed"
        .split('; '),
    "LOINC",
    "ARat",
    "Clinical",
    "unit of angular (rotational) speed used to express turning rate",
    "[pi].rad/360",
    "[PI].RAD/360",
    "2",
    2,
    false,
  ),
  UcumUnit(
    true,
    "decigram",
    "dg",
    "DG",
    "mass",
    0.1,
    [0, 0, 1, 0, 0, 0, 0],
    "dg",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "decigrams; dgm; 0.1 grams; 1/10 gm".split('; '),
    "LOINC",
    "Mass",
    "Clinical",
    "equal to 1/10 gram",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "deciliter",
    "dL",
    "DL",
    "volume",
    1e-4,
    [3, 0, 0, 0, 0, 0, 0],
    "dL",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "deciliters; decilitres; 0.1 liters; 1/10 L".split('; '),
    "LOINC",
    "Vol",
    "Clinical",
    "equal to 1/10 liter",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    true,
    "decimeter",
    "dm",
    "DM",
    "length",
    0.1,
    [1, 0, 0, 0, 0, 0, 0],
    "dm",
    null,
    false,
    "L",
    null,
    1,
    false,
    false,
    0,
    "decimeters; decimetres; 0.1 meters; 1/10 m; 10 cm; centimeters"
        .split('; '),
    "LOINC",
    "Len",
    "Clinical",
    "equal to 1/10 meter or 10 centimeters",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "square decimeter per square second",
    "dm2/s2",
    "DM2/S2",
    "length",
    0.010000000000000002,
    [2, -2, 0, 0, 0, 0, 0],
    "(dm<sup>2</sup>)/(s<sup>2</sup>)",
    null,
    false,
    "L",
    null,
    1,
    false,
    false,
    0,
    "dm2 per s2; dm^2/s^2; decimeters squared per second squared; sq dm; sq sec"
        .split('; '),
    "LOINC",
    "EngMass (massic energy)",
    "Clinical",
    "units for energy per unit mass or Joules per kilogram (J/kg = kg.m2/s2/kg = m2/s2) ",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "dyne second per centimeter per square meter",
    "dyn.s/(cm.m2)",
    "(DYN.S)/(CM.M2)",
    "force",
    1,
    [-2, -1, 1, 0, 0, 0, 0],
    "(dyn.s)/(cm.(m<sup>2</sup>))",
    "cgs",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "(dyn*s)/(cm*m2); (dyn*s)/(cm*m^2); dyn s per cm per m2; m^2; dyne seconds per centimeters per square meter; centimetres; sq. meter; squared"
        .split('; '),
    "LOINC",
    "",
    "Clinical",
    "",
    "g.cm/s2",
    "G.CM/S2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "dyne second per centimeter",
    "dyn.s/cm",
    "(DYN.S)/CM",
    "force",
    1,
    [0, -1, 1, 0, 0, 0, 0],
    "(dyn.s)/cm",
    "cgs",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "(dyn*s)/cm; dyn sec per cm; seconds; centimetre; dyne seconds".split('; '),
    "LOINC",
    "",
    "Clinical",
    "",
    "g.cm/s2",
    "G.CM/S2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "equivalent per liter",
    "eq/L",
    "EQ/L",
    "amount of substance",
    6.0221366999999994e26,
    [-3, 0, 0, 0, 0, 0, 0],
    "eq/L",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "eq/liter; eq/litre; eqs; equivalents per liter; litre".split('; '),
    "LOINC",
    "SCnc",
    "Clinical",
    "equivalence equals moles per valence",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "equivalent per milliliter",
    "eq/mL",
    "EQ/ML",
    "amount of substance",
    6.0221367e29,
    [-3, 0, 0, 0, 0, 0, 0],
    "eq/mL",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "equivalent/milliliter; equivalents per milliliter; eq per mL; millilitre"
        .split('; '),
    "LOINC",
    "SCnc",
    "Clinical",
    "equivalence equals moles per valence",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "equivalent per millimole",
    "eq/mmol",
    "EQ/MMOL",
    "amount of substance",
    1e3,
    [0, 0, 0, 0, 0, 0, 0],
    "eq/mmol",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "equivalent/millimole; equivalents per millimole; eq per mmol".split('; '),
    "LOINC",
    "SRto",
    "Clinical",
    "equivalence equals moles per valence",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "equivalent per micromole",
    "eq/umol",
    "EQ/UMOL",
    "amount of substance",
    1e6,
    [0, 0, 0, 0, 0, 0, 0],
    "eq/μmol",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "equivalent/micromole; equivalents per micromole; eq per umol".split('; '),
    "LOINC",
    "SRto",
    "Clinical",
    "equivalence equals moles per valence",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    true,
    "femtogram",
    "fg",
    "FG",
    "mass",
    1e-15,
    [0, 0, 1, 0, 0, 0, 0],
    "fg",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "fg; fgm; femtograms; weight".split('; '),
    "LOINC",
    "Mass",
    "Clinical",
    "equal to 10^-15 grams",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "femtoliter",
    "fL",
    "FL",
    "volume",
    1e-18,
    [3, 0, 0, 0, 0, 0, 0],
    "fL",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "femtolitres; femtoliters".split('; '),
    "LOINC",
    "Vol; EntVol",
    "Clinical",
    "equal to 10^-15 liters",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    true,
    "femtometer",
    "fm",
    "FM",
    "length",
    1e-15,
    [1, 0, 0, 0, 0, 0, 0],
    "fm",
    null,
    false,
    "L",
    null,
    1,
    false,
    false,
    0,
    "femtometres; femtometers".split('; '),
    "LOINC",
    "Len",
    "Clinical",
    "equal to 10^-15 meters",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "femtomole",
    "fmol",
    "FMOL",
    "amount of substance",
    602213670,
    [0, 0, 0, 0, 0, 0, 0],
    "fmol",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    ["femtomoles"],
    "LOINC",
    "EntSub",
    "Clinical",
    "equal to 10^-15 moles",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "femtomole per gram",
    "fmol/g",
    "FMOL/G",
    "amount of substance",
    602213670,
    [0, 0, -1, 0, 0, 0, 0],
    "fmol/g",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "femtomoles; fmol/gm; fmol per gm".split('; '),
    "LOINC",
    "SCnt",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "femtomole per liter",
    "fmol/L",
    "FMOL/L",
    "amount of substance",
    60221367e4,
    [-3, 0, 0, 0, 0, 0, 0],
    "fmol/L",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "femtomoles; fmol per liter; litre".split('; '),
    "LOINC",
    "SCnc",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "femtomole per milligram",
    "fmol/mg",
    "FMOL/MG",
    "amount of substance",
    60221367e4,
    [0, 0, -1, 0, 0, 0, 0],
    "fmol/mg",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "fmol per mg; femtomoles".split('; '),
    "LOINC",
    "SCnt",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "femtomole per milliliter",
    "fmol/mL",
    "FMOL/ML",
    "amount of substance",
    60221367e7,
    [-3, 0, 0, 0, 0, 0, 0],
    "fmol/mL",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "femtomoles; millilitre; fmol per mL; fmol per milliliter".split('; '),
    "LOINC",
    "SCnc",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    true,
    "gram meter",
    "g.m",
    "G.M",
    "mass",
    1,
    [1, 0, 1, 0, 0, 0, 0],
    "g.m",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "g*m; gxm; meters; metres".split('; '),
    "LOINC",
    "Enrg",
    "Clinical",
    "Unit for measuring stroke work (heart work)",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per 100 gram",
    "g/(100.g)",
    "G/G",
    "mass",
    0.01,
    [0, 0, 0, 0, 0, 0, 0],
    "g/g",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "g/100 gm; 100gm; grams per 100 grams; gm per 100 gm".split('; '),
    "LOINC",
    "MCnt",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per 12 hour",
    "g/(12.h)",
    "G/HR",
    "mass",
    23148148148148147e-21,
    [0, -1, 1, 0, 0, 0, 0],
    "g/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "gm/12hrs; 12 hrs; gm per 12 hrs; 12hrs; grams per 12 hours".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per 24 hour",
    "g/(24.h)",
    "G/HR",
    "mass",
    11574074074074073e-21,
    [0, -1, 1, 0, 0, 0, 0],
    "g/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "gm/24hrs; gm/24 hrs; gm per 24 hrs; 24hrs; grams per 24 hours; gm/dy; gm per dy; grams per day"
        .split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per 3 days",
    "g/(3.d)",
    "G/D",
    "mass",
    3858024691358025e-21,
    [0, -1, 1, 0, 0, 0, 0],
    "g/d",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "gm/3dy; gm/3 dy; gm per 3 days; grams".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per 4 hour",
    "g/(4.h)",
    "G/HR",
    "mass",
    6944444444444444e-20,
    [0, -1, 1, 0, 0, 0, 0],
    "g/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "gm/4hrs; gm/4 hrs; gm per 4 hrs; 4hrs; grams per 4 hours".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per 48 hour",
    "g/(48.h)",
    "G/HR",
    "mass",
    5787037037037037e-21,
    [0, -1, 1, 0, 0, 0, 0],
    "g/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "gm/48hrs; gm/48 hrs; gm per 48 hrs; 48hrs; grams per 48 hours".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per 5 hour",
    "g/(5.h)",
    "G/HR",
    "mass",
    5555555555555556e-20,
    [0, -1, 1, 0, 0, 0, 0],
    "g/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "gm/5hrs; gm/5 hrs; gm per 5 hrs; 5hrs; grams per 5 hours".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per 6 hour",
    "g/(6.h)",
    "G/HR",
    "mass",
    46296296296296294e-21,
    [0, -1, 1, 0, 0, 0, 0],
    "g/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "gm/6hrs; gm/6 hrs; gm per 6 hrs; 6hrs; grams per 6 hours".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per 72 hour",
    "g/(72.h)",
    "G/HR",
    "mass",
    3858024691358025e-21,
    [0, -1, 1, 0, 0, 0, 0],
    "g/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "gm/72hrs; gm/72 hrs; gm per 72 hrs; 72hrs; grams per 72 hours".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per cubic centimeter",
    "g/cm3",
    "G/CM3",
    "mass",
    999999.9999999999,
    [-3, 0, 1, 0, 0, 0, 0],
    "g/(cm<sup>3</sup>)",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "g/cm^3; gm per cm3; g per cm^3; grams per centimeter cubed; cu. cm; centimetre; g/mL; gram per milliliter; millilitre"
        .split('; '),
    "LOINC",
    "MCnc",
    "Clinical",
    "g/cm3 = g/mL",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per day",
    "g/d",
    "G/D",
    "mass",
    11574074074074073e-21,
    [0, -1, 1, 0, 0, 0, 0],
    "g/d",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "gm/dy; gm per dy; grams per day; gm/24hrs; gm/24 hrs; gm per 24 hrs; 24hrs; grams per 24 hours; serving"
        .split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per deciliter",
    "g/dL",
    "G/DL",
    "mass",
    1e4,
    [-3, 0, 1, 0, 0, 0, 0],
    "g/dL",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "gm/dL; gm per dL; grams per deciliter; decilitre".split('; '),
    "LOINC",
    "MCnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per gram",
    "g/g",
    "G/G",
    "mass",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "g/g",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "gm; grams".split('; '),
    "LOINC",
    "MRto ",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per hour",
    "g/h",
    "G/HR",
    "mass",
    0.0002777777777777778,
    [0, -1, 1, 0, 0, 0, 0],
    "g/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "gm/hr; gm per hr; grams; intake; output".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per hour per square meter",
    "g/h/m2",
    "(G/HR)/M2",
    "mass",
    0.0002777777777777778,
    [-2, -1, 1, 0, 0, 0, 0],
    "(g/h)/(m<sup>2</sup>)",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "gm/hr/m2; gm/h/m2; /m^2; sq. m; g per hr per m2; grams per hours per square meter; meter squared; metre"
        .split('; '),
    "LOINC",
    "ArMRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per kilogram",
    "g/kg ",
    "G/KG",
    "mass",
    0.001,
    [0, 0, 0, 0, 0, 0, 0],
    "g/kg",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "g per kg; gram per kilograms".split('; '),
    "LOINC",
    "MCnt",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per kilogram per 8 hour ",
    "g/kg/(8.h)",
    "(G/KG)/HR",
    "mass",
    3.472222222222222e-8,
    [0, -1, 0, 0, 0, 0, 0],
    "(g/kg)/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "g/(8.kg.h); gm/kg/8hrs; 8 hrs; g per kg per 8 hrs; 8hrs; grams per kilograms per 8 hours; shift"
        .split('; '),
    "LOINC",
    "MCntRat; RelMRat",
    "Clinical",
    "unit often used to describe mass in grams of protein consumed in a 8 hours, divided by the subject's body weight in kilograms. Also used to measure mass dose rate per body mass",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per kilogram per day",
    "g/kg/d",
    "(G/KG)/D",
    "mass",
    1.1574074074074074e-8,
    [0, -1, 0, 0, 0, 0, 0],
    "(g/kg)/d",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "g/(kg.d); gm/kg/dy; gm per kg per dy; grams per kilograms per day"
        .split('; '),
    "LOINC",
    "RelMRat",
    "Clinical",
    "unit often used to describe mass in grams of protein consumed in a day, divided by the subject's body weight in kilograms. Also used to measure mass dose rate per body mass",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per kilogram per hour",
    "g/kg/h",
    "(G/KG)/HR",
    "mass",
    2.7777777777777776e-7,
    [0, -1, 0, 0, 0, 0, 0],
    "(g/kg)/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "g/(kg.h); g/kg/hr; g per kg per hrs; grams per kilograms per hour"
        .split('; '),
    "LOINC",
    "MCntRat; RelMRat",
    "Clinical",
    "unit used to measure mass dose rate per body mass",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per kilogram per minute",
    "g/kg/min",
    "(G/KG)/MIN",
    "mass",
    16666666666666667e-21,
    [0, -1, 0, 0, 0, 0, 0],
    "(g/kg)/min",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "g/(kg.min); g/kg/min; g per kg per min; grams per kilograms per minute"
        .split('; '),
    "LOINC",
    "MCntRat; RelMRat",
    "Clinical",
    "unit used to measure mass dose rate per body mass",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per liter",
    "g/L",
    "G/L",
    "mass",
    1e3,
    [-3, 0, 1, 0, 0, 0, 0],
    "g/L",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "gm per liter; g/liter; grams per liter; litre".split('; '),
    "LOINC",
    "MCnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per square meter",
    "g/m2",
    "G/M2",
    "mass",
    1,
    [-2, 0, 1, 0, 0, 0, 0],
    "g/(m<sup>2</sup>)",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "g/m^2; gram/square meter; g/sq m; g per m2; g per m^2; grams per square meter; meters squared; metre"
        .split('; '),
    "LOINC",
    "ArMass",
    "Clinical",
    "Tests measure myocardial mass (heart ventricle system) per body surface area; unit used to measure mass dose per body surface area",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per milligram",
    "g/mg",
    "G/MG",
    "mass",
    1e3,
    [0, 0, 0, 0, 0, 0, 0],
    "g/mg",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "g per mg; grams per milligram".split('; '),
    "LOINC",
    "MCnt; MRto",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per minute",
    "g/min",
    "G/MIN",
    "mass",
    0.016666666666666666,
    [0, -1, 1, 0, 0, 0, 0],
    "g/min",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "g per min; grams per minute; gram/minute".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per milliliter",
    "g/mL",
    "G/ML",
    "mass",
    1e6,
    [-3, 0, 1, 0, 0, 0, 0],
    "g/mL",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "g per mL; grams per milliliter; millilitre".split('; '),
    "LOINC",
    "MCnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "gram per millimole",
    "g/mmol",
    "G/MMOL",
    "mass",
    1.6605401866749388e-21,
    [0, 0, 1, 0, 0, 0, 0],
    "g/mmol",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    -1,
    "grams per millimole; g per mmol".split('; '),
    "LOINC",
    "Ratio",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "joule per liter",
    "J/L",
    "J/L",
    "energy",
    1e6,
    [-1, -2, 1, 0, 0, 0, 0],
    "J/L",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "joules per liter; litre; J per L".split('; '),
    "LOINC",
    "EngCnc",
    "Clinical",
    "",
    "N.m",
    "N.M",
    "1",
    1,
    false,
  ),
  UcumUnit(
    true,
    "degree Kelvin per Watt",
    "K/W",
    "K/W",
    "temperature",
    0.001,
    [-2, 3, -1, 0, 1, 0, 0],
    "K/W",
    null,
    false,
    "C",
    null,
    1,
    false,
    false,
    0,
    "degree Kelvin/Watt; K per W; thermal ohm; thermal resistance; degrees"
        .split('; '),
    "LOINC",
    "TempEngRat",
    "Clinical",
    "unit for absolute thermal resistance equal to the reciprocal of thermal conductance. Unit used for tests to measure work of breathing",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "kilo international unit per liter",
    "k[IU]/L",
    "K[IU]/L",
    "arbitrary",
    1e6,
    [-3, 0, 0, 0, 0, 0, 0],
    "(ki.U.)/L",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    true,
    0,
    "kIU/L; kIU per L; kIU per liter; kilo international units; litre; allergens; allergy units"
        .split('; '),
    "LOINC",
    "ACnc",
    "Clinical",
    "IgE has an WHO reference standard so IgE allergen testing can be reported as k[IU]/L",
    "[iU]",
    "[IU]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "kilo international unit per milliliter",
    "k[IU]/mL",
    "K[IU]/ML",
    "arbitrary",
    1e9,
    [-3, 0, 0, 0, 0, 0, 0],
    "(ki.U.)/mL",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    true,
    0,
    "kIU/mL; kIU per mL; kIU per milliliter; kilo international units; millilitre; allergens; allergy units"
        .split('; '),
    "LOINC",
    "ACnc",
    "Clinical",
    "IgE has an WHO reference standard so IgE allergen testing can be reported as k[IU]/mL",
    "[iU]",
    "[IU]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "katal per kilogram",
    "kat/kg",
    "KAT/KG",
    "catalytic activity",
    60221367e13,
    [0, -1, -1, 0, 0, 0, 0],
    "kat/kg",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "kat per kg; katals per kilogram; mol/s/kg; moles per seconds per kilogram"
        .split('; '),
    "LOINC",
    "CCnt",
    "Clinical",
    "kat is a unit of catalytic activity with base units = mol/s. Rarely used because its units are too large to practically express catalytic activity. See enzyme unit [U] which is the standard unit for catalytic activity.",
    "mol/s",
    "MOL/S",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "katal per liter",
    "kat/L",
    "KAT/L",
    "catalytic activity",
    6.0221366999999994e26,
    [-3, -1, 0, 0, 0, 0, 0],
    "kat/L",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "kat per L; katals per liter; litre; mol/s/L; moles per seconds per liter"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "kat is a unit of catalytic activity with base units = mol/s. Rarely used because its units are too large to practically express catalytic activity. See enzyme unit [U] which is the standard unit for catalytic activity.",
    "mol/s",
    "MOL/S",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "kilocalorie",
    "kcal",
    "KCAL",
    "energy",
    4184e3,
    [2, -2, 1, 0, 0, 0, 0],
    "kcal",
    "heat",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "kilogram calories; large calories; food calories; kcals".split('; '),
    "LOINC",
    "EngRat",
    "Clinical",
    "It is equal to 1000 calories (equal to 4.184 kJ). But in practical usage, kcal refers to food calories which excludes caloric content in fiber and other constitutes that is not digestible by humans. Also see nutrition label Calories ([Cal])",
    "cal_th",
    "CAL_TH",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "kilocalorie per 24 hour",
    "kcal/(24.h)",
    "KCAL/HR",
    "energy",
    48.425925925925924,
    [2, -3, 1, 0, 0, 0, 0],
    "kcal/h",
    "heat",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "kcal/24hrs; kcal/24 hrs; kcal per 24hrs; kilocalories per 24 hours; kilojoules; kJ/24hr; kJ/(24.h); kJ/dy; kilojoules per days; intake; calories burned; metabolic rate; food calories"
        .split('; '),
    "",
    "EngRat",
    "Clinical",
    "",
    "cal_th",
    "CAL_TH",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "kilocalorie per ounce",
    "kcal/[oz_av]",
    "KCAL/[OZ_AV]",
    "energy",
    147586.25679704445,
    [2, -2, 0, 0, 0, 0, 0],
    "kcal/oz",
    "heat",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "kcal/oz; kcal per ozs; large calories per ounces; food calories; servings; international"
        .split('; '),
    "LOINC",
    "EngCnt",
    "Clinical",
    "used in nutrition to represent calorie of food",
    "cal_th",
    "CAL_TH",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "kilocalorie per day",
    "kcal/d",
    "KCAL/D",
    "energy",
    48.425925925925924,
    [2, -3, 1, 0, 0, 0, 0],
    "kcal/d",
    "heat",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "kcal/dy; kcal per day; kilocalories per days; kilojoules; kJ/dy; kilojoules per days; intake; calories burned; metabolic rate; food calories"
        .split('; '),
    "LOINC",
    "EngRat",
    "Clinical",
    "unit in nutrition for food intake (measured in calories) in a day",
    "cal_th",
    "CAL_TH",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "kilocalorie per hour",
    "kcal/h",
    "KCAL/HR",
    "energy",
    1162.2222222222222,
    [2, -3, 1, 0, 0, 0, 0],
    "kcal/h",
    "heat",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "kcal/hrs; kcals per hr; intake; kilocalories per hours; kilojoules"
        .split('; '),
    "LOINC",
    "EngRat",
    "Clinical",
    "used in nutrition to represent caloric requirement or consumption",
    "cal_th",
    "CAL_TH",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "kilocalorie per kilogram per 24 hour",
    "kcal/kg/(24.h)",
    "(KCAL/KG)/HR",
    "energy",
    0.04842592592592593,
    [2, -3, 0, 0, 0, 0, 0],
    "(kcal/kg)/h",
    "heat",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "kcal/kg/24hrs; 24 hrs; kcal per kg per 24hrs; kilocalories per kilograms per 24 hours; kilojoules"
        .split('; '),
    "LOINC",
    "EngCntRat",
    "Clinical",
    "used in nutrition to represent caloric requirement per day based on subject's body weight in kilograms",
    "cal_th",
    "CAL_TH",
    "1",
    1,
    false,
  ),
  UcumUnit(
    true,
    "kilogram",
    "kg",
    "KG",
    "mass",
    1e3,
    [0, 0, 1, 0, 0, 0, 0],
    "kg",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "kilograms; kgs".split('; '),
    "LOINC",
    "Mass",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "kilogram meter per second",
    "kg.m/s",
    "(KG.M)/S",
    "mass",
    1e3,
    [1, -1, 1, 0, 0, 0, 0],
    "(kg.m)/s",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "kg*m/s; kg.m per sec; kg*m per sec; p; momentum".split('; '),
    "LOINC",
    "",
    "Clinical",
    "unit for momentum =  mass times velocity",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "kilogram per second per square meter",
    "kg/(s.m2)",
    "KG/(S.M2)",
    "mass",
    1e3,
    [-2, -1, 1, 0, 0, 0, 0],
    "kg/(s.(m<sup>2</sup>))",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "kg/(s*m2); kg/(s*m^2); kg per s per m2; per sec; per m^2; kilograms per seconds per square meter; meter squared; metre"
        .split('; '),
    "LOINC",
    "ArMRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "kilogram per hour",
    "kg/h",
    "KG/HR",
    "mass",
    0.2777777777777778,
    [0, -1, 1, 0, 0, 0, 0],
    "kg/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "kg/hr; kg per hr; kilograms per hour".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "kilogram per liter",
    "kg/L",
    "KG/L",
    "mass",
    1e6,
    [-3, 0, 1, 0, 0, 0, 0],
    "kg/L",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "kg per liter; litre; kilograms".split('; '),
    "LOINC",
    "MCnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "kilogram per square meter",
    "kg/m2",
    "KG/M2",
    "mass",
    1e3,
    [-2, 0, 1, 0, 0, 0, 0],
    "kg/(m<sup>2</sup>)",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "kg/m^2; kg/sq. m; kg per m2; per m^2; per sq. m; kilograms; meter squared; metre; BMI"
        .split('; '),
    "LOINC",
    "Ratio",
    "Clinical",
    "units for body mass index (BMI)",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "kilogram per cubic meter",
    "kg/m3",
    "KG/M3",
    "mass",
    1e3,
    [-3, 0, 1, 0, 0, 0, 0],
    "kg/(m<sup>3</sup>)",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "kg/m^3; kg/cu. m; kg per m3; per m^3; per cu. m; kilograms; meters cubed; metre"
        .split('; '),
    "LOINC",
    "MCnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "kilogram per minute",
    "kg/min",
    "KG/MIN",
    "mass",
    16.666666666666668,
    [0, -1, 1, 0, 0, 0, 0],
    "kg/min",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "kilogram/minute; kg per min; kilograms per minute".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "kilogram per mole",
    "kg/mol",
    "KG/MOL",
    "mass",
    1.6605401866749388e-21,
    [0, 0, 1, 0, 0, 0, 0],
    "kg/mol",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    -1,
    "kilogram/mole; kg per mol; kilograms per mole".split('; '),
    "LOINC",
    "SCnt",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "kilogram per second",
    "kg/s",
    "KG/S",
    "mass",
    1e3,
    [0, -1, 1, 0, 0, 0, 0],
    "kg/s",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "kg/sec; kilogram/second; kg per sec; kilograms; second".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "kiloliter",
    "kL",
    "KL",
    "volume",
    1,
    [3, 0, 0, 0, 0, 0, 0],
    "kL",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "kiloliters; kilolitres; m3; m^3; meters cubed; metre".split('; '),
    "LOINC",
    "Vol",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    true,
    "kilometer",
    "km",
    "KM",
    "length",
    1e3,
    [1, 0, 0, 0, 0, 0, 0],
    "km",
    null,
    false,
    "L",
    null,
    1,
    false,
    false,
    0,
    "kilometers; kilometres; distance".split('; '),
    "LOINC",
    "Len",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "kilopascal",
    "kPa",
    "KPAL",
    "pressure",
    1e6,
    [-1, -2, 1, 0, 0, 0, 0],
    "kPa",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "kilopascals; pressure".split('; '),
    "LOINC",
    "Pres; PPresDiff",
    "Clinical",
    "",
    "N/m2",
    "N/M2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    true,
    "kilosecond",
    "ks",
    "KS",
    "time",
    1e3,
    [0, 1, 0, 0, 0, 0, 0],
    "ks",
    null,
    false,
    "T",
    null,
    1,
    false,
    false,
    0,
    "kiloseconds; ksec".split('; '),
    "LOINC",
    "Time",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "kilo enzyme unit",
    "kU",
    "KU",
    "catalytic activity",
    100368945e11,
    [0, -1, 0, 0, 0, 0, 0],
    "kU",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "units; mmol/min; millimoles per minute".split('; '),
    "LOINC",
    "CAct",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min); 1 kU = 1 mmol/min",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "kilo enzyme unit per gram",
    "kU/g",
    "KU/G",
    "catalytic activity",
    100368945e11,
    [0, -1, -1, 0, 0, 0, 0],
    "kU/g",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "units per grams; kU per gm".split('; '),
    "LOINC",
    "CCnt",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min); 1 kU = 1 mmol/min",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "kilo enzyme unit per liter",
    "kU/L",
    "KU/L",
    "catalytic activity",
    1.00368945e22,
    [-3, -1, 0, 0, 0, 0, 0],
    "kU/L",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "units per liter; litre; enzymatic activity; enzyme activity per volume; activities"
        .split('; '),
    "LOINC",
    "ACnc; CCnc",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min); 1 kU = 1 mmol/min",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "kilo enzyme unit per milliliter",
    "kU/mL",
    "KU/ML",
    "catalytic activity",
    1.00368945e25,
    [-3, -1, 0, 0, 0, 0, 0],
    "kU/mL",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "kU per mL; units per milliliter; millilitre; enzymatic activity per volume; enzyme activities"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min); 1 kU = 1 mmol/min",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Liters per 24 hour",
    "L/(24.h)",
    "L/HR",
    "volume",
    1.1574074074074074e-8,
    [3, -1, 0, 0, 0, 0, 0],
    "L/h",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "L/24hrs; L/24 hrs; L per 24hrs; liters per 24 hours; day; dy; litres; volume flow rate"
        .split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Liters per 8 hour",
    "L/(8.h)",
    "L/HR",
    "volume",
    3.472222222222222e-8,
    [3, -1, 0, 0, 0, 0, 0],
    "L/h",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "L/8hrs; L/8 hrs; L per 8hrs; liters per 8 hours; litres; volume flow rate; shift"
        .split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Liters per minute per square meter",
    "L/(min.m2) ",
    "L/(MIN.M2)",
    "volume",
    16666666666666667e-21,
    [1, -1, 0, 0, 0, 0, 0],
    "L/(min.(m<sup>2</sup>))",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "L/(min.m2); L/min/m^2; L/min/sq. meter; L per min per m2; m^2; liters per minutes per square meter; meter squared; litres; metre "
        .split('; '),
    "LOINC",
    "ArVRat",
    "Clinical",
    "unit for tests that measure cardiac output per body surface area (cardiac index)",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Liters per day",
    "L/d",
    "L/D",
    "volume",
    1.1574074074074074e-8,
    [3, -1, 0, 0, 0, 0, 0],
    "L/d",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "L/dy; L per day; 24hrs; 24 hrs; 24 hours; liters; litres".split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Liters per hour",
    "L/h",
    "L/HR",
    "volume",
    2.7777777777777776e-7,
    [3, -1, 0, 0, 0, 0, 0],
    "L/h",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "L/hr; L per hr; litres".split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Liters per kilogram",
    "L/kg",
    "L/KG",
    "volume",
    1e-6,
    [3, 0, -1, 0, 0, 0, 0],
    "L/kg",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "L per kg; litre".split('; '),
    "LOINC",
    "VCnt",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Liters per liter",
    "L/L",
    "L/L",
    "volume",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "L/L",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "L per L; liter/liter; litre".split('; '),
    "LOINC",
    "VFr",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Liters per minute",
    "L/min",
    "L/MIN",
    "volume",
    16666666666666667e-21,
    [3, -1, 0, 0, 0, 0, 0],
    "L/min",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "liters per minute; litre".split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Liters per minute per square meter",
    "L/min/m2",
    "(L/MIN)/M2",
    "volume",
    16666666666666667e-21,
    [1, -1, 0, 0, 0, 0, 0],
    "(L/min)/(m<sup>2</sup>)",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "L/(min.m2); L/min/m^2; L/min/sq. meter; L per min per m2; m^2; liters per minutes per square meter; meter squared; litres; metre "
        .split('; '),
    "",
    "ArVRat",
    "Clinical",
    "unit for tests that measure cardiac output per body surface area (cardiac index)",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Liters per second",
    "L/s",
    "L/S",
    "volume",
    0.001,
    [3, -1, 0, 0, 0, 0, 0],
    "L/s",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "L per sec; litres".split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "unit used often to measure gas flow and peak expiratory flow",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Liters per second per square second",
    "L/s/s2",
    "(L/S)/S2",
    "volume",
    0.001,
    [3, -3, 0, 0, 0, 0, 0],
    "(L/s)/(s<sup>2</sup>)",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "L/s/s^2; L/sec/sec2; L/sec/sec^2; L/sec/sq. sec; L per s per s2; L per sec per sec2; s^2; sec^2; liters per seconds per square second; second squared; litres "
        .split('; '),
    "LOINC",
    "ArVRat",
    "Clinical",
    "unit for tests that measure cardiac output/body surface area",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "lumen square meter",
    "lm.m2",
    "LM.M2",
    "luminous flux",
    1,
    [2, 0, 0, 2, 0, 0, 1],
    "lm.(m<sup>2</sup>)",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "lm*m2; lm*m^2; lumen meters squared; lumen sq. meters; metres".split('; '),
    "LOINC",
    "",
    "Clinical",
    "",
    "cd.sr",
    "CD.SR",
    "1",
    1,
    false,
  ),
  UcumUnit(
    true,
    "meter per second",
    "m/s",
    "M/S",
    "length",
    1,
    [1, -1, 0, 0, 0, 0, 0],
    "m/s",
    null,
    false,
    "L",
    null,
    1,
    false,
    false,
    0,
    "meter/second; m per sec; meters per second; metres; velocity; speed"
        .split('; '),
    "LOINC",
    "Vel",
    "Clinical",
    "unit of velocity",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "meter per square second",
    "m/s2",
    "M/S2",
    "length",
    1,
    [1, -2, 0, 0, 0, 0, 0],
    "m/(s<sup>2</sup>)",
    null,
    false,
    "L",
    null,
    1,
    false,
    false,
    0,
    "m/s^2; m/sq. sec; m per s2; per s^2; meters per square second; second squared; sq second; metres; acceleration"
        .split('; '),
    "LOINC",
    "Accel",
    "Clinical",
    "unit of acceleration",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "milli international unit per liter",
    "m[IU]/L",
    "M[IU]/L",
    "arbitrary",
    1,
    [-3, 0, 0, 0, 0, 0, 0],
    "(mi.U.)/L",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    true,
    0,
    "mIU/L; m IU/L; mIU per liter; units; litre".split('; '),
    "LOINC",
    "ACnc",
    "Clinical",
    "International units (IU) are analyte and reference specimen  specific arbitrary units (held at WHO)",
    "[iU]",
    "[IU]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milli  international unit per milliliter",
    "m[IU]/mL",
    "M[IU]/ML",
    "arbitrary",
    1000.0000000000001,
    [-3, 0, 0, 0, 0, 0, 0],
    "(mi.U.)/mL",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    true,
    0,
    "mIU/mL; m IU/mL; mIU per mL; milli international units per milliliter; millilitre"
        .split('; '),
    "LOINC",
    "ACnc",
    "Clinical",
    "International units (IU) are analyte and reference specimen  specific arbitrary units (held at WHO)",
    "[iU]",
    "[IU]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    true,
    "square meter",
    "m2",
    "M2",
    "length",
    1,
    [2, 0, 0, 0, 0, 0, 0],
    "m<sup>2</sup>",
    null,
    false,
    "L",
    null,
    1,
    false,
    false,
    0,
    "m^2; sq m; square meters; meters squared; metres".split('; '),
    "LOINC",
    "Area",
    "Clinical",
    "unit often used to represent body surface area",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "square meter per second",
    "m2/s",
    "M2/S",
    "length",
    1,
    [2, -1, 0, 0, 0, 0, 0],
    "(m<sup>2</sup>)/s",
    null,
    false,
    "L",
    null,
    1,
    false,
    false,
    0,
    "m^2/sec; m2 per sec; m^2 per sec; sq m/sec; meters squared/seconds; sq m per sec; meters squared; metres"
        .split('; '),
    "LOINC",
    "ArRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "cubic meter per second",
    "m3/s",
    "M3/S",
    "length",
    1,
    [3, -1, 0, 0, 0, 0, 0],
    "(m<sup>3</sup>)/s",
    null,
    false,
    "L",
    null,
    1,
    false,
    false,
    0,
    "m^3/sec; m3 per sec; m^3 per sec; cu m/sec; cubic meters per seconds; meters cubed; metres"
        .split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "milliampere",
    "mA",
    "MA",
    "electric current",
    0.001,
    [0, -1, 0, 0, 0, 1, 0],
    "mA",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mamp; milliamperes".split('; '),
    "LOINC",
    "ElpotRat",
    "Clinical",
    "unit of electric current",
    "C/s",
    "C/S",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "millibar",
    "mbar",
    "MBAR",
    "pressure",
    1e5,
    [-1, -2, 1, 0, 0, 0, 0],
    "mbar",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "millibars",
    ],
    "LOINC",
    "Pres",
    "Clinical",
    "unit of pressure",
    "Pa",
    "PAL",
    "1e5",
    1e5,
    false,
  ),
  UcumUnit(
    false,
    "millibar second per liter",
    "mbar.s/L",
    "(MBAR.S)/L",
    "pressure",
    1e8,
    [-4, -1, 1, 0, 0, 0, 0],
    "(mbar.s)/L",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mbar*s/L; mbar.s per L; mbar*s per L; millibar seconds per liter; millibar second per litre"
        .split('; '),
    "LOINC",
    "",
    "Clinical",
    "unit to measure expiratory resistance",
    "Pa",
    "PAL",
    "1e5",
    1e5,
    false,
  ),
  UcumUnit(
    false,
    "millibar per liter per second",
    "mbar/L/s",
    "(MBAR/L)/S",
    "pressure",
    1e8,
    [-4, -3, 1, 0, 0, 0, 0],
    "(mbar/L)/s",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mbar/(L.s); mbar/L/sec; mbar/liter/second; mbar per L per sec; mbar per liter per second; millibars per liters per seconds; litres"
        .split('; '),
    "LOINC",
    "PresCncRat",
    "Clinical",
    "unit to measure expiratory resistance",
    "Pa",
    "PAL",
    "1e5",
    1e5,
    false,
  ),
  UcumUnit(
    false,
    "milliequivalent",
    "meq",
    "MEQ",
    "amount of substance",
    60221367e13,
    [0, 0, 0, 0, 0, 0, 0],
    "meq",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "milliequivalents; meqs".split('; '),
    "LOINC",
    "Sub",
    "Clinical",
    "equivalence equals moles per valence",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliequivalent per 2 hour",
    "meq/(2.h)",
    "MEQ/HR",
    "amount of substance",
    836407875e8,
    [0, -1, 0, 0, 0, 0, 0],
    "meq/h",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "meq/2hrs; meq/2 hrs; meq per 2 hrs; milliequivalents per 2 hours"
        .split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "equivalence equals moles per valence",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliequivalent per 24 hour",
    "meq/(24.h)",
    "MEQ/HR",
    "amount of substance",
    6970065625e6,
    [0, -1, 0, 0, 0, 0, 0],
    "meq/h",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "meq/24hrs; meq/24 hrs; meq per 24 hrs; milliequivalents per 24 hours"
        .split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "equivalence equals moles per valence",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliequivalent per 8 hour",
    "meq/(8.h)",
    "MEQ/HR",
    "amount of substance",
    20910196875e6,
    [0, -1, 0, 0, 0, 0, 0],
    "meq/h",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "meq/8hrs; meq/8 hrs; meq per 8 hrs; milliequivalents per 8 hours; shift"
        .split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "equivalence equals moles per valence",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliequivalent per day",
    "meq/d",
    "MEQ/D",
    "amount of substance",
    6970065625e6,
    [0, -1, 0, 0, 0, 0, 0],
    "meq/d",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "meq/dy; meq per day; milliquivalents per days; meq/24hrs; meq/24 hrs; meq per 24 hrs; milliequivalents per 24 hours"
        .split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "equivalence equals moles per valence",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliequivalent per deciliter",
    "meq/dL",
    "MEQ/DL",
    "amount of substance",
    6.022136699999999e24,
    [-3, 0, 0, 0, 0, 0, 0],
    "meq/dL",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "meq per dL; milliequivalents per deciliter; decilitre".split('; '),
    "LOINC",
    "SCnc",
    "Clinical",
    "equivalence equals moles per valence",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliequivalent per gram",
    "meq/g",
    "MEQ/G",
    "amount of substance",
    60221367e13,
    [0, 0, -1, 0, 0, 0, 0],
    "meq/g",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mgq/gm; meq per gm; milliequivalents per gram".split('; '),
    "LOINC",
    "MCnt",
    "Clinical",
    "equivalence equals moles per valence",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliequivalent per hour",
    "meq/h",
    "MEQ/HR",
    "amount of substance",
    167281575e9,
    [0, -1, 0, 0, 0, 0, 0],
    "meq/h",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "meq/hrs; meq per hrs; milliequivalents per hour".split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "equivalence equals moles per valence",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliequivalent per kilogram",
    "meq/kg",
    "MEQ/KG",
    "amount of substance",
    60221367e10,
    [0, 0, -1, 0, 0, 0, 0],
    "meq/kg",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "meq per kg; milliequivalents per kilogram".split('; '),
    "LOINC",
    "SCnt",
    "Clinical",
    "equivalence equals moles per valence; used to measure dose per patient body mass",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliequivalent per kilogram per hour",
    "meq/kg/h",
    "(MEQ/KG)/HR",
    "amount of substance",
    167281575e6,
    [0, -1, -1, 0, 0, 0, 0],
    "(meq/kg)/h",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "meq/(kg.h); meq/kg/hr; meq per kg per hr; milliequivalents per kilograms per hour"
        .split('; '),
    "LOINC",
    "SCntRat",
    "Clinical",
    "equivalence equals moles per valence; unit used to measure dose rate per patient body mass",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliequivalent per liter",
    "meq/L",
    "MEQ/L",
    "amount of substance",
    6.0221367e23,
    [-3, 0, 0, 0, 0, 0, 0],
    "meq/L",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "milliequivalents per liter; litre; meq per l; acidity".split('; '),
    "LOINC",
    "SCnc",
    "Clinical",
    "equivalence equals moles per valence",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliequivalent per square meter",
    "meq/m2",
    "MEQ/M2",
    "amount of substance",
    60221367e13,
    [-2, 0, 0, 0, 0, 0, 0],
    "meq/(m<sup>2</sup>)",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "meq/m^2; meq/sq. m; milliequivalents per square meter; meter squared; metre"
        .split('; '),
    "LOINC",
    "ArSub",
    "Clinical",
    "equivalence equals moles per valence; note that the use of m2 in clinical units ofter refers to body surface area",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliequivalent per minute",
    "meq/min",
    "MEQ/MIN",
    "amount of substance",
    100368945e11,
    [0, -1, 0, 0, 0, 0, 0],
    "meq/min",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "meq per min; milliequivalents per minute".split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "equivalence equals moles per valence",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliequivalent per milliliter",
    "meq/mL",
    "MEQ/ML",
    "amount of substance",
    6.0221367e26,
    [-3, 0, 0, 0, 0, 0, 0],
    "meq/mL",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "meq per mL; milliequivalents per milliliter; millilitre".split('; '),
    "LOINC",
    "SCnc",
    "Clinical",
    "equivalence equals moles per valence",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    true,
    "milligram",
    "mg",
    "MG",
    "mass",
    0.001,
    [0, 0, 1, 0, 0, 0, 0],
    "mg",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    [
      "milligrams",
    ],
    "LOINC",
    "Mass",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per 10 hour",
    "mg/(10.h)",
    "MG/HR",
    "mass",
    2.7777777777777777e-8,
    [0, -1, 1, 0, 0, 0, 0],
    "mg/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg/10hrs; mg/10 hrs; mg per 10 hrs; milligrams per 10 hours".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per 12 hour",
    "mg/(12.h)",
    "MG/HR",
    "mass",
    2.3148148148148148e-8,
    [0, -1, 1, 0, 0, 0, 0],
    "mg/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg/12hrs; mg/12 hrs; per 12 hrs; 12hrs; milligrams per 12 hours"
        .split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "units used for tests in urine",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per 2 hour",
    "mg/(2.h)",
    "MG/HR",
    "mass",
    1.3888888888888888e-7,
    [0, -1, 1, 0, 0, 0, 0],
    "mg/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg/2hrs; mg/2 hrs; mg per 2 hrs; 2hrs; milligrams per 2 hours".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "units used for tests in urine",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per 24 hour",
    "mg/(24.h)",
    "MG/HR",
    "mass",
    1.1574074074074074e-8,
    [0, -1, 1, 0, 0, 0, 0],
    "mg/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg/24hrs; mg/24 hrs; milligrams per 24 hours; mg/kg/dy; mg per kg per day; milligrams per kilograms per days"
        .split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per 6 hour",
    "mg/(6.h)",
    "MG/HR",
    "mass",
    4.6296296296296295e-8,
    [0, -1, 1, 0, 0, 0, 0],
    "mg/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg/6hrs; mg/6 hrs; mg per 6 hrs; 6hrs; milligrams per 6 hours".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per 72 hour",
    "mg/(72.h)",
    "MG/HR",
    "mass",
    3.858024691358025e-9,
    [0, -1, 1, 0, 0, 0, 0],
    "mg/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg/72hrs; mg/72 hrs; 72 hrs; 72hrs; milligrams per 72 hours".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per 8 hour",
    "mg/(8.h)",
    "MG/HR",
    "mass",
    3.472222222222222e-8,
    [0, -1, 1, 0, 0, 0, 0],
    "mg/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg/8hrs; mg/8 hrs; milligrams per 8 hours; shift".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per day",
    "mg/d",
    "MG/D",
    "mass",
    1.1574074074074074e-8,
    [0, -1, 1, 0, 0, 0, 0],
    "mg/d",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg/24hrs; mg/24 hrs; milligrams per 24 hours; mg/dy; mg per day; milligrams"
        .split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per deciliter",
    "mg/dL",
    "MG/DL",
    "mass",
    10,
    [-3, 0, 1, 0, 0, 0, 0],
    "mg/dL",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg per dL; milligrams per deciliter; decilitre".split('; '),
    "LOINC",
    "MCnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per gram",
    "mg/g",
    "MG/G",
    "mass",
    0.001,
    [0, 0, 0, 0, 0, 0, 0],
    "mg/g",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg per gm; milligrams per gram".split('; '),
    "LOINC",
    "MCnt; MRto",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per hour",
    "mg/h",
    "MG/HR",
    "mass",
    2.7777777777777776e-7,
    [0, -1, 1, 0, 0, 0, 0],
    "mg/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg/hr; mg per hr; milligrams".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per kilogram",
    "mg/kg",
    "MG/KG",
    "mass",
    1e-6,
    [0, 0, 0, 0, 0, 0, 0],
    "mg/kg",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg per kg; milligrams per kilograms".split('; '),
    "LOINC",
    "MCnt",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per kilogram per 8 hour",
    "mg/kg/(8.h)",
    "(MG/KG)/HR",
    "mass",
    3.472222222222222e-11,
    [0, -1, 0, 0, 0, 0, 0],
    "(mg/kg)/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg/(8.h.kg); mg/kg/8hrs; mg/kg/8 hrs; mg per kg per 8hrs; 8 hrs; milligrams per kilograms per 8 hours; shift"
        .split('; '),
    "LOINC",
    "RelMRat; MCntRat",
    "Clinical",
    "unit used to measure mass dose rate per patient body mass",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per kilogram per day",
    "mg/kg/d",
    "(MG/KG)/D",
    "mass",
    1.1574074074074074e-11,
    [0, -1, 0, 0, 0, 0, 0],
    "(mg/kg)/d",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg/(kg.d); mg/(kg.24.h)mg/kg/dy; mg per kg per day; milligrams per kilograms per days; mg/kg/(24.h); mg/kg/24hrs; 24 hrs; 24 hours"
        .split('; '),
    "LOINC",
    "RelMRat ",
    "Clinical",
    "unit used to measure mass dose rate per patient body mass",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per kilogram per hour",
    "mg/kg/h",
    "(MG/KG)/HR",
    "mass",
    2.7777777777777777e-10,
    [0, -1, 0, 0, 0, 0, 0],
    "(mg/kg)/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg/(kg.h); mg/kg/hr; mg per kg per hr; milligrams per kilograms per hour"
        .split('; '),
    "LOINC",
    "RelMRat; MCntRat",
    "Clinical",
    "unit used to measure mass dose rate per patient body mass",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per kilogram per minute",
    "mg/kg/min",
    "(MG/KG)/MIN",
    "mass",
    1.6666666666666667e-8,
    [0, -1, 0, 0, 0, 0, 0],
    "(mg/kg)/min",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg/(kg.min); mg per kg per min; milligrams per kilograms per minute"
        .split('; '),
    "LOINC",
    "RelMRat; MCntRat",
    "Clinical",
    "unit used to measure mass dose rate per patient body mass",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per liter",
    "mg/L",
    "MG/L",
    "mass",
    1,
    [-3, 0, 1, 0, 0, 0, 0],
    "mg/L",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg per l; milligrams per liter; litre".split('; '),
    "LOINC",
    "MCnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per square meter",
    "mg/m2",
    "MG/M2",
    "mass",
    0.001,
    [-2, 0, 1, 0, 0, 0, 0],
    "mg/(m<sup>2</sup>)",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg/m^2; mg/sq. m; mg per m2; mg per m^2; mg per sq. milligrams; meter squared; metre"
        .split('; '),
    "LOINC",
    "ArMass",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per cubic meter",
    "mg/m3",
    "MG/M3",
    "mass",
    0.001,
    [-3, 0, 1, 0, 0, 0, 0],
    "mg/(m<sup>3</sup>)",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg/m^3; mg/cu. m; mg per m3; milligrams per cubic meter; meter cubed; metre"
        .split('; '),
    "LOINC",
    "MCnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per milligram",
    "mg/mg",
    "MG/MG",
    "mass",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "mg/mg",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg per mg; milligrams; milligram/milligram".split('; '),
    "LOINC",
    "MRto",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per minute",
    "mg/min",
    "MG/MIN",
    "mass",
    16666666666666667e-21,
    [0, -1, 1, 0, 0, 0, 0],
    "mg/min",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg per min; milligrams per minutes; milligram/minute".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per milliliter",
    "mg/mL",
    "MG/ML",
    "mass",
    1000.0000000000001,
    [-3, 0, 1, 0, 0, 0, 0],
    "mg/mL",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg per mL; milligrams per milliliters; millilitre".split('; '),
    "LOINC",
    "MCnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per millimole",
    "mg/mmol",
    "MG/MMOL",
    "mass",
    1.660540186674939e-24,
    [0, 0, 1, 0, 0, 0, 0],
    "mg/mmol",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    -1,
    "mg per mmol; milligrams per millimole; ".split('; '),
    "LOINC",
    "Ratio",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "milligram per week",
    "mg/wk",
    "MG/WK",
    "mass",
    1.6534391534391535e-9,
    [0, -1, 1, 0, 0, 0, 0],
    "mg/wk",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mg/week; mg per wk; milligrams per weeks; milligram/week".split('; '),
    "LOINC",
    "Mrat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "milliliter",
    "mL",
    "ML",
    "volume",
    1e-6,
    [3, 0, 0, 0, 0, 0, 0],
    "mL",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "milliliters; millilitres".split('; '),
    "LOINC",
    "Vol",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per 10 hour",
    "mL/(10.h)",
    "ML/HR",
    "volume",
    2.7777777777777777e-11,
    [3, -1, 0, 0, 0, 0, 0],
    "mL/h",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "ml/10hrs; ml/10 hrs; mL per 10hrs; 10 hrs; milliliters per 10 hours; millilitres"
        .split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per 12 hour",
    "mL/(12.h)",
    "ML/HR",
    "volume",
    2.3148148148148147e-11,
    [3, -1, 0, 0, 0, 0, 0],
    "mL/h",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "ml/12hrs; ml/12 hrs; mL per 12hrs; 12 hrs; milliliters per 12 hours; millilitres"
        .split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per 2 hour",
    "mL/(2.h)",
    "ML/HR",
    "volume",
    1.3888888888888888e-10,
    [3, -1, 0, 0, 0, 0, 0],
    "mL/h",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "ml/2hrs; ml/2 hrs; mL per 2hrs; 2 hrs; milliliters per 2 hours; millilitres "
        .split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per 24 hour",
    "mL/(24.h)",
    "ML/HR",
    "volume",
    1.1574074074074074e-11,
    [3, -1, 0, 0, 0, 0, 0],
    "mL/h",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "ml/24hrs; ml/24 hrs; mL per 24hrs; 24 hrs; milliliters per 24 hours; millilitres; ml/dy; /day; ml per dy; days; fluid outputs; fluid inputs; flow rate"
        .split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per 4 hour",
    "mL/(4.h)",
    "ML/HR",
    "volume",
    6.944444444444444e-11,
    [3, -1, 0, 0, 0, 0, 0],
    "mL/h",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "ml/4hrs; ml/4 hrs; mL per 4hrs; 4 hrs; milliliters per 4 hours; millilitres"
        .split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per 5 hour",
    "mL/(5.h)",
    "ML/HR",
    "volume",
    5.5555555555555553e-11,
    [3, -1, 0, 0, 0, 0, 0],
    "mL/h",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "ml/5hrs; ml/5 hrs; mL per 5hrs; 5 hrs; milliliters per 5 hours; millilitres"
        .split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per 6 hour",
    "mL/(6.h)",
    "ML/HR",
    "volume",
    4.6296296296296294e-11,
    [3, -1, 0, 0, 0, 0, 0],
    "mL/h",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "ml/6hrs; ml/6 hrs; mL per 6hrs; 6 hrs; milliliters per 6 hours; millilitres"
        .split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per 72 hour",
    "mL/(72.h)",
    "ML/HR",
    "volume",
    3.8580246913580245e-12,
    [3, -1, 0, 0, 0, 0, 0],
    "mL/h",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "ml/72hrs; ml/72 hrs; mL per 72hrs; 72 hrs; milliliters per 72 hours; millilitres"
        .split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per 8 hour",
    "mL/(8.h)",
    "ML/HR",
    "volume",
    3.472222222222222e-11,
    [3, -1, 0, 0, 0, 0, 0],
    "mL/h",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "ml/8hrs; ml/8 hrs; mL per 8hrs; 8 hrs; milliliters per 8 hours; millilitres; shift"
        .split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per 8 hour per kilogram",
    "mL/(8.h)/kg",
    "(ML/HR)/KG",
    "volume",
    3.472222222222222e-14,
    [3, -1, -1, 0, 0, 0, 0],
    "(mL/h)/kg",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mL/kg/(8.h); ml/8h/kg; ml/8 h/kg; ml/8hr/kg; ml/8 hr/kgr; mL per 8h per kg; 8 h; 8hr; 8 hr; milliliters per 8 hours per kilogram; millilitres; shift"
        .split('; '),
    "LOINC",
    "VRatCnt",
    "Clinical",
    "unit used to measure renal excretion volume rate per body mass",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per square inch (international)",
    "mL/[sin_i]",
    "ML/[SIN_I]",
    "volume",
    0.0015500031000061998,
    [1, 0, 0, 0, 0, 0, 0],
    "mL",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mL/sin; mL/in2; mL/in^2; mL per sin; in2; in^2; sq. in; milliliters per square inch; inch squared"
        .split('; '),
    "LOINC",
    "ArVol",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per centimeter of water",
    "mL/cm[H2O]",
    "ML/CM[H2O]",
    "volume",
    1.0197162129779282e-11,
    [4, 2, -1, 0, 0, 0, 0],
    "mL/(cm HO<sub><r>2</r></sub>)",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "milliliters per centimeter of water; millilitre per centimetre of water; millilitres per centimetre of water; mL/cmH2O; mL/cm H2O; mL per cmH2O; mL per cm H2O"
        .split('; '),
    "LOINC",
    "Compli",
    "Clinical",
    "unit used to measure dynamic lung compliance",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per day",
    "mL/d",
    "ML/D",
    "volume",
    1.1574074074074074e-11,
    [3, -1, 0, 0, 0, 0, 0],
    "mL/d",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "ml/day; ml per day; milliliters per day; 24 hours; 24hrs; millilitre;"
        .split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "usually used to measure fluid output or input; flow rate",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per deciliter",
    "mL/dL",
    "ML/DL",
    "volume",
    0.009999999999999998,
    [0, 0, 0, 0, 0, 0, 0],
    "mL/dL",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mL per dL; millilitres; decilitre; milliliters".split('; '),
    "LOINC",
    "VFr; VFrDiff",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per hour",
    "mL/h",
    "ML/HR",
    "volume",
    2.7777777777777777e-10,
    [3, -1, 0, 0, 0, 0, 0],
    "mL/h",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mL/hr; mL per hr; milliliters per hour; millilitres; fluid intake; fluid output"
        .split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per kilogram",
    "mL/kg",
    "ML/KG",
    "volume",
    9.999999999999999e-10,
    [3, 0, -1, 0, 0, 0, 0],
    "mL/kg",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mL per kg; milliliters per kilogram; millilitres".split('; '),
    "LOINC",
    "VCnt",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per kilogram per 8 hour",
    "mL/kg/(8.h)",
    "(ML/KG)/HR",
    "volume",
    3.472222222222222e-14,
    [3, -1, -1, 0, 0, 0, 0],
    "(mL/kg)/h",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mL/(8.h.kg); mL/kg/8hrs; mL/kg/8 hrs; mL per kg per 8hrs; 8 hrs; milliliters per kilograms per 8 hours; millilitres; shift"
        .split('; '),
    "LOINC",
    "VCntRat; RelEngRat",
    "Clinical",
    "unit used to measure renal excretion volume rate per body mass",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per kilogram per day",
    "mL/kg/d",
    "(ML/KG)/D",
    "volume",
    1.1574074074074072e-14,
    [3, -1, -1, 0, 0, 0, 0],
    "(mL/kg)/d",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mL/(kg.d); mL/kg/dy; mL per kg per day; milliliters per kilograms per day; mg/kg/24hrs; 24 hrs; per 24 hours millilitres"
        .split('; '),
    "LOINC",
    "VCntRat; RelEngRat",
    "Clinical",
    "unit used to measure renal excretion volume rate per body mass",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per kilogram per hour",
    "mL/kg/h",
    "(ML/KG)/HR",
    "volume",
    2.7777777777777774e-13,
    [3, -1, -1, 0, 0, 0, 0],
    "(mL/kg)/h",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mL/(kg.h); mL/kg/hr; mL per kg per hr; milliliters per kilograms per hour; millilitres"
        .split('; '),
    "LOINC",
    "VCntRat; RelEngRat",
    "Clinical",
    "unit used to measure renal excretion volume rate per body mass",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per kilogram per minute",
    "mL/kg/min",
    "(ML/KG)/MIN",
    "volume",
    1.6666666666666664e-11,
    [3, -1, -1, 0, 0, 0, 0],
    "(mL/kg)/min",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mL/(kg.min); mL/kg/dy; mL per kg per day; milliliters per kilograms per day; millilitres"
        .split('; '),
    "LOINC",
    "RelEngRat",
    "Clinical",
    "used for tests that measure activity metabolic rate compared to standard resting metabolic rate ",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per square meter",
    "mL/m2",
    "ML/M2",
    "volume",
    1e-6,
    [1, 0, 0, 0, 0, 0, 0],
    "mL/(m<sup>2</sup>)",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mL/m^2; mL/sq. meter; mL per m2; m^2; sq. meter; milliliters per square meter; millilitres; meter squared"
        .split('; '),
    "LOINC",
    "ArVol",
    "Clinical",
    "used for tests that relate to heart work - e.g. ventricular stroke volume; atrial volume per body surface area",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per millibar",
    "mL/mbar",
    "ML/MBAR",
    "volume",
    1e-11,
    [4, 2, -1, 0, 0, 0, 0],
    "mL/mbar",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mL per mbar; milliliters per millibar; millilitres".split('; '),
    "LOINC",
    "",
    "Clinical",
    "unit used to measure dynamic lung compliance",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per minute",
    "mL/min",
    "ML/MIN",
    "volume",
    1.6666666666666667e-8,
    [3, -1, 0, 0, 0, 0, 0],
    "mL/min",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mL per min; milliliters; millilitres".split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per minute per square meter",
    "mL/min/m2",
    "(ML/MIN)/M2",
    "volume",
    1.6666666666666667e-8,
    [1, -1, 0, 0, 0, 0, 0],
    "(mL/min)/(m<sup>2</sup>)",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "ml/min/m^2; ml/min/sq. meter; mL per min per m2; m^2; sq. meter; milliliters per minutes per square meter; millilitres; metre; meter squared"
        .split('; '),
    "LOINC",
    "ArVRat",
    "Clinical",
    "unit used to measure volume per body surface area; oxygen consumption index",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per millimeter",
    "mL/mm",
    "ML/MM",
    "volume",
    0.001,
    [2, 0, 0, 0, 0, 0, 0],
    "mL/mm",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mL per mm; milliliters per millimeter; millilitres; millimetre"
        .split('; '),
    "LOINC",
    "Lineic Volume",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliliter per second",
    "mL/s",
    "ML/S",
    "volume",
    1e-6,
    [3, -1, 0, 0, 0, 0, 0],
    "mL/s",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "ml/sec; mL per sec; milliliters per second; millilitres".split('; '),
    "LOINC",
    "Vel; VelRat; VRat",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    true,
    "millimeter",
    "mm",
    "MM",
    "length",
    0.001,
    [1, 0, 0, 0, 0, 0, 0],
    "mm",
    null,
    false,
    "L",
    null,
    1,
    false,
    false,
    0,
    "millimeters; millimetres; height; length; diameter; thickness; axis; curvature; size"
        .split('; '),
    "LOINC",
    "Len",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "millimeter per hour",
    "mm/h",
    "MM/HR",
    "length",
    2.7777777777777776e-7,
    [1, -1, 0, 0, 0, 0, 0],
    "mm/h",
    null,
    false,
    "L",
    null,
    1,
    false,
    false,
    0,
    "mm/hr; mm per hr; millimeters per hour; millimetres".split('; '),
    "LOINC",
    "Vel",
    "Clinical",
    "unit to measure sedimentation rate",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "millimeter per minute",
    "mm/min",
    "MM/MIN",
    "length",
    16666666666666667e-21,
    [1, -1, 0, 0, 0, 0, 0],
    "mm/min",
    null,
    false,
    "L",
    null,
    1,
    false,
    false,
    0,
    "mm per min; millimeters per minute; millimetres".split('; '),
    "LOINC",
    "Vel",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "millimeter of water",
    "mm[H2O]",
    "MM[H2O]",
    "pressure",
    9806.65,
    [-1, -2, 1, 0, 0, 0, 0],
    "mm HO<sub><r>2</r></sub>",
    "clinical",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mmH2O; mm H2O; millimeters of water; millimetres".split('; '),
    "LOINC",
    "Pres",
    "Clinical",
    "",
    "kPa",
    "KPAL",
    "980665e-5",
    9.80665,
    false,
  ),
  UcumUnit(
    false,
    "millimeter of mercury",
    "mm[Hg]",
    "MM[HG]",
    "pressure",
    133322,
    [-1, -2, 1, 0, 0, 0, 0],
    "mm Hg",
    "clinical",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mmHg; mm Hg; millimeters of mercury; millimetres".split('; '),
    "LOINC",
    "Pres; PPres; Ratio",
    "Clinical",
    "1 mm[Hg] = 1 torr; unit to measure blood pressure",
    "kPa",
    "KPAL",
    "133.3220",
    133.322,
    false,
  ),
  UcumUnit(
    true,
    "square millimeter",
    "mm2",
    "MM2",
    "length",
    1e-6,
    [2, 0, 0, 0, 0, 0, 0],
    "mm<sup>2</sup>",
    null,
    false,
    "L",
    null,
    1,
    false,
    false,
    0,
    "mm^2; sq. mm.; sq. millimeters; millimeters squared; millimetres"
        .split('; '),
    "LOINC",
    "Area",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "millimole",
    "mmol",
    "MMOL",
    "amount of substance",
    60221367e13,
    [0, 0, 0, 0, 0, 0, 0],
    "mmol",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    ["millimoles"],
    "LOINC",
    "Sub",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "millimole per 12 hour",
    "mmol/(12.h)",
    "MMOL/HR",
    "amount of substance",
    1394013125e7,
    [0, -1, 0, 0, 0, 0, 0],
    "mmol/h",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mmol/12hrs; mmol/12 hrs; mmol per 12 hrs; 12hrs; millimoles per 12 hours"
        .split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "unit for tests related to urine",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "millimole per 2 hour",
    "mmol/(2.h)",
    "MMOL/HR",
    "amount of substance",
    836407875e8,
    [0, -1, 0, 0, 0, 0, 0],
    "mmol/h",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mmol/2hrs; mmol/2 hrs; mmol per 2 hrs; 2hrs; millimoles per 2 hours"
        .split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "unit for tests related to urine",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "millimole per 24 hour",
    "mmol/(24.h)",
    "MMOL/HR",
    "amount of substance",
    6970065625e6,
    [0, -1, 0, 0, 0, 0, 0],
    "mmol/h",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mmol/24hrs; mmol/24 hrs; mmol per 24 hrs; 24hrs; millimoles per 24 hours"
        .split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "millimole per 5 hour",
    "mmol/(5.h)",
    "MMOL/HR",
    "amount of substance",
    33456315e9,
    [0, -1, 0, 0, 0, 0, 0],
    "mmol/h",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mmol/5hrs; mmol/5 hrs; mmol per 5 hrs; 5hrs; millimoles per 5 hours"
        .split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "unit for tests related to doses",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "millimole per 6 hour",
    "mmol/(6.h)",
    "MMOL/HR",
    "amount of substance",
    278802625e8,
    [0, -1, 0, 0, 0, 0, 0],
    "mmol/h",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mmol/6hrs; mmol/6 hrs; mmol per 6 hrs; 6hrs; millimoles per 6 hours"
        .split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "unit for tests related to urine",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "millimole per 8 hour",
    "mmol/(8.h)",
    "MMOL/HR",
    "amount of substance",
    20910196875e6,
    [0, -1, 0, 0, 0, 0, 0],
    "mmol/h",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mmol/8hrs; mmol/8 hrs; mmol per 8 hrs; 8hrs; millimoles per 8 hours; shift"
        .split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "millimole per day",
    "mmol/d",
    "MMOL/D",
    "amount of substance",
    6970065625e6,
    [0, -1, 0, 0, 0, 0, 0],
    "mmol/d",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mmol/24hrs; mmol/24 hrs; mmol per 24 hrs; 24hrs; millimoles per 24 hours"
        .split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "millimole per deciliter",
    "mmol/dL",
    "MMOL/DL",
    "amount of substance",
    6.022136699999999e24,
    [-3, 0, 0, 0, 0, 0, 0],
    "mmol/dL",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mmol per dL; millimoles; decilitre".split('; '),
    "LOINC",
    "SCnc",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "millimole per gram",
    "mmol/g",
    "MMOL/G",
    "amount of substance",
    60221367e13,
    [0, 0, -1, 0, 0, 0, 0],
    "mmol/g",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mmol per gram; millimoles".split('; '),
    "LOINC",
    "SCnt",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "millimole per hour",
    "mmol/h",
    "MMOL/HR",
    "amount of substance",
    167281575e9,
    [0, -1, 0, 0, 0, 0, 0],
    "mmol/h",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mmol/hr; mmol per hr; millimoles per hour".split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "unit for tests related to urine",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "millimole per kilogram",
    "mmol/kg",
    "MMOL/KG",
    "amount of substance",
    60221367e10,
    [0, 0, -1, 0, 0, 0, 0],
    "mmol/kg",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mmol per kg; millimoles per kilogram".split('; '),
    "LOINC",
    "SCnt",
    "Clinical",
    "unit for tests related to stool",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "millimole per kilogram per 8 hour",
    "mmol/kg/(8.h)",
    "(MMOL/KG)/HR",
    "amount of substance",
    20910196875e3,
    [0, -1, -1, 0, 0, 0, 0],
    "(mmol/kg)/h",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mmol/(8.h.kg); mmol/kg/8hrs; mmol/kg/8 hrs; mmol per kg per 8hrs; 8 hrs; millimoles per kilograms per 8 hours; shift"
        .split('; '),
    "LOINC",
    "CCnt",
    "Clinical",
    "unit used to measure molar dose rate per patient body mass",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "millimole per kilogram per day",
    "mmol/kg/d",
    "(MMOL/KG)/D",
    "amount of substance",
    6970065625e3,
    [0, -1, -1, 0, 0, 0, 0],
    "(mmol/kg)/d",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mmol/kg/dy; mmol/kg/day; mmol per kg per dy; millimoles per kilograms per day"
        .split('; '),
    "LOINC",
    "RelSRat",
    "Clinical",
    "unit used to measure molar dose rate per patient body mass",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "millimole per kilogram per hour",
    "mmol/kg/h",
    "(MMOL/KG)/HR",
    "amount of substance",
    167281575e6,
    [0, -1, -1, 0, 0, 0, 0],
    "(mmol/kg)/h",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mmol/kg/hr; mmol per kg per hr; millimoles per kilograms per hour"
        .split('; '),
    "LOINC",
    "CCnt",
    "Clinical",
    "unit used to measure molar dose rate per patient body mass",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "millimole per kilogram per minute",
    "mmol/kg/min",
    "(MMOL/KG)/MIN",
    "amount of substance",
    100368945e8,
    [0, -1, -1, 0, 0, 0, 0],
    "(mmol/kg)/min",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mmol/(kg.min); mmol/kg/min; mmol per kg per min; millimoles per kilograms per minute"
        .split('; '),
    "LOINC",
    "CCnt",
    "Clinical",
    "unit used to measure molar dose rate per patient body mass; note that the unit for the enzyme unit U = umol/min. mmol/kg/min = kU/kg; ",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "millimole per liter",
    "mmol/L",
    "MMOL/L",
    "amount of substance",
    6.0221367e23,
    [-3, 0, 0, 0, 0, 0, 0],
    "mmol/L",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mmol per L; millimoles per liter; litre".split('; '),
    "LOINC",
    "SCnc",
    "Clinical",
    "unit for tests related to doses",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "millimole per square meter",
    "mmol/m2",
    "MMOL/M2",
    "amount of substance",
    60221367e13,
    [-2, 0, 0, 0, 0, 0, 0],
    "mmol/(m<sup>2</sup>)",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mmol/m^2; mmol/sq. meter; mmol per m2; m^2; sq. meter; millimoles; meter squared; metre"
        .split('; '),
    "LOINC",
    "ArSub",
    "Clinical",
    "unit used to measure molar dose per patient body surface area",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "millimole per minute",
    "mmol/min",
    "MMOL/MIN",
    "amount of substance",
    100368945e11,
    [0, -1, 0, 0, 0, 0, 0],
    "mmol/min",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mmol per min; millimoles per minute".split('; '),
    "LOINC",
    "Srat; CAct",
    "Clinical",
    "unit for the enzyme unit U = umol/min. mmol/min = kU",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "millimole per millimole",
    "mmol/mmol",
    "MMOL/MMOL",
    "amount of substance",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "mmol/mmol",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mmol per mmol; millimoles per millimole".split('; '),
    "LOINC",
    "SRto",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "millimole per mole",
    "mmol/mol",
    "MMOL/MOL",
    "amount of substance",
    0.001,
    [0, 0, 0, 0, 0, 0, 0],
    "mmol/mol",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mmol per mol; millimoles per mole".split('; '),
    "LOINC",
    "SRto",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "millimole per second per liter",
    "mmol/s/L",
    "(MMOL/S)/L",
    "amount of substance",
    6.0221367e23,
    [-3, -1, 0, 0, 0, 0, 0],
    "(mmol/s)/L",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mmol/sec/L; mmol per s per L; per sec; millimoles per seconds per liter; litre"
        .split('; '),
    "LOINC",
    "CCnc ",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "mole per kilogram",
    "mol/kg",
    "MOL/KG",
    "amount of substance",
    60221367e13,
    [0, 0, -1, 0, 0, 0, 0],
    "mol/kg",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mol per kg; moles; mols".split('; '),
    "LOINC",
    "SCnt",
    "Clinical",
    "unit for tests related to stool",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "mole per kilogram per second",
    "mol/kg/s",
    "(MOL/KG)/S",
    "amount of substance",
    60221367e13,
    [0, -1, -1, 0, 0, 0, 0],
    "(mol/kg)/s",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mol/kg/sec; mol per kg per sec; moles per kilograms per second; mols"
        .split('; '),
    "LOINC",
    "CCnt",
    "Clinical",
    "unit of catalytic activity (mol/s) per mass (kg)",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "mole per liter",
    "mol/L",
    "MOL/L",
    "amount of substance",
    6.0221366999999994e26,
    [-3, 0, 0, 0, 0, 0, 0],
    "mol/L",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mol per L; moles per liter; litre; moles; mols".split('; '),
    "LOINC",
    "SCnc",
    "Clinical",
    "unit often used in tests measuring oxygen content",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "mole per cubic meter",
    "mol/m3",
    "MOL/M3",
    "amount of substance",
    6.0221367e23,
    [-3, 0, 0, 0, 0, 0, 0],
    "mol/(m<sup>3</sup>)",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mol/m^3; mol/cu. m; mol per m3; m^3; cu. meter; mols; moles; meters cubed; metre; mole per kiloliter; kilolitre; mol/kL"
        .split('; '),
    "LOINC",
    "SCnc",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "mole per milliliter",
    "mol/mL",
    "MOL/ML",
    "amount of substance",
    6.0221367e29,
    [-3, 0, 0, 0, 0, 0, 0],
    "mol/mL",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mol per mL; moles; millilitre; mols".split('; '),
    "LOINC",
    "SCnc",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "mole per mole",
    "mol/mol",
    "MOL/MOL",
    "amount of substance",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "mol/mol",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mol per mol; moles per mol; mols".split('; '),
    "LOINC",
    "SRto",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "mole per second",
    "mol/s",
    "MOL/S",
    "amount of substance",
    6.0221367e23,
    [0, -1, 0, 0, 0, 0, 0],
    "mol/s",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mol per sec; moles per second; mols".split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "milliosmole",
    "mosm",
    "MOSM",
    "amount of substance (dissolved particles)",
    60221367e13,
    [0, 0, 0, 0, 0, 0, 0],
    "mosm",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    ["milliosmoles"],
    "LOINC",
    "Osmol",
    "Clinical",
    "equal to 1/1000 of an osmole",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliosmole per kilogram",
    "mosm/kg",
    "MOSM/KG",
    "amount of substance (dissolved particles)",
    60221367e10,
    [0, 0, -1, 0, 0, 0, 0],
    "mosm/kg",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mosm per kg; milliosmoles per kilogram".split('; '),
    "LOINC",
    "Osmol",
    "Clinical",
    "",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milliosmole per liter",
    "mosm/L",
    "MOSM/L",
    "amount of substance (dissolved particles)",
    6.0221367e23,
    [-3, 0, 0, 0, 0, 0, 0],
    "mosm/L",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mosm per liter; litre; milliosmoles".split('; '),
    "LOINC",
    "Osmol",
    "Clinical",
    "",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "millipascal",
    "mPa",
    "MPAL",
    "pressure",
    1,
    [-1, -2, 1, 0, 0, 0, 0],
    "mPa",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "millipascals",
    ],
    "LOINC",
    "Pres",
    "Clinical",
    "unit of pressure",
    "N/m2",
    "N/M2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "millipascal second",
    "mPa.s",
    "MPAL.S",
    "pressure",
    1,
    [-1, -1, 1, 0, 0, 0, 0],
    "mPa.s",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "mPa*s; millipoise; mP; dynamic viscosity".split('; '),
    "LOINC",
    "Visc",
    "Clinical",
    "base units for millipoise, a measurement of dynamic viscosity",
    "N/m2",
    "N/M2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    true,
    "megasecond",
    "Ms",
    "MAS",
    "time",
    1e6,
    [0, 1, 0, 0, 0, 0, 0],
    "Ms",
    null,
    false,
    "T",
    null,
    1,
    false,
    false,
    0,
    [
      "megaseconds",
    ],
    "LOINC",
    "Time",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "millisecond",
    "ms",
    "MS",
    "time",
    0.001,
    [0, 1, 0, 0, 0, 0, 0],
    "ms",
    null,
    false,
    "T",
    null,
    1,
    false,
    false,
    0,
    "milliseconds; duration".split('; '),
    "LOINC",
    "Time",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "milli enzyme unit per gram",
    "mU/g",
    "MU/G",
    "catalytic activity",
    100368945e5,
    [0, -1, -1, 0, 0, 0, 0],
    "mU/g",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mU per gm; milli enzyme units per gram; enzyme activity; enzymatic activity per mass"
        .split('; '),
    "LOINC",
    "CCnt",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min); 1 mU = 1 nmol/min",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milli enzyme unit per liter",
    "mU/L",
    "MU/L",
    "catalytic activity",
    100368945e8,
    [-3, -1, 0, 0, 0, 0, 0],
    "mU/L",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mU per liter; litre; milli enzyme units enzymatic activity per volume; enzyme activity"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min); 1 mU = 1 nmol/min",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milli enzyme unit per milligram",
    "mU/mg",
    "MU/MG",
    "catalytic activity",
    100368945e8,
    [0, -1, -1, 0, 0, 0, 0],
    "mU/mg",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mU per mg; milli enzyme units per milligram".split('; '),
    "LOINC",
    "CCnt",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min); 1 mU = 1 nmol/min",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milli enzyme unit per milliliter",
    "mU/mL",
    "MU/ML",
    "catalytic activity",
    100368945e11,
    [-3, -1, 0, 0, 0, 0, 0],
    "mU/mL",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mU per mL; milli enzyme units per milliliter; millilitre; enzymatic activity per volume; enzyme activity"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min); 1 mU = 1 nmol/min",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "milli enzyme unit per milliliter per minute",
    "mU/mL/min",
    "(MU/ML)/MIN",
    "catalytic activity",
    167281575e9,
    [-3, -2, 0, 0, 0, 0, 0],
    "(mU/mL)/min",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "mU per mL per min; mU per milliliters per minute; millilitres; milli enzyme units; enzymatic activity; enzyme activity"
        .split('; '),
    "LOINC",
    "CCncRat",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min); 1 mU = 1 nmol/min",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "millivolt",
    "mV",
    "MV",
    "electric potential",
    1,
    [2, -2, 1, 0, 0, -1, 0],
    "mV",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "millivolts",
    ],
    "LOINC",
    "Elpot",
    "Clinical",
    "unit of electric potential (voltage)",
    "J/C",
    "J/C",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Newton centimeter",
    "N.cm",
    "N.CM",
    "force",
    10,
    [2, -2, 1, 0, 0, 0, 0],
    "N.cm",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "N*cm; Ncm; N cm; Newton*centimeters; Newton* centimetres; torque; work"
        .split('; '),
    "LOINC",
    "",
    "Clinical",
    "as a measurement of work, N.cm = 1/100 Joules;\nnote that N.m is the standard unit of measurement for torque (although dimensionally equivalent to Joule), and N.cm can also be thought of as a torqe unit",
    "kg.m/s2",
    "KG.M/S2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Newton second",
    "N.s",
    "N.S",
    "force",
    1e3,
    [1, -1, 1, 0, 0, 0, 0],
    "N.s",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "Newton*seconds; N*s; N s; Ns; impulse; imp".split('; '),
    "LOINC",
    "",
    "Clinical",
    "standard unit of impulse",
    "kg.m/s2",
    "KG.M/S2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    true,
    "nanogram",
    "ng",
    "NG",
    "mass",
    1e-9,
    [0, 0, 1, 0, 0, 0, 0],
    "ng",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    [
      "nanograms",
    ],
    "LOINC",
    "Mass",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "nanogram per 24 hour",
    "ng/(24.h)",
    "NG/HR",
    "mass",
    1.1574074074074075e-14,
    [0, -1, 1, 0, 0, 0, 0],
    "ng/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ng/24hrs; ng/24 hrs; nanograms per 24 hours".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "nanogram per 8 hour",
    "ng/(8.h)",
    "NG/HR",
    "mass",
    3.4722222222222224e-14,
    [0, -1, 1, 0, 0, 0, 0],
    "ng/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ng/8hrs; ng/8 hrs; nanograms per 8 hours".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "nanogram per million",
    "ng/10*6",
    "NG/(10*6)",
    "mass",
    1e-15,
    [0, 0, 1, 0, 0, 0, 0],
    "ng/(10<sup>6</sup>)",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ng/10^6; ng per 10*6; 10^6; nanograms".split('; '),
    "LOINC",
    "MNum",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "nanogram per day",
    "ng/d",
    "NG/D",
    "mass",
    1.1574074074074075e-14,
    [0, -1, 1, 0, 0, 0, 0],
    "ng/d",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ng/dy; ng per day; nanograms ".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "nanogram per deciliter",
    "ng/dL",
    "NG/DL",
    "mass",
    1e-5,
    [-3, 0, 1, 0, 0, 0, 0],
    "ng/dL",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ng per dL; nanograms per deciliter; decilitre".split('; '),
    "LOINC",
    "MCnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "nanogram per gram",
    "ng/g",
    "NG/G",
    "mass",
    1e-9,
    [0, 0, 0, 0, 0, 0, 0],
    "ng/g",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ng/gm; ng per gm; nanograms per gram".split('; '),
    "LOINC",
    "MCnt",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "nanogram per hour",
    "ng/h",
    "NG/HR",
    "mass",
    2.777777777777778e-13,
    [0, -1, 1, 0, 0, 0, 0],
    "ng/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ng/hr; ng per hr; nanograms per hour".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "nanogram per kilogram",
    "ng/kg",
    "NG/KG",
    "mass",
    1e-12,
    [0, 0, 0, 0, 0, 0, 0],
    "ng/kg",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ng per kg; nanograms per kilogram".split('; '),
    "LOINC",
    "MCnt",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "nanogram per kilogram per 8 hour",
    "ng/kg/(8.h)",
    "(NG/KG)/HR",
    "mass",
    3.472222222222222e-17,
    [0, -1, 0, 0, 0, 0, 0],
    "(ng/kg)/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ng/(8.h.kg); ng/kg/8hrs; ng/kg/8 hrs; ng per kg per 8hrs; 8 hrs; nanograms per kilograms per 8 hours; shift"
        .split('; '),
    "LOINC",
    "MRtoRat ",
    "Clinical",
    "unit used to measure mass dose rate per patient body mass",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "nanogram per kilogram per hour",
    "ng/kg/h",
    "(NG/KG)/HR",
    "mass",
    2.7777777777777775e-16,
    [0, -1, 0, 0, 0, 0, 0],
    "(ng/kg)/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ng/(kg.h); ng/kg/hr; ng per kg per hr; nanograms per kilograms per hour"
        .split('; '),
    "LOINC",
    "MRtoRat ",
    "Clinical",
    "unit used to measure mass dose rate per patient body mass",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "nanogram per kilogram per minute",
    "ng/kg/min",
    "(NG/KG)/MIN",
    "mass",
    1.6666666666666667e-14,
    [0, -1, 0, 0, 0, 0, 0],
    "(ng/kg)/min",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ng/(kg.min); ng per kg per min; nanograms per kilograms per minute"
        .split('; '),
    "LOINC",
    "MRtoRat ",
    "Clinical",
    "unit used to measure mass dose rate per patient body mass",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "nanogram per liter",
    "ng/L",
    "NG/L",
    "mass",
    1e-6,
    [-3, 0, 1, 0, 0, 0, 0],
    "ng/L",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ng per L; nanograms per liter; litre".split('; '),
    "LOINC",
    "MCnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "nanogram per square meter",
    "ng/m2",
    "NG/M2",
    "mass",
    1e-9,
    [-2, 0, 1, 0, 0, 0, 0],
    "ng/(m<sup>2</sup>)",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ng/m^2; ng/sq. m; ng per m2; m^2; sq. meter; nanograms; meter squared; metre"
        .split('; '),
    "LOINC",
    "ArMass",
    "Clinical",
    "unit used to measure mass dose per patient body surface area",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "nanogram per milligram",
    "ng/mg",
    "NG/MG",
    "mass",
    1e-6,
    [0, 0, 0, 0, 0, 0, 0],
    "ng/mg",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ng per mg; nanograms".split('; '),
    "LOINC",
    "MCnt",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "nanogram per milligram per hour",
    "ng/mg/h",
    "(NG/MG)/HR",
    "mass",
    2.7777777777777777e-10,
    [0, -1, 0, 0, 0, 0, 0],
    "(ng/mg)/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ng/mg/hr; ng per mg per hr; nanograms per milligrams per hour".split('; '),
    "LOINC",
    "MRtoRat ",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "nanogram per minute",
    "ng/min",
    "NG/MIN",
    "mass",
    1.6666666666666667e-11,
    [0, -1, 1, 0, 0, 0, 0],
    "ng/min",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ng per min; nanograms".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "nanogram per millliiter",
    "ng/mL",
    "NG/ML",
    "mass",
    0.001,
    [-3, 0, 1, 0, 0, 0, 0],
    "ng/mL",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ng per mL; nanograms; millilitre".split('; '),
    "LOINC",
    "MCnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "nanogram per milliliter per hour",
    "ng/mL/h",
    "(NG/ML)/HR",
    "mass",
    2.7777777777777776e-7,
    [-3, -1, 1, 0, 0, 0, 0],
    "(ng/mL)/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ng/mL/hr; ng per mL per mL; nanograms per milliliter per hour; nanogram per millilitre per hour; nanograms per millilitre per hour; enzymatic activity per volume; enzyme activity per milliliters"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "tests that measure enzymatic activity",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "nanogram per second",
    "ng/s",
    "NG/S",
    "mass",
    1e-9,
    [0, -1, 1, 0, 0, 0, 0],
    "ng/s",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ng/sec; ng per sec; nanograms per second".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "nanogram per enzyme unit",
    "ng/U",
    "NG/U",
    "mass",
    9.963241120049634e-26,
    [0, 1, 1, 0, 0, 0, 0],
    "ng/U",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    -1,
    "ng per U; nanograms per enzyme unit".split('; '),
    "LOINC",
    "CMass",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min)",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "nanokatal",
    "nkat",
    "NKAT",
    "catalytic activity",
    60221367e7,
    [0, -1, 0, 0, 0, 0, 0],
    "nkat",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    ["nanokatals"],
    "LOINC",
    "CAct",
    "Clinical",
    "kat is a unit of catalytic activity with base units = mol/s. Rarely used because its units are too large to practically express catalytic activity. See enzyme unit [U] which is the standard unit for catalytic activity.",
    "mol/s",
    "MOL/S",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "nanoliter",
    "nL",
    "NL",
    "volume",
    1.0000000000000002e-12,
    [3, 0, 0, 0, 0, 0, 0],
    "nL",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "nanoliters; nanolitres".split('; '),
    "LOINC",
    "Vol",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    true,
    "nanometer",
    "nm",
    "NM",
    "length",
    1e-9,
    [1, 0, 0, 0, 0, 0, 0],
    "nm",
    null,
    false,
    "L",
    null,
    1,
    false,
    false,
    0,
    "nanometers; nanometres".split('; '),
    "LOINC",
    "Len",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "nanometer per second per liter",
    "nm/s/L",
    "(NM/S)/L",
    "length",
    1e-6,
    [-2, -1, 0, 0, 0, 0, 0],
    "(nm/s)/L",
    null,
    false,
    "L",
    null,
    1,
    false,
    false,
    0,
    "nm/sec/liter; nm/sec/litre; nm per s per l; nm per sec per l; nanometers per second per liter; nanometre per second per litre; nanometres per second per litre"
        .split('; '),
    "LOINC",
    "VelCnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "nanomole",
    "nmol",
    "NMOL",
    "amount of substance",
    60221367e7,
    [0, 0, 0, 0, 0, 0, 0],
    "nmol",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    ["nanomoles"],
    "LOINC",
    "Sub",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "nanomole per 24 hour",
    "nmol/(24.h)",
    "NMOL/HR",
    "amount of substance",
    6970065625,
    [0, -1, 0, 0, 0, 0, 0],
    "nmol/h",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "nmol/24hr; nmol/24 hr; nanomoles per 24 hours; nmol/day; nanomoles per day; nmol per day; nanomole/day; nanomol/day"
        .split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "nanomole per day",
    "nmol/d",
    "NMOL/D",
    "amount of substance",
    6970065625,
    [0, -1, 0, 0, 0, 0, 0],
    "nmol/d",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "nmol/day; nanomoles per day; nmol per day; nanomole/day; nanomol/day; nmol/24hr; nmol/24 hr; nanomoles per 24 hours; "
        .split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "nanomole per deciliter",
    "nmol/dL",
    "NMOL/DL",
    "amount of substance",
    60221367e11,
    [-3, 0, 0, 0, 0, 0, 0],
    "nmol/dL",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "nmol per dL; nanomoles per deciliter; nanomole per decilitre; nanomoles per decilitre; nanomole/deciliter; nanomole/decilitre; nanomol/deciliter; nanomol/decilitre"
        .split('; '),
    "LOINC",
    "SCnc",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "nanomole per gram",
    "nmol/g",
    "NMOL/G",
    "amount of substance",
    60221367e7,
    [0, 0, -1, 0, 0, 0, 0],
    "nmol/g",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "nmol per gram; nanomoles per gram; nanomole/gram".split('; '),
    "LOINC",
    "SCnt",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "nanomole per hour per liter",
    "nmol/h/L",
    "(NMOL/HR)/L",
    "amount of substance",
    167281575e6,
    [-3, -1, 0, 0, 0, 0, 0],
    "(nmol/h)/L",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "nmol/hrs/L; nmol per hrs per L; nanomoles per hours per liter; litre; enzymatic activity per volume; enzyme activities"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "nanomole per liter",
    "nmol/L",
    "NMOL/L",
    "amount of substance",
    60221367e10,
    [-3, 0, 0, 0, 0, 0, 0],
    "nmol/L",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "nmol per L; nanomoles per liter; litre".split('; '),
    "LOINC",
    "SCnc",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "nanomole per milligram",
    "nmol/mg",
    "NMOL/MG",
    "amount of substance",
    60221367e10,
    [0, 0, -1, 0, 0, 0, 0],
    "nmol/mg",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "nmol per mg; nanomoles per milligram".split('; '),
    "LOINC",
    "SCnt",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "nanomole per milligram per hour",
    "nmol/mg/h",
    "(NMOL/MG)/HR",
    "amount of substance",
    167281575e6,
    [0, -1, -1, 0, 0, 0, 0],
    "(nmol/mg)/h",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "nmol/mg/hr; nmol per mg per hr; nanomoles per milligrams per hour"
        .split('; '),
    "LOINC",
    "SCntRat",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "nanomole per milligram of protein",
    "nmol/mg{prot}",
    "NMOL/MG",
    "amount of substance",
    60221367e10,
    [0, 0, -1, 0, 0, 0, 0],
    "nmol/mg",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "nanomoles; nmol/mg prot; nmol per mg prot".split('; '),
    "LOINC",
    "Ratio; CCnt",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "nanomole per minute",
    "nmol/min",
    "NMOL/MIN",
    "amount of substance",
    100368945e5,
    [0, -1, 0, 0, 0, 0, 0],
    "nmol/min",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "nmol per min; nanomoles per minute; milli enzyme units; enzyme activity per volume; enzymatic activity"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "unit for the enzyme unit U = umol/min. nmol/min = mU (milli enzyme unit)",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "nanomole per minute per milliliter",
    "nmol/min/mL",
    "(NMOL/MIN)/ML",
    "amount of substance",
    100368945e11,
    [-3, -1, 0, 0, 0, 0, 0],
    "(nmol/min)/mL",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "nmol per min per mL; nanomoles per minutes per milliliter; millilitre; milli enzyme units per volume; enzyme activity; enzymatic activity"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "unit for the enzyme unit U = umol/min. nmol/mL/min = mU/mL",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "nanomole per milliliter",
    "nmol/mL",
    "NMOL/ML",
    "amount of substance",
    60221367e13,
    [-3, 0, 0, 0, 0, 0, 0],
    "nmol/mL",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "nmol per mL; nanomoles per milliliter; millilitre".split('; '),
    "LOINC",
    "SCnc",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "nanomole per milliliter per hour",
    "nmol/mL/h",
    "(NMOL/ML)/HR",
    "amount of substance",
    167281575e9,
    [-3, -1, 0, 0, 0, 0, 0],
    "(nmol/mL)/h",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "nmol/mL/hr; nmol per mL per hr; nanomoles per milliliters per hour; millilitres; milli enzyme units per volume; enzyme activity; enzymatic activity"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "unit for the enzyme unit U = umol/min.",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "nanomole per milliliter per minute",
    "nmol/mL/min",
    "(NMOL/ML)/MIN",
    "amount of substance",
    100368945e11,
    [-3, -1, 0, 0, 0, 0, 0],
    "(nmol/mL)/min",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "nmol per mL per min; nanomoles per milliliters per min; millilitres; milli enzyme units per volume; enzyme activity; enzymatic activity"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "unit for the enzyme unit U = umol/min. nmol/mL/min = mU/mL",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "nanomole per millimole",
    "nmol/mmol",
    "NMOL/MMOL",
    "amount of substance",
    1e-6,
    [0, 0, 0, 0, 0, 0, 0],
    "nmol/mmol",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "nmol per mmol; nanomoles per millimole".split('; '),
    "LOINC",
    "SRto",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "nanomole per millimole of creatinine",
    "nmol/mmol{creat}",
    "NMOL/MMOL",
    "amount of substance",
    1e-6,
    [0, 0, 0, 0, 0, 0, 0],
    "nmol/mmol",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "nanomoles",
    ],
    "LOINC",
    "SRto",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "nanomole per mole",
    "nmol/mol",
    "NMOL/MOL",
    "amount of substance",
    1e-9,
    [0, 0, 0, 0, 0, 0, 0],
    "nmol/mol",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "nmol per mole; nanomoles".split('; '),
    "LOINC",
    "SRto",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "nanomole per nanomole",
    "nmol/nmol",
    "NMOL/NMOL",
    "amount of substance",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "nmol/nmol",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "nmol per nmol; nanomoles".split('; '),
    "LOINC",
    "SRto",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "nanomole per second",
    "nmol/s",
    "NMOL/S",
    "amount of substance",
    60221367e7,
    [0, -1, 0, 0, 0, 0, 0],
    "nmol/s",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "nmol/sec; nmol per sec; nanomoles per sercond; milli enzyme units; enzyme activity; enzymatic activity"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "unit for the enzyme unit U = umol/min.",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "nanomole per second per liter",
    "nmol/s/L",
    "(NMOL/S)/L",
    "amount of substance",
    60221367e10,
    [-3, -1, 0, 0, 0, 0, 0],
    "(nmol/s)/L",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "nmol/sec/L; nmol per s per L; nmol per sec per L; nanomoles per seconds per liter; litre; milli enzyme units per volume; enzyme activity; enzymatic activity"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "unit for the enzyme unit U = umol/min.",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    true,
    "nanosecond",
    "ns",
    "NS",
    "time",
    1e-9,
    [0, 1, 0, 0, 0, 0, 0],
    "ns",
    null,
    false,
    "T",
    null,
    1,
    false,
    false,
    0,
    [
      "nanoseconds",
    ],
    "LOINC",
    "Time",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "nanoenzyme unit per milliliter",
    "nU/mL",
    "NU/ML",
    "catalytic activity",
    100368945e5,
    [-3, -1, 0, 0, 0, 0, 0],
    "nU/mL",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "nU per mL; nanoenzyme units per milliliter; millilitre; enzymatic activity per volume; enzyme activity"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min); 1 fU = pmol/min",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "Ohm meter",
    "Ohm.m",
    "OHM.M",
    "electric resistance",
    1e3,
    [3, -1, 1, 0, 0, -2, 0],
    "Ω.m",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "electric resistivity; meters; metres".split('; '),
    "LOINC",
    "",
    "Clinical",
    "unit of electric resistivity",
    "V/A",
    "V/A",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "osmole per kilogram",
    "osm/kg",
    "OSM/KG",
    "amount of substance (dissolved particles)",
    60221367e13,
    [0, 0, -1, 0, 0, 0, 0],
    "osm/kg",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "osm per kg; osmoles per kilogram; osmols".split('; '),
    "LOINC",
    "Osmol",
    "Clinical",
    "",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "osmole per liter",
    "osm/L",
    "OSM/L",
    "amount of substance (dissolved particles)",
    6.0221366999999994e26,
    [-3, 0, 0, 0, 0, 0, 0],
    "osm/L",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "osm per L; osmoles per liter; litre; osmols".split('; '),
    "LOINC",
    "Osmol",
    "Clinical",
    "",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "picoampere",
    "pA",
    "PA",
    "electric current",
    1e-12,
    [0, -1, 0, 0, 0, 1, 0],
    "pA",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "picoamperes",
    ],
    "LOINC",
    "",
    "Clinical",
    "equal to 10^-12 amperes",
    "C/s",
    "C/S",
    "1",
    1,
    false,
  ),
  UcumUnit(
    true,
    "picogram",
    "pg",
    "PG",
    "mass",
    1e-12,
    [0, 0, 1, 0, 0, 0, 0],
    "pg",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    [
      "picograms",
    ],
    "LOINC",
    "Mass; EntMass",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "picogram per deciliter",
    "pg/dL",
    "PG/DL",
    "mass",
    9.999999999999999e-9,
    [-3, 0, 1, 0, 0, 0, 0],
    "pg/dL",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "pg per dL; picograms; decilitre".split('; '),
    "LOINC",
    "MCnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "picogram per liter",
    "pg/L",
    "PG/L",
    "mass",
    1e-9,
    [-3, 0, 1, 0, 0, 0, 0],
    "pg/L",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "pg per L; picograms; litre".split('; '),
    "LOINC",
    "MCnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "picogram per milligram",
    "pg/mg",
    "PG/MG",
    "mass",
    1e-9,
    [0, 0, 0, 0, 0, 0, 0],
    "pg/mg",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "pg per mg; picograms".split('; '),
    "LOINC",
    "MCnt",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "picogram per milliliter",
    "pg/mL",
    "PG/ML",
    "mass",
    1e-6,
    [-3, 0, 1, 0, 0, 0, 0],
    "pg/mL",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "pg per mL; picograms per milliliter; millilitre".split('; '),
    "LOINC",
    "MCnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "picogram per millimeter",
    "pg/mm",
    "PG/MM",
    "mass",
    1e-9,
    [-1, 0, 1, 0, 0, 0, 0],
    "pg/mm",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "pg per mm; picogram/millimeter; picogram/millimetre; picograms per millimeter; millimetre"
        .split('; '),
    "LOINC",
    "Lineic Mass",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "picokatal",
    "pkat",
    "PKAT",
    "catalytic activity",
    60221367e4,
    [0, -1, 0, 0, 0, 0, 0],
    "pkat",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "pkats; picokatals".split('; '),
    "LOINC",
    "CAct",
    "Clinical",
    "kat is a unit of catalytic activity with base units = mol/s. Rarely used because its units are too large to practically express catalytic activity. See enzyme unit [U] which is the standard unit for catalytic activity.",
    "mol/s",
    "MOL/S",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "picoliter",
    "pL",
    "PL",
    "volume",
    1e-15,
    [3, 0, 0, 0, 0, 0, 0],
    "pL",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "picoliters; picolitres".split('; '),
    "LOINC",
    "Vol",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    true,
    "picometer",
    "pm",
    "PM",
    "length",
    1e-12,
    [1, 0, 0, 0, 0, 0, 0],
    "pm",
    null,
    false,
    "L",
    null,
    1,
    false,
    false,
    0,
    "picometers; picometres".split('; '),
    "LOINC",
    "Len",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "picomole",
    "pmol",
    "PMOL",
    "amount of substance",
    60221367e4,
    [0, 0, 0, 0, 0, 0, 0],
    "pmol",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "picomoles; pmols".split('; '),
    "LOINC",
    "Sub",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "picomole per 24 hour",
    "pmol/(24.h)",
    "PMOL/HR",
    "amount of substance",
    6970065.625,
    [0, -1, 0, 0, 0, 0, 0],
    "pmol/h",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "pmol/24hrs; pmol/24 hrs; pmol per 24 hrs; 24hrs; days; dy; picomoles per 24 hours"
        .split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "picomole per day",
    "pmol/d",
    "PMOL/D",
    "amount of substance",
    6970065.625,
    [0, -1, 0, 0, 0, 0, 0],
    "pmol/d",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "pmol/dy; pmol per day; 24 hours; 24hrs; 24 hrs; picomoles".split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "picomole per deciliter",
    "pmol/dL",
    "PMOL/DL",
    "amount of substance",
    60221367e8,
    [-3, 0, 0, 0, 0, 0, 0],
    "pmol/dL",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "pmol per dL; picomoles per deciliter; decilitre".split('; '),
    "LOINC",
    "SCnc",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "picomole per gram",
    "pmol/g",
    "PMOL/G",
    "amount of substance",
    60221367e4,
    [0, 0, -1, 0, 0, 0, 0],
    "pmol/g",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "pmol per gm; picomoles per gram; picomole/gram".split('; '),
    "LOINC",
    "SCnt",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "picomole per hour per milliliter ",
    "pmol/h/mL",
    "(PMOL/HR)/ML",
    "amount of substance",
    167281575e6,
    [-3, -1, 0, 0, 0, 0, 0],
    "(pmol/h)/mL",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "pmol/hrs/mL; pmol per hrs per mL; picomoles per hour per milliliter; millilitre; micro enzyme units per volume; enzymatic activity; enzyme activity"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "unit for the enzyme unit U = umol/min. ",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "picomole per liter",
    "pmol/L",
    "PMOL/L",
    "amount of substance",
    60221367e7,
    [-3, 0, 0, 0, 0, 0, 0],
    "pmol/L",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "picomole/liter; pmol per L; picomoles; litre".split('; '),
    "LOINC",
    "SCnc",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "picomole per minute",
    "pmol/min",
    "PMOL/MIN",
    "amount of substance",
    10036894500,
    [0, -1, 0, 0, 0, 0, 0],
    "pmol/min",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "picomole/minute; pmol per min; picomoles per minute; micro enzyme units; enzymatic activity; enzyme activity"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "unit for the enzyme unit U = umol/min. pmol/min = uU (micro enzyme unit)",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "picomole per milliliter",
    "pmol/mL",
    "PMOL/ML",
    "amount of substance",
    60221367e10,
    [-3, 0, 0, 0, 0, 0, 0],
    "pmol/mL",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "picomole/milliliter; picomole/millilitre; pmol per mL; picomoles; millilitre; picomols; pmols"
        .split('; '),
    "LOINC",
    "SCnc",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "picomole per micromole",
    "pmol/umol",
    "PMOL/UMOL",
    "amount of substance",
    1e-6,
    [0, 0, 0, 0, 0, 0, 0],
    "pmol/μmol",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "pmol/mcgmol; picomole/micromole; pmol per umol; pmol per mcgmol; picomoles "
        .split('; '),
    "LOINC",
    "SRto",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    true,
    "picosecond",
    "ps",
    "PS",
    "time",
    1e-12,
    [0, 1, 0, 0, 0, 0, 0],
    "ps",
    null,
    false,
    "T",
    null,
    1,
    false,
    false,
    0,
    "picoseconds; psec".split('; '),
    "LOINC",
    "Time",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "picotesla",
    "pT",
    "PT",
    "magnetic flux density",
    1e-9,
    [0, -1, 1, 0, 0, -1, 0],
    "pT",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "picoteslas",
    ],
    "LOINC",
    "",
    "Clinical",
    "SI unit of magnetic field strength for magnetic field B",
    "Wb/m2",
    "WB/M2",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "enzyme unit per 12 hour",
    "U/(12.h)",
    "U/HR",
    "catalytic activity",
    232335520833.33334,
    [0, -2, 0, 0, 0, 0, 0],
    "U/h",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "U/12hrs; U/ 12hrs; U per 12 hrs; 12hrs; enzyme units per 12 hours; enzyme activity; enzymatic activity per time; umol per min per 12 hours; micromoles per minute per 12 hours; umol/min/12hr"
        .split('; '),
    "LOINC",
    "CRat",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min)",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "enzyme unit per 2 hour",
    "U/(2.h)",
    "U/HR",
    "catalytic activity",
    1394013125e3,
    [0, -2, 0, 0, 0, 0, 0],
    "U/h",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "U/2hrs; U/ 2hrs; U per 2 hrs; 2hrs; enzyme units per 2 hours; enzyme activity; enzymatic activity per time; umol per minute per 2 hours; micromoles per minute; umol/min/2hr; umol per min per 2hr"
        .split('; '),
    "LOINC",
    "CRat",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min)",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "enzyme unit per 24 hour",
    "U/(24.h)",
    "U/HR",
    "catalytic activity",
    116167760416.66667,
    [0, -2, 0, 0, 0, 0, 0],
    "U/h",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "U/24hrs; U/ 24hrs; U per 24 hrs; 24hrs; enzyme units per 24 hours; enzyme activity; enzymatic activity per time; micromoles per minute per 24 hours; umol/min/24hr; umol per min per 24hr"
        .split('; '),
    "LOINC",
    "CRat",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min)",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "enzyme unit per 10",
    "U/10",
    "U",
    "catalytic activity",
    100368945e7,
    [0, -1, 0, 0, 0, 0, 0],
    "U",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "enzyme unit/10; U per 10; enzyme units per 10; enzymatic activity; enzyme activity; micromoles per minute; umol/min/10"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min)",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "enzyme unit per 10 billion",
    "U/10*10",
    "U/(10*10)",
    "catalytic activity",
    1003689.45,
    [0, -1, 0, 0, 0, 0, 0],
    "U/(10<sup>10</sup>)",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "U per 10*10; enzyme units per 10*10; U per 10 billion; enzyme units; enzymatic activity; micromoles per minute per 10 billion; umol/min/10*10"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min)",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "enzyme unit per trillion",
    "U/10*12",
    "U/(10*12)",
    "catalytic activity",
    10036.8945,
    [0, -1, 0, 0, 0, 0, 0],
    "U/(10<sup>12</sup>)",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "enzyme unit/10*12; U per 10*12; enzyme units per 10*12; enzyme units per trillion; enzymatic activity; micromoles per minute per trillion; umol/min/10*12; umol per min per 10*12"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min)",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "enzyme unit per million",
    "U/10*6",
    "U/(10*6)",
    "catalytic activity",
    10036894500,
    [0, -1, 0, 0, 0, 0, 0],
    "U/(10<sup>6</sup>)",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "enzyme unit/10*6; U per 10*6; enzyme units per 10*6; enzyme units; enzymatic activity per volume; micromoles per minute per million; umol/min/10*6; umol per min per 10*6"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min)",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "enzyme unit per billion",
    "U/10*9",
    "U/(10*9)",
    "catalytic activity",
    10036894.5,
    [0, -1, 0, 0, 0, 0, 0],
    "U/(10<sup>9</sup>)",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "enzyme unit/10*9; U per 10*9; enzyme units per 10*9; enzymatic activity per volume; micromoles per minute per billion; umol/min/10*9; umol per min per 10*9"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min)",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "enzyme unit per day",
    "U/d",
    "U/D",
    "catalytic activity",
    116167760416.66667,
    [0, -2, 0, 0, 0, 0, 0],
    "U/d",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "U/dy; enzyme units per day; enzyme units; enzyme activity; enzymatic activity per time; micromoles per minute per day; umol/min/day; umol per min per day"
        .split('; '),
    "LOINC",
    "CRat",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min)",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "enzyme unit per deciliter",
    "U/dL",
    "U/DL",
    "catalytic activity",
    100368945e12,
    [-3, -1, 0, 0, 0, 0, 0],
    "U/dL",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "U per dL; enzyme units per deciliter; decilitre; micromoles per minute per deciliter; umol/min/dL; umol per min per dL"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min)",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "enzyme unit per gram",
    "U/g",
    "U/G",
    "catalytic activity",
    100368945e8,
    [0, -1, -1, 0, 0, 0, 0],
    "U/g",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "U/gm; U per gm; enzyme units per gram; micromoles per minute per gram; umol/min/g; umol per min per g"
        .split('; '),
    "LOINC",
    "CCnt",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min)",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "enzyme unit per hour",
    "U/h",
    "U/HR",
    "catalytic activity",
    278802625e4,
    [0, -2, 0, 0, 0, 0, 0],
    "U/h",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "U/hr; U per hr; enzyme units per hour; micromoles per minute per hour; umol/min/hr; umol per min per hr"
        .split('; '),
    "LOINC",
    "CRat",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min)",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "enzyme unit per liter",
    "U/L",
    "U/L",
    "catalytic activity",
    100368945e11,
    [-3, -1, 0, 0, 0, 0, 0],
    "U/L",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "enzyme unit/liter; enzyme unit/litre; U per L; enzyme units per liter; enzyme unit per litre; micromoles per minute per liter; umol/min/L; umol per min per L"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min)",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "enzyme unit per minute",
    "U/min",
    "U/MIN",
    "catalytic activity",
    167281575e6,
    [0, -2, 0, 0, 0, 0, 0],
    "U/min",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "enzyme unit/minute; U per min; enzyme units; umol/min/min; micromoles per minute per minute; micromoles per min per min; umol"
        .split('; '),
    "LOINC",
    "CRat",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min)",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "enzyme unit per milliliter",
    "U/mL",
    "U/ML",
    "catalytic activity",
    1.00368945e22,
    [-3, -1, 0, 0, 0, 0, 0],
    "U/mL",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "U per mL; enzyme units per milliliter; millilitre; micromoles per minute per milliliter; umol/min/mL; umol per min per mL"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min)",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "enzyme unit per second",
    "U/s",
    "U/S",
    "catalytic activity",
    100368945e8,
    [0, -2, 0, 0, 0, 0, 0],
    "U/s",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "U/sec; U per second; enzyme units per second; micromoles per minute per second; umol/min/sec; umol per min per sec"
        .split('; '),
    "LOINC",
    "CRat",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min)",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "micro international unit",
    "u[IU]",
    "U[IU]",
    "arbitrary",
    1e-6,
    [0, 0, 0, 0, 0, 0, 0],
    "μi.U.",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    true,
    0,
    "uIU; u IU; microinternational units".split('; '),
    "LOINC",
    "Arb",
    "Clinical",
    "International units (IU) are analyte and reference specimen  specific arbitrary units (held at WHO)",
    "[iU]",
    "[IU]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "micro international unit per liter",
    "u[IU]/L",
    "U[IU]/L",
    "arbitrary",
    0.001,
    [-3, 0, 0, 0, 0, 0, 0],
    "(μi.U.)/L",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    true,
    0,
    "uIU/L; u IU/L; uIU per L; microinternational units per liter; litre; "
        .split('; '),
    "LOINC",
    "ACnc",
    "Clinical",
    "International units (IU) are analyte and reference specimen  specific arbitrary units (held at WHO)",
    "[iU]",
    "[IU]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "micro international unit per milliliter",
    "u[IU]/mL",
    "U[IU]/ML",
    "arbitrary",
    1,
    [-3, 0, 0, 0, 0, 0, 0],
    "(μi.U.)/mL",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    true,
    0,
    "uIU/mL; u IU/mL; uIU per mL; microinternational units per milliliter; millilitre"
        .split('; '),
    "LOINC",
    "ACnc",
    "Clinical",
    "International units (IU) are analyte and reference specimen  specific arbitrary units (held at WHO)",
    "[iU]",
    "[IU]",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "microequivalent",
    "ueq",
    "UEQ",
    "amount of substance",
    60221367e10,
    [0, 0, 0, 0, 0, 0, 0],
    "μeq",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "microequivalents; 10^-6 equivalents; 10-6 equivalents".split('; '),
    "LOINC",
    "Sub",
    "Clinical",
    "",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "microequivalent per liter",
    "ueq/L",
    "UEQ/L",
    "amount of substance",
    60221367e13,
    [-3, 0, 0, 0, 0, 0, 0],
    "μeq/L",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "ueq per liter; litre; microequivalents".split('; '),
    "LOINC",
    "MCnc",
    "Clinical",
    "",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "microequivalent per milliliter",
    "ueq/mL",
    "UEQ/ML",
    "amount of substance",
    6.0221367000000003e23,
    [-3, 0, 0, 0, 0, 0, 0],
    "μeq/mL",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "ueq per milliliter; millilitre; microequivalents".split('; '),
    "LOINC",
    "MCnc",
    "Clinical",
    "",
    "mol",
    "MOL",
    "1",
    1,
    false,
  ),
  UcumUnit(
    true,
    "microgram",
    "ug",
    "UG",
    "mass",
    1e-6,
    [0, 0, 1, 0, 0, 0, 0],
    "μg",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mcg; micrograms; 10^-6 grams; 10-6 grams".split('; '),
    "LOINC",
    "Mass",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microgram per 100 gram",
    "ug/(100.g)",
    "UG/G",
    "mass",
    1e-8,
    [0, 0, 0, 0, 0, 0, 0],
    "μg/g",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ug/100gm; ug/100 gm; mcg; ug per 100g; 100 gm; mcg per 100g; micrograms per 100 grams"
        .split('; '),
    "LOINC",
    "MCnt",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microgram per 24 hour",
    "ug/(24.h)",
    "UG/HR",
    "mass",
    1.1574074074074074e-11,
    [0, -1, 1, 0, 0, 0, 0],
    "μg/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ug/24hrs; ug/24 hrs; mcg/24hrs; ug per 24hrs; mcg per 24hrs; 24 hrs; micrograms per 24 hours"
        .split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microgram per 8 hour",
    "ug/(8.h)",
    "UG/HR",
    "mass",
    3.472222222222222e-11,
    [0, -1, 1, 0, 0, 0, 0],
    "μg/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ug/8hrs; ug/8 hrs; mcg/8hrs; ug per 8hrs; mcg per 8hrs; 8 hrs; micrograms per 8 hours; shift"
        .split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microgram per square foot (international)",
    "ug/[sft_i]",
    "UG/[SFT_I]",
    "mass",
    10763910416709721e-21,
    [-2, 0, 1, 0, 0, 0, 0],
    "μg",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ug/sft; ug/ft2; ug/ft^2; ug/sq. ft; micrograms; sq. foot; foot squared"
        .split('; '),
    "LOINC",
    "ArMass",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microgram per day",
    "ug/d",
    "UG/D",
    "mass",
    1.1574074074074074e-11,
    [0, -1, 1, 0, 0, 0, 0],
    "μg/d",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ug/dy; mcg/dy; ug per day; mcg; micrograms per day".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microgram per deciliter",
    "ug/dL",
    "UG/DL",
    "mass",
    0.009999999999999998,
    [-3, 0, 1, 0, 0, 0, 0],
    "μg/dL",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ug per dL; mcg/dl; mcg per dl; micrograms per deciliter; decilitre"
        .split('; '),
    "LOINC",
    "MCnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microgram per gram",
    "ug/g",
    "UG/G",
    "mass",
    1e-6,
    [0, 0, 0, 0, 0, 0, 0],
    "μg/g",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ug per gm; mcg/gm; mcg per g; micrograms per gram".split('; '),
    "LOINC",
    "MCnt",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microgram per hour",
    "ug/h",
    "UG/HR",
    "mass",
    2.7777777777777777e-10,
    [0, -1, 1, 0, 0, 0, 0],
    "μg/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ug/hr; mcg/hr; mcg per hr; ug per hr; ug per hour; micrograms".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microgram per kilogram",
    "ug/kg",
    "UG/KG",
    "mass",
    9.999999999999999e-10,
    [0, 0, 0, 0, 0, 0, 0],
    "μg/kg",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ug per kg; mcg/kg; mcg per kg; micrograms per kilogram".split('; '),
    "LOINC",
    "MCnt",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microgram per kilogram per 8 hour",
    "ug/kg/(8.h)",
    "(UG/KG)/HR",
    "mass",
    3.472222222222222e-14,
    [0, -1, 0, 0, 0, 0, 0],
    "(μg/kg)/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ug/kg/8hrs; mcg/kg/8hrs; ug/kg/8 hrs; mcg/kg/8 hrs; ug per kg per 8hrs; 8 hrs; mcg per kg per 8hrs; micrograms per kilograms per 8 hours; shift"
        .split('; '),
    "LOINC",
    "",
    "Clinical",
    "unit used to measure mass dose rate per patient body mass",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microgram per kilogram per day",
    "ug/kg/d",
    "(UG/KG)/D",
    "mass",
    1.1574074074074072e-14,
    [0, -1, 0, 0, 0, 0, 0],
    "(μg/kg)/d",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ug/(kg.d); ug/kg/dy; mcg/kg/day; ug per kg per dy; 24 hours; 24hrs; mcg; kilograms; microgram per kilogram and day"
        .split('; '),
    "LOINC",
    "",
    "Clinical",
    "unit used to measure mass dose rate per patient body mass",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microgram per kilogram per hour",
    "ug/kg/h",
    "(UG/KG)/HR",
    "mass",
    2.7777777777777774e-13,
    [0, -1, 0, 0, 0, 0, 0],
    "(μg/kg)/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ug/(kg.h); ug/kg/hr; mcg/kg/hr; ug per kg per hr; mcg per kg per hr; kilograms"
        .split('; '),
    "LOINC",
    "",
    "Clinical",
    "unit used to measure mass dose rate per patient body mass",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microgram per kilogram per minute",
    "ug/kg/min",
    "(UG/KG)/MIN",
    "mass",
    1.6666666666666664e-11,
    [0, -1, 0, 0, 0, 0, 0],
    "(μg/kg)/min",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ug/kg/min; ug/kg/min; mcg/kg/min; ug per kg per min; mcg; micrograms per kilograms per minute "
        .split('; '),
    "LOINC",
    "",
    "Clinical",
    "unit used to measure mass dose rate per patient body mass",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microgram per liter",
    "ug/L",
    "UG/L",
    "mass",
    0.001,
    [-3, 0, 1, 0, 0, 0, 0],
    "μg/L",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "mcg/L; ug per L; mcg; micrograms per liter; litre ".split('; '),
    "LOINC",
    "MCnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microgram per liter per 24 hour",
    "ug/L/(24.h)",
    "(UG/L)/HR",
    "mass",
    1.1574074074074074e-8,
    [-3, -1, 1, 0, 0, 0, 0],
    "(μg/L)/h",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ug/L/24hrs; ug/L/24 hrs; mcg/L/24hrs; ug per L per 24hrs; 24 hrs; day; dy mcg; micrograms per liters per 24 hours; litres"
        .split('; '),
    "LOINC",
    "",
    "Clinical",
    "unit used to measure mass dose rate per patient body mass",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microgram per square meter",
    "ug/m2",
    "UG/M2",
    "mass",
    1e-6,
    [-2, 0, 1, 0, 0, 0, 0],
    "μg/(m<sup>2</sup>)",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ug/m^2; ug/sq. m; mcg/m2; mcg/m^2; mcg/sq. m; ug per m2; m^2; sq. meter; mcg; micrograms per square meter; meter squared; metre"
        .split('; '),
    "LOINC",
    "ArMass",
    "Clinical",
    "unit used to measure mass dose per patient body surface area",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microgram per cubic meter",
    "ug/m3",
    "UG/M3",
    "mass",
    1e-6,
    [-3, 0, 1, 0, 0, 0, 0],
    "μg/(m<sup>3</sup>)",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ug/m^3; ug/cu. m; mcg/m3; mcg/m^3; mcg/cu. m; ug per m3; ug per m^3; ug per cu. m; mcg; micrograms per cubic meter; meter cubed; metre"
        .split('; '),
    "LOINC",
    "MCnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microgram per milligram",
    "ug/mg",
    "UG/MG",
    "mass",
    0.001,
    [0, 0, 0, 0, 0, 0, 0],
    "μg/mg",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ug per mg; mcg/mg; mcg per mg; micromilligrams per milligram".split('; '),
    "LOINC",
    "MCnt",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microgram per minute",
    "ug/min",
    "UG/MIN",
    "mass",
    1.6666666666666667e-8,
    [0, -1, 1, 0, 0, 0, 0],
    "μg/min",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ug per min; mcg/min; mcg per min; microminutes per minute".split('; '),
    "LOINC",
    "MRat",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microgram per milliliter",
    "ug/mL",
    "UG/ML",
    "mass",
    1,
    [-3, 0, 1, 0, 0, 0, 0],
    "μg/mL",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ug per mL; mcg/mL; mcg per mL; micrograms per milliliter; millilitre"
        .split('; '),
    "LOINC",
    "MCnc",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microgram per millimole",
    "ug/mmol",
    "UG/MMOL",
    "mass",
    1.660540186674939e-27,
    [0, 0, 1, 0, 0, 0, 0],
    "μg/mmol",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    -1,
    "ug per mmol; mcg/mmol; mcg per mmol; micrograms per millimole".split('; '),
    "LOINC",
    "Ratio",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microgram per nanogram",
    "ug/ng",
    "UG/NG",
    "mass",
    999.9999999999999,
    [0, 0, 0, 0, 0, 0, 0],
    "μg/ng",
    null,
    false,
    "M",
    null,
    1,
    false,
    false,
    0,
    "ug per ng; mcg/ng; mcg per ng; micrograms per nanogram".split('; '),
    "LOINC",
    "MCnt",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "microkatal",
    "ukat",
    "UKAT",
    "catalytic activity",
    60221367e10,
    [0, -1, 0, 0, 0, 0, 0],
    "μkat",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "microkatals; ukats".split('; '),
    "LOINC",
    "CAct",
    "Clinical",
    "kat is a unit of catalytic activity with base units = mol/s. Rarely used because its units are too large to practically express catalytic activity. See enzyme unit [U] which is the standard unit for catalytic activity.",
    "mol/s",
    "MOL/S",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "microliter",
    "uL",
    "UL",
    "volume",
    1e-9,
    [3, 0, 0, 0, 0, 0, 0],
    "μL",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "microliters; microlitres; mcl".split('; '),
    "LOINC",
    "Vol",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "microliter per 2 hour",
    "uL/(2.h)",
    "UL/HR",
    "volume",
    1.388888888888889e-13,
    [3, -1, 0, 0, 0, 0, 0],
    "μL/h",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "uL/2hrs; uL/2 hrs; mcg/2hr; mcg per 2hr; uL per 2hr; uL per 2 hrs; microliters per 2 hours; microlitres "
        .split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "microliter per hour",
    "uL/h",
    "UL/HR",
    "volume",
    2.777777777777778e-13,
    [3, -1, 0, 0, 0, 0, 0],
    "μL/h",
    "iso1000",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "uL/hr; mcg/hr; mcg per hr; uL per hr; microliters per hour; microlitres"
        .split('; '),
    "LOINC",
    "VRat",
    "Clinical",
    "",
    "l",
    null,
    "1",
    1,
    false,
  ),
  UcumUnit(
    true,
    "micrometer",
    "um",
    "UM",
    "length",
    1e-6,
    [1, 0, 0, 0, 0, 0, 0],
    "μm",
    null,
    false,
    "L",
    null,
    1,
    false,
    false,
    0,
    "micrometers; micrometres; μm; microns".split('; '),
    "LOINC",
    "Len",
    "Clinical",
    "Unit of length that is usually used in tests related to the eye",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    true,
    "microns per second",
    "um/s",
    "UM/S",
    "length",
    1e-6,
    [1, -1, 0, 0, 0, 0, 0],
    "μm/s",
    null,
    false,
    "L",
    null,
    1,
    false,
    false,
    0,
    "um/sec; micron/second; microns/second; um per sec; micrometers per second; micrometres"
        .split('; '),
    "LOINC",
    "Vel",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "micromole",
    "umol",
    "UMOL",
    "amount of substance",
    60221367e10,
    [0, 0, 0, 0, 0, 0, 0],
    "μmol",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "micromoles; umols".split('; '),
    "LOINC",
    "Sub",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "micromole per 2 hour",
    "umol/(2.h)",
    "UMOL/HR",
    "amount of substance",
    836407875e5,
    [0, -1, 0, 0, 0, 0, 0],
    "μmol/h",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "umol/2hrs; umol/2 hrs; umol per 2 hrs; 2hrs; micromoles per 2 hours"
        .split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "micromole per 24 hour",
    "umol/(24.h)",
    "UMOL/HR",
    "amount of substance",
    6970065625e3,
    [0, -1, 0, 0, 0, 0, 0],
    "μmol/h",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "umol/24hrs; umol/24 hrs; umol per 24 hrs; per 24hrs; micromoles per 24 hours"
        .split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "micromole per 8 hour",
    "umol/(8.h)",
    "UMOL/HR",
    "amount of substance",
    20910196875e3,
    [0, -1, 0, 0, 0, 0, 0],
    "μmol/h",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "umol/8hr; umol/8 hr; umol per 8 hr; umol per 8hr; umols per 8hr; umol per 8 hours; micromoles per 8 hours; shift"
        .split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "micromole per day",
    "umol/d",
    "UMOL/D",
    "amount of substance",
    6970065625e3,
    [0, -1, 0, 0, 0, 0, 0],
    "μmol/d",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "umol/day; umol per day; umols per day; umol per days; micromoles per days; umol/24hr; umol/24 hr; umol per 24 hr; umol per 24hr; umols per 24hr; umol per 24 hours; micromoles per 24 hours"
        .split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "micromole per deciliter",
    "umol/dL",
    "UMOL/DL",
    "amount of substance",
    6.0221367e21,
    [-3, 0, 0, 0, 0, 0, 0],
    "μmol/dL",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "micromole/deciliter; micromole/decilitre; umol per dL; micromoles per deciliters; micromole per decilitres"
        .split('; '),
    "LOINC",
    "SCnc",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "micromole per gram",
    "umol/g",
    "UMOL/G",
    "amount of substance",
    60221367e10,
    [0, 0, -1, 0, 0, 0, 0],
    "μmol/g",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "micromole/gram; umol per g; micromoles per gram".split('; '),
    "LOINC",
    "SCnt; Ratio",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "micromole per hour",
    "umol/h",
    "UMOL/HR",
    "amount of substance",
    167281575e6,
    [0, -1, 0, 0, 0, 0, 0],
    "μmol/h",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "umol/hr; umol per hr; umol per hour; micromoles per hours".split('; '),
    "LOINC",
    "SRat",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "micromole per kilogram",
    "umol/kg",
    "UMOL/KG",
    "amount of substance",
    60221367e7,
    [0, 0, -1, 0, 0, 0, 0],
    "μmol/kg",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "umol per kg; micromoles per kilogram".split('; '),
    "LOINC",
    "SCnt",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "micromole per liter",
    "umol/L",
    "UMOL/L",
    "amount of substance",
    60221367e13,
    [-3, 0, 0, 0, 0, 0, 0],
    "μmol/L",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "micromole/liter; micromole/litre; umol per liter; micromoles per liter; litre"
        .split('; '),
    "LOINC",
    "SCnc",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "micromole per liter per hour",
    "umol/L/h",
    "(UMOL/L)/HR",
    "amount of substance",
    167281575e9,
    [-3, -1, 0, 0, 0, 0, 0],
    "(μmol/L)/h",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "umol/liter/hr; umol/litre/hr; umol per L per hr; umol per liter per hour; micromoles per liters per hour; litre"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "unit for the enzyme unit U = umol/min; umol/L/h is a derived unit of enzyme units",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "micromole per milligram",
    "umol/mg",
    "UMOL/MG",
    "amount of substance",
    60221367e13,
    [0, 0, -1, 0, 0, 0, 0],
    "μmol/mg",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "micromole/milligram; umol per mg; micromoles per milligram".split('; '),
    "LOINC",
    "SCnt",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "micromole per minute",
    "umol/min",
    "UMOL/MIN",
    "amount of substance",
    100368945e8,
    [0, -1, 0, 0, 0, 0, 0],
    "μmol/min",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "micromole/minute; umol per min; micromoles per minute; enzyme units"
        .split('; '),
    "LOINC",
    "CAct",
    "Clinical",
    "unit for the enzyme unit U = umol/min",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "micromole per minute per gram",
    "umol/min/g",
    "(UMOL/MIN)/G",
    "amount of substance",
    100368945e8,
    [0, -1, -1, 0, 0, 0, 0],
    "(μmol/min)/g",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "umol/min/gm; umol per min per gm; micromoles per minutes per gram; U/g; enzyme units"
        .split('; '),
    "LOINC",
    "CCnt",
    "Clinical",
    "unit for the enzyme unit U = umol/min. umol/min/g = U/g",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "micromole per minute per liter",
    "umol/min/L",
    "(UMOL/MIN)/L",
    "amount of substance",
    100368945e11,
    [-3, -1, 0, 0, 0, 0, 0],
    "(μmol/min)/L",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "umol/min/liter; umol/minute/liter; micromoles per minutes per liter; litre; enzyme units; U/L"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "unit for the enzyme unit U = umol/min. umol/min/L = U/L",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "micromole per milliliter",
    "umol/mL",
    "UMOL/ML",
    "amount of substance",
    6.0221367000000003e23,
    [-3, 0, 0, 0, 0, 0, 0],
    "μmol/mL",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "umol per mL; micromoles per milliliter; millilitre".split('; '),
    "LOINC",
    "SCnc",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "micromole per milliliter per minute",
    "umol/mL/min",
    "(UMOL/ML)/MIN",
    "amount of substance",
    1.00368945e22,
    [-3, -1, 0, 0, 0, 0, 0],
    "(μmol/mL)/min",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "umol per mL per min; micromoles per milliliters per minute; millilitres"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "unit for the enzyme unit U = umol/min. umol/mL/min = U/mL",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "micromole per millimole",
    "umol/mmol",
    "UMOL/MMOL",
    "amount of substance",
    0.001,
    [0, 0, 0, 0, 0, 0, 0],
    "μmol/mmol",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "umol per mmol; micromoles per millimole".split('; '),
    "LOINC",
    "SRto",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "micromole per mole",
    "umol/mol",
    "UMOL/MOL",
    "amount of substance",
    1e-6,
    [0, 0, 0, 0, 0, 0, 0],
    "μmol/mol",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "umol per mol; micromoles per mole".split('; '),
    "LOINC",
    "SRto",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "micromole per micromole",
    "umol/umol",
    "UMOL/UMOL",
    "amount of substance",
    1,
    [0, 0, 0, 0, 0, 0, 0],
    "μmol/μmol",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "umol per umol; micromoles per micromole".split('; '),
    "LOINC",
    "Srto; SFr; EntSRto",
    "Clinical",
    "",
    "10*23",
    "10*23",
    "6.0221367",
    6.0221367,
    false,
  ),
  UcumUnit(
    false,
    "microOhm",
    "uOhm",
    "UOHM",
    "electric resistance",
    0.001,
    [2, -1, 1, 0, 0, -2, 0],
    "μΩ",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    "microOhms; µΩ".split('; '),
    "LOINC",
    "",
    "Clinical",
    "unit of electric resistance",
    "V/A",
    "V/A",
    "1",
    1,
    false,
  ),
  UcumUnit(
    true,
    "microsecond",
    "us",
    "US",
    "time",
    1e-6,
    [0, 1, 0, 0, 0, 0, 0],
    "μs",
    null,
    false,
    "T",
    null,
    1,
    false,
    false,
    0,
    [
      "microseconds",
    ],
    "LOINC",
    "Time",
    "Clinical",
    "",
    null,
    null,
    null,
    null,
    false,
  ),
  UcumUnit(
    false,
    "micro enzyme unit per gram",
    "uU/g",
    "UU/G",
    "catalytic activity",
    10036894500,
    [0, -1, -1, 0, 0, 0, 0],
    "μU/g",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "uU per gm; micro enzyme units per gram; micro enzymatic activity per mass; enzyme activity"
        .split('; '),
    "LOINC",
    "CCnt",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min); 1 uU = 1pmol/min",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "micro enzyme unit per liter",
    "uU/L",
    "UU/L",
    "catalytic activity",
    100368945e5,
    [-3, -1, 0, 0, 0, 0, 0],
    "μU/L",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "uU per L; micro enzyme units per liter; litre; enzymatic activity per volume; enzyme activity "
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min); 1 uU = 1pmol/min",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "micro enzyme unit per milliliter",
    "uU/mL",
    "UU/ML",
    "catalytic activity",
    100368945e8,
    [-3, -1, 0, 0, 0, 0, 0],
    "μU/mL",
    "chemical",
    true,
    null,
    null,
    1,
    false,
    false,
    1,
    "uU per mL; micro enzyme units per milliliter; millilitre; enzymatic activity per volume; enzyme activity"
        .split('; '),
    "LOINC",
    "CCnc",
    "Clinical",
    "1 U is the standard enzyme unit which equals 1 micromole substrate catalyzed per minute (1 umol/min); 1 uU = 1pmol/min",
    "umol/min",
    "UMOL/MIN",
    "1",
    1,
    false,
  ),
  UcumUnit(
    false,
    "microvolt",
    "uV",
    "UV",
    "electric potential",
    0.001,
    [2, -2, 1, 0, 0, -1, 0],
    "μV",
    "si",
    true,
    null,
    null,
    1,
    false,
    false,
    0,
    [
      "microvolts",
    ],
    "LOINC",
    "Elpot",
    "Clinical",
    "unit of electric potential (voltage)",
    "J/C",
    "J/C",
    "1",
    1,
    false,
  ),
];
